#include "constants.h"
#include "ChatView.h"
#include <Window.h>
#include <ScrollView.h>
#include <Menu.h>
#include <MenuItem.h>
#include <PopUpMenu.h>
#include <Entry.h>
#include <Directory.h>
#include <File.h>
#include <Path.h>
#include <Application.h>



#include "ChatWindow.h"
#include "newButton.h"

#include "irc_view.h"
#include "newItem.h"
#include "Utils.h"

#include "textFilter.h"
#include "myText.h"
#include "tips.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static const char sc_users_list[] = "users_list";
static const char sc_scroll_list[] = "sw_users_list";

ChatView::ChatView(BRect rc, const char *sz_chat_name)
	: BView(rc, "ChatView", B_FOLLOW_ALL, B_WILL_DRAW /*| B_NAVIGABLE_JUMP*/| B_FRAME_EVENTS)
{
	m_file = NULL;
	m_chat_name = sz_chat_name;
   	rc = Bounds();
  	rc.top++;
  	rc.top += B_H_SCROLL_BAR_HEIGHT + 1;
  	rc.right -= 120;
   	IRCView *pIrc = new IRCView(rc);
  	AddChild(pIrc);

  	rc.top += B_H_SCROLL_BAR_HEIGHT;
  	rc.left = rc.right + 6;
  	rc.right = Bounds().right - B_V_SCROLL_BAR_WIDTH;
  	rc.bottom -= B_H_SCROLL_BAR_HEIGHT;
  	//BListView* lv = new BListView (rc, sc_users_list, B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL );
  	BListView* lv = (BListView*) new newListView(rc, sc_users_list, B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL );
  	//lv->SetSelectionMessage(new BMessage('isel'));
  	lv->SetViewColor(sc_viewcolor);
	lv->SetHighColor(sc_highcolor);
	lv->SetLowColor(sc_lowcolor);
	
  	BScrollView *sv = new BScrollView(sc_scroll_list, lv, 
            B_FOLLOW_RIGHT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW, false, true, B_NO_BORDER);
  	
  	AddChild(sv);
  	
  	rc.top = rc.bottom;
  	rc.bottom += B_H_SCROLL_BAR_HEIGHT - 1;
  	rc.right += B_V_SCROLL_BAR_WIDTH - 0;
  	rc.OffsetBy( 0, 1 );
  	ChatInfoView *ci = new ChatInfoView( rc );
  	AddChild( ci );
  
 	rc.top = B_H_SCROLL_BAR_HEIGHT + 2;
 	rc.bottom = rc.top + B_H_SCROLL_BAR_HEIGHT - 1;
 	ChatModeView *cm = new ChatModeView( rc, m_chat_name );
 	AddChild( cm );
 	 	
  	textFilter* filter = new textFilter(false);
  	rc = Bounds();
  	//rc.top--;
  	rc.bottom = rc.top + B_H_SCROLL_BAR_HEIGHT;
  	rc.left += 45;
  	rc.right -= 25;
  	m_topicV = (BTextControl*)new myText(filter, rc, "_n_topic_edit", NULL , NULL, new BMessage('tpc'), B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP);
  	BTextView* tv = m_topicV->TextView();	
  	((myText*)m_topicV)->set_draw(false);
  	m_topicV->ResizeTo(rc.Width(), rc.Height());
  	tv->MoveTo(0, 1);
  	tv->ResizeBy(8, 0);
  	tv->SetFont(be_plain_font);
  	//m_topicV->MoveBy(0, 0);
  	// m_topicV->SetEnabled(false);
	
	rc.bottom = rc.top + B_H_SCROLL_BAR_HEIGHT;
  	
  	rc.left = rc.right + 1;
 	rc.right = rc.left + 12;
	//rc.InsetBy(0, 2);
	BMessage *btn_msg = new BMessage('tstm');
	btn_msg->AddString( STR_TTIPS, "Time Stamp");
	
	newButton *btn = new newButton( rc, "_tstm_", "t", btn_msg, 1);
	btn->SetResizingMode(B_FOLLOW_RIGHT | B_FOLLOW_TOP );
	btn->SetFont(be_plain_font);
	btn->SetFontSize( 12 );
	AddChild( btn );
	
	rc.OffsetBy( 13, 0);
	btn_msg = new BMessage('slog');
	btn_msg->AddString( STR_TTIPS, "Session Log OFF");
	btn = new newButton( rc, "_log_", "l", btn_msg, 1);
	btn->SetResizingMode(B_FOLLOW_RIGHT | B_FOLLOW_TOP );
	btn->SetFont(be_plain_font);
	btn->SetFontSize( 12 );
	
	AddChild( btn );

}
ChatView::~ChatView()
{
	//RemoveAll();
	delete m_file;
}

void ChatView::AttachedToWindow(void)
{	
	BView::AttachedToWindow();
	SETUP_VIEW_COLORS;
	AddChild(m_topicV);
	//ptr->SetTarget(this);	
	BTextView* tv = m_topicV->TextView();
	m_topicV->SetViewColor(192, 192, 192);
	tv->SetViewColor(192, 192, 192);

	ChatModeView* cm = (ChatModeView*)FindView("vChatMode");
	cm->SetEnable( false );
	
	BButton *btn = (BButton*)FindView( "_tstm_" );
	btn->SetTarget( this );
	btn = (BButton*)FindView( "_log_" );
	btn->SetTarget( this );
}
void ChatView::DetachedFromWindow(void) 
{
	RemoveAll();
}
void ChatView::FrameResized(float width, float height)
{
	BView* ptr = FindView("IRCView");
	BRect rc( ptr->Frame().RightTop(), BPoint(ptr->Frame().RightBottom()) );
	rc.right += 6;
	Invalidate(rc);
}

void ChatView::SetTopic(char *topic)
{
 m_topicV->SetText(topic);
}
void ChatView::AddItem(const char *str)
{
	if( HasItem(str) )
	{
		if( str[0] == '@' )
			SetOP( str, 1);
		else
			if( str[0] == '+' )
				SetOP( str, 2);
			else
				SetOP( str, 0);
		return;
	}	
	
	BWindow *w = Window();
	if(w) w->Lock();
	BListView* ptr = (BListView*)FindView(sc_users_list);
	ptr->AddItem( new nickitem( str ));
	
	/*ChatWindow* cw = (ChatWindow*)Window();
	const char *nick_ptr= cw->get_nick();
	if( nick_ptr && strcasecmp( nick_ptr, str) == 0 )
	{
		nickitem *item = FaindItem( nick_ptr );
		if( item )
		{
			ChatModeView* cm = (ChatModeView*)FindView("vChatMode");
			if( item->get_type() == 1 )
			{	
				enable_topic( true );
			}
			else
			{	
				if( cm->is_t() )
					enable_topic( false );
				else	
					enable_topic( true );
			}	
		}
	}		
	*/
	if(w)w->Unlock();
	update_chatinfo();
}
void ChatView::update_chatinfo(void)
{
	BListView* ptr = (BListView*)FindView(sc_users_list);
	int32 count = ptr->CountItems();
	int count_ops = 0;	
	for( int32 i = 0; i < count; i++)
	{
		nickitem * item = (nickitem*)ptr->ItemAt( i );
		if( item->get_type() == 1 )
			count_ops++;
	}
	ChatInfoView* vptr = (ChatInfoView*)FindView("vChatInfo");
	char sz[128 ];
	sprintf( sz, "%i ops, %i total", count_ops, (int)count);
	vptr->SetString( sz );
}
bool ChatView::RenameItem(const char *str, const char*str2)
{
	nickitem *item = FaindItem(str);
	if(item == NULL)
		return false;
	BWindow *w = Window();
	if(w) w->Lock();
	BListView* ptr = (BListView*)FindView(sc_users_list);
	item->rename(str2);
	ptr->InvalidateItem( ptr->IndexOf(item) );
	if(w)w->Unlock();

	update_chatinfo();

	return true;
}
void ChatView::RemoveAll(void)
{
	BWindow *w = Window();
	if(w) w->Lock();
	BListView* ptr = (BListView*)FindView(sc_users_list);
	int32 count = ptr->CountItems();
	for( int32 i = 0; i < count; i++)
		delete ptr->RemoveItem( (int32)0 );
	ptr->MakeEmpty();
	if(w)w->Unlock();
	update_chatinfo();	
}
bool ChatView::HasItem(const char* str)
{
	return ( FaindItem(str) != NULL);
}
nickitem* ChatView::FaindItem(const char *str)
{
  	BWindow *w = Window();
	if(w) w->Lock();
	
	nickitem* ret = NULL;
	
  	BListView* lv = (BListView*)FindView(sc_users_list);
  	int32 count = lv->CountItems();
   
	for( int32 i = 0; i < count; i++)
	{ 
		nickitem* ptr = (nickitem*)lv->ItemAt( i );
		const char *name = ptr->get_name();
		if ( !name)
			continue;
		if(str[0] == '@')
			str++;	
		if(str[0] == '+')
			str++;	
			
		if(strcmp(name, str) == 0)
		{
			ret =  ptr;
			break;
		}     	
	}	
	if(w)w->Unlock();
	return ret;
}

bool ChatView::RemoveItem(const char *str)
{  
  	nickitem* item = FaindItem(str);
	if( !item)
		return false;
		
  	BWindow *w = Window();
	if(w) w->Lock();
	
	BListView* lv = (BListView*)FindView(sc_users_list);
  	lv->RemoveItem( item );
	if(w)w->Unlock();
	update_chatinfo();
	return true;
}

void ChatView::SetOP(const char *str, bool op)
{

  	nickitem* item = FaindItem( str );
  	if(!item)
  		return;
  	BWindow *w = Window();
	if(w) w->Lock();
	item->set_type( op );
	BListView* ptr = (BListView*)FindView(sc_users_list);
	ptr->InvalidateItem( ptr->IndexOf(item) );
	
	ChatWindow* cw = (ChatWindow*)Window();
	const char *nick_ptr= cw->get_nick();
	if( nick_ptr )
	{
		item = FaindItem( nick_ptr );
		if( item )
		{
			ChatModeView* cm = (ChatModeView*)FindView("vChatMode");
			cm->SetEnable( item->get_type() == 1 );
		}
		check_topic();	
	}		
	if(w)w->Unlock();
	
	update_chatinfo();
}
void ChatView::sort_items(void)
{
	BListView* ptr = (BListView*)FindView(sc_users_list);
	ptr->SortItems( nick_cmp );	
}
void ChatView::check_topic( void )
{
	bool b = false;
	const char *nick_ptr= NULL;
	ChatWindow* cw = NULL;
	cw = static_cast<ChatWindow*>( Window() );
	if( cw )
		nick_ptr= cw->get_nick();
	if( nick_ptr )
	{
		nickitem *item = FaindItem( nick_ptr );
		if( item )
		{
			ChatModeView* cm = (ChatModeView*)FindView("vChatMode");
						
			if( item->get_type() == 1 )
				b = true;
			else	
			{				
				if( cm->is_t() )
					b = false;
				else
					b = true;	
			}
		}	
	}				
	BTextView *tv = m_topicV->TextView();
	tv->MakeEditable( b );
	BRect rc = Bounds();
	rc. bottom = rc.top + B_H_SCROLL_BAR_HEIGHT;
	rc.right = rc.top + 45;
	Invalidate(rc);			
}

void ChatView::Draw(BRect updateRect)
{
	BView* ptr = FindView("IRCView");
	BRect rc( ptr->Frame().RightTop(), BPoint(ptr->Frame().RightBottom()) );
	rc.right += 6;
	SetHighColor(sc_viewcolor);
	FillRect(rc);//, B_SOLID_LOW);
	
	SetHighColor(sc_highcolor);
	rc.InsetBy(1,  0); 
	draw_3Drect(this, rc, false);
	rc = Bounds();
	rc.bottom = rc.top + B_H_SCROLL_BAR_HEIGHT + 1;
	rc.InsetBy(-1, 0);
	rc.top--;
	SetHighColor (192, 192, 192);
	FillRect(rc);
	draw_3Drect(this, rc, false);
	
	SetFont(be_bold_font);
	font_height height;
	GetFontHeight(&height);
	MovePenTo( 6 , rc.top +  height.ascent + height.leading + 2);
static const char stopic[] = "Topic :";
	rgb_color color = HighColor();
	bool b = m_topicV->TextView()->IsEditable();
	SetHighColor( (b ? 128 : 0), 0, 0 );
	DrawString( stopic );
	SetHighColor(color);
	SetFont(be_plain_font);
}
void ChatView::MouseDown(BPoint point)
{
	BView* ptr = FindView("IRCView");
	BView* ptr2 = FindView( sc_scroll_list );
	BView* ptr3 = FindView( "vChatInfo" );
	BView* ptr4 = FindView( "vChatMode" );
	BRect rc_left = ptr->Frame();
	BRect rect(rc_left.RightTop(), rc_left.RightBottom() ); 
	rect.right += 6;
	//rect.OffsetBy(1, 0);
	
	float startx = point.x;
	
	unsigned long buttons; 
	
	if( rect.Contains(point) )
	{
		BRect rc_border = Bounds();
		do
		{ 
			snooze(80 * 1000); 
			GetMouse(&point, &buttons);
			if( point.x < rc_border.left )
				point.x = rc_border.left;
			 if( point.x > rc_border.right )
			 	point.x = rc_border.right;
			if(point.x != rc_left.right)
			{
				rc_left.right = point.x;
				ptr->ResizeBy(point.x - startx, 0);//rc_left.Height());
				ptr2->ResizeBy(startx - point.x  , 0);
				ptr3->ResizeBy(startx - point.x  , 0);
				ptr4->ResizeBy(startx - point.x  , 0);
				ptr2->MoveBy(point.x - startx, 0);
				ptr3->MoveBy(point.x - startx, 0);
				ptr4->MoveBy(point.x - startx, 0);
				rect.OffsetBy(point.x - startx, 0); 
				Invalidate(rect);
				//Window()->UpdateIfNeeded();
				startx = point.x;							
			}
			
	 	}
	 	while ( buttons );	 	
	}			
	// remove same extra messages
	BMessageQueue *mq = Window()->MessageQueue();
	mq->Lock();
	while( mq->CountMessages() > 14 )
	{
		BMessage *msg = mq->NextMessage();
		if( !msg )
			break;
		delete msg;		
	}		
	mq->Unlock();

	Window()->UpdateIfNeeded();
}
#include <String.h>
void ChatView::make_ctcp_menu(BPopUpMenu* popup, const char* name)
{
	const static char ctcp_cmd[][16] = { "PING", "USERINFO", "VERSION", "TIME", "FINGER", "SOURCE", "CLIENTINFO" };
	char sz_msg[128];
	int count = sizeof(ctcp_cmd)/sizeof(ctcp_cmd[0]);
	BMessage* item_msg;
	BMenuItem *item;
	BMenu* ctcp_popup = new BMenu("CTCP");
	ctcp_popup->SetFont(be_plain_font);
	
	for( int i = 0; i < count; i++)
	{
		item_msg = new BMessage('itm');
		BString bstr(ctcp_cmd[i]);
		bstr.ToLower();
		bstr.CapitalizeEachWord();
		sprintf(sz_msg, "/CTCP %s %s", ctcp_cmd[i], name);
		item_msg->AddString("cmd", sz_msg);
		item = new BMenuItem( bstr.String(), item_msg);
		item->SetTrigger('\0');
		ctcp_popup->AddItem(item);
	}  
	ctcp_popup->SetTargetForItems(Window());
	popup->AddItem(ctcp_popup);
	
	ctcp_popup = new BMenu("DCC");
	ctcp_popup->SetFont(be_plain_font);
	
	item_msg = new BMessage('itm');
	sprintf(sz_msg, "/DCC chat %s", name);
	item_msg->AddString("cmd", sz_msg);
	sprintf(sz_msg, "Chat whis %s", name);
	item = new BMenuItem( sz_msg, item_msg);
	item->SetTrigger('\0');
	ctcp_popup->AddItem(item);
	
	item_msg = new BMessage('itm');
	sprintf(sz_msg, "/DCC send %s $file", name);
	item_msg->AddString("cmd", sz_msg);
	sprintf(sz_msg, "Send file ...");
	item = new BMenuItem( sz_msg, item_msg);
	item->SetTrigger('\0');
	ctcp_popup->AddItem(item);
	
	ctcp_popup->SetTargetForItems(Window());
	popup->AddItem(ctcp_popup);	
}


void ChatView::open_log(bool b)
{
	IRCView* pirc_v = (IRCView*)FindView("IRCView");
	BButton *btn = (BButton*)FindView("_log_");
	
	if( !b )
	{			
		btn->Message()->ReplaceString( STR_TTIPS, "Session Log OFF");		
		pirc_v->m_log_file = NULL;
		if( m_file )
		{
			m_file->Unset();
			delete m_file;
		}	
		m_file = NULL;
		return;
	}	
	// get curdir
	app_info info;
	be_app->Lock();
	be_app->GetAppInfo(&info);
	be_app->Unlock();
	BEntry ent( &info.ref );
	BPath path;
	ent.GetPath( &path );
	path.GetParent( &path );

	BDirectory dir;
	dir.SetTo( path.Path() );
	if( dir.InitCheck() != B_OK )
		return;
	m_file = new	BFile();
	
	path.Append("logs");	
	dir.CreateDirectory("logs", &dir);
	
	dir.SetTo( path.Path() );
	
	ChatWindow *w = (ChatWindow*)Window();
	if( w->m_network_name )
	{
		path.Append( w->m_network_name );	
		dir.CreateDirectory( w->m_network_name, &dir);
	}	
	char sz_file_name[256] = "~";
	if( w->get_name() )
		strcpy(sz_file_name, w->get_name() );
	
	time_t clock;
	time(&clock);	
	tm *time_on = localtime(&clock);
	sprintf( sz_file_name, "%s[%02d-%02d-%d]", sz_file_name, time_on->tm_mday, time_on->tm_mon+1, 1900 + time_on->tm_year);
	path.Append( sz_file_name );	
	m_file->SetTo(path.Path(),  B_WRITE_ONLY | B_OPEN_AT_END | B_CREATE_FILE);
		
	
	if(m_file->InitCheck() != B_OK)
	{
		delete m_file;
		m_file = NULL;
		return;	
	}	
	sprintf( sz_file_name, "// %s", asctime(time_on));
	m_file->Write( sz_file_name, strlen(sz_file_name) );
	pirc_v->m_log_file = m_file;
	
	btn->Message()->ReplaceString( STR_TTIPS, "Session Log ON");		

	return;	
}
#include <Beep.h>
void ChatView::MessageReceived(BMessage* message)
{
  switch (message->what)
  {
	case 'slog':
	{
		newButton *btn = (newButton*)FindView("_log_");
		btn->Check( !btn->IsCheck() );
		open_log( btn->IsCheck() );
	}
	break;
	case 'tstm':
	{
		newButton *btn = (newButton*)FindView("_tstm_");
		IRCView* pirc_v = (IRCView*)FindView("IRCView");
		btn->Check( !btn->IsCheck() );
		pirc_v->m_is_time_stamp = btn->IsCheck();			
	}
	break;
	case 'mdn':
	{
		BListView* ptr = (BListView*)FindView(sc_users_list);//"users_list");	
		if(!ptr)
			break;
		int32 selected = ptr->CurrentSelection();
		if(selected < 0)
			break;
			
		nickitem* nickptr = (nickitem*)ptr->ItemAt( selected );
		const char *name = nickptr->get_name();
		BRect rc =  ptr->ItemFrame(selected);
		BPopUpMenu* popup = new BPopUpMenu("user_menu", false);//, false );
		popup->SetFont(be_plain_font);
		BMessage *item_msg = new BMessage('prv');
		item_msg->AddString( "user_name", name);
		char sz_item_name[128];
		sprintf(sz_item_name, "Private chat whith %s", name);
		BMenuItem *item = new BMenuItem( sz_item_name, item_msg);
		popup->AddItem(item);
		ChatWindow *cw = (ChatWindow*)Window();
		nickitem* my_nickitem = FaindItem( cw->get_nick() );
		if( my_nickitem->get_type() == 1 )
		{
			popup->AddSeparatorItem();
			item_msg = new BMessage('itm');
			switch( nickptr->get_type() )
			{
				case 0:
					sprintf(sz_item_name, "/OP %s %s", m_chat_name, name );
					item_msg->AddString( "cmd", sz_item_name);
					sprintf(sz_item_name, "Op %s", name);
					break;
				case 1:
					sprintf(sz_item_name, "/DEOP %s %s", m_chat_name, name );
					item_msg->AddString( "cmd", sz_item_name);
					sprintf(sz_item_name, "DeOp %s", name);
					break;				
			}
			item = new BMenuItem( sz_item_name, item_msg);
			popup->AddItem(item);
		}		
				
		
		popup->AddSeparatorItem();
		
		item_msg = new BMessage('itm');
		sprintf(sz_item_name, "/WHO %s", name);
		item_msg->AddString("cmd", sz_item_name);
		sprintf(sz_item_name, "Who %s", name);		
		item = new BMenuItem( sz_item_name, item_msg);
		popup->AddItem(item);
		
		item_msg = new BMessage('itm');
		sprintf(sz_item_name, "/WHOIS %s", name);
		item_msg->AddString("cmd", sz_item_name);
		sprintf(sz_item_name, "WhoIs %s", name);		
		item = new BMenuItem( sz_item_name, item_msg);
		popup->AddItem(item);
		popup->AddSeparatorItem();
		
		item_msg = new BMessage('itm');
		sprintf(sz_item_name, "/USERHOST %s", name);
		item_msg->AddString("cmd", sz_item_name);
		sprintf(sz_item_name, "UserHost %s", name);		
		item = new BMenuItem( sz_item_name, item_msg);
		popup->AddItem(item);
		popup->AddSeparatorItem();
	
	
		make_ctcp_menu(popup, name);
		ptr->ConvertToScreen(&rc);
		popup->SetTargetForItems(Window());
		popup->Go(rc.LeftBottom(), true, true, rc ); 
		delete popup;
	}
	break;
	default:    	
	break;
  }
	BView::MessageReceived(message);
}
/////////////////////   ChatInfoView
static const char chan_mode_name[ ][8] = 
{
	"t",
	"n",
	"s",
	"i",
	"p",
	"m",
	"o"
};

static const char chan_modeTT[ ][64] = 
{
	"Topic settable by channel operator only",
	"No message to channel",
	"Secret channel",
	"Invite-only channel",
	"Private channel",
	"Moderated Cannel",
	"Channel operators privileges"
};



ChatInfoView::ChatInfoView( BRect rc , uint32 resizeMode )
: BView( rc ,"vChatInfo", resizeMode, B_WILL_DRAW| B_FRAME_EVENTS)
{
	SetViewColor( 196, 196, 196 );
	SetHighColor( sc_highcolor );
	//SetViewColor( sc_viewcolor );
	m_str = NULL;
	m_sz_data = NULL;
	SetFontSize( 11.5 );
	SetDrawingMode( B_OP_OVER );
	BMessage *msg = new BMessage('emti');
	//msg->AddString( STR_TTIPS, "*" );
	SetMessage( msg );
}


ChatInfoView::~ChatInfoView()
{
	if( m_str)
		delete m_str;
	if( m_sz_data )	
		delete m_sz_data;
}

void ChatInfoView::SetString( const char *str )
{
	if( m_str)
		delete m_str;
	if( str )
		m_str = strdup( str );
	BRect rc = Bounds();
	rc.InsetBy(1,1);
	Invalidate( rc );	
	char sz[128];
	sprintf( sz,"%s %s", m_str, m_sz_data );
	BFont font;
	GetFont( &font );
	float width = font.StringWidth( sz ) + 4;
	BMessage *msg = Message();
	if( width > rc.Width() )
	{
		if( msg->HasString( STR_TTIPS ) )
			msg->ReplaceString( STR_TTIPS,  sz );	
		else
			msg->AddString( STR_TTIPS,  sz );	
	}
	else
	{
		msg->RemoveName( STR_TTIPS );	
	}	
}
void ChatInfoView::SetCreatedData( const char *str )
{
	if( m_sz_data )	
		delete m_sz_data;
	if( str )
		m_sz_data = strdup( str );
	BRect rc = Bounds();
	rc.InsetBy(1,1);
	Invalidate( rc );	
	char sz[128];
	sprintf( sz,"%s %s", m_str, m_sz_data );
	BFont font;
	GetFont( &font );
	float width = font.StringWidth( sz ) + 4;
	BMessage *msg = Message();
	if( width > rc.Width() )
	{
		if( msg->HasString( STR_TTIPS ) )
			msg->ReplaceString( STR_TTIPS,  sz );	
		else
			msg->AddString( STR_TTIPS,  sz );	
	}
	else
	{
		msg->RemoveName( STR_TTIPS );	
	}	
}
void ChatInfoView::FrameResized(float width, float height)
{
	BView::FrameResized( width, height);
	char sz[128];
	sprintf( sz,"%s %s", m_str, m_sz_data );
	BFont font;
	GetFont( &font );
	float str_width = font.StringWidth( sz ) + 4;
	BMessage *msg = Message();
	if( str_width > width )
	{
		if( msg->HasString( STR_TTIPS ) )
			msg->ReplaceString( STR_TTIPS,  sz );	
		else
			msg->AddString( STR_TTIPS,  sz );	
	}
	else
	{
		msg->RemoveName( STR_TTIPS );	
	}	

}
void ChatInfoView::Draw(BRect rc)
{
	rc = Bounds();
	font_height height;
	GetFontHeight(&height);	
	rgb_color hc = HighColor();
	SetHighColor( ViewColor() );
	//FillRect( rc );	
	SetHighColor( 0, 0, 0 ); 
 	MovePenTo( 4. , rc.top +  height.ascent + height.leading);
	if( m_str )
	{
		//drawing_mode dw = DrawingMode();
		//SetDrawingMode( B_OP_OVER );
		DrawString( m_str );
		//SetDrawingMode( dw );
	}
	if( m_sz_data )
	{
		DrawString( " , " );
		DrawString( m_sz_data );	
	}
	SetHighColor( hc );
	draw_3Drect( this, rc );
}

/////////////////////   ChatModeView
#include "newButton.h"

ChatModeView::ChatModeView( BRect rc, const char *chat_name )
: BView( rc ,"vChatMode",B_FOLLOW_RIGHT |
	B_FOLLOW_TOP, B_WILL_DRAW)
{
	m_chat_name = chat_name;
	//t = m = n = s = i = p = m = o = false;
	SetHighColor( sc_highcolor );
	SetViewColor( sc_viewcolor );
	//SetViewColor( 196, 196, 196 );
	SetFontSize( 12.0 );
	//SetDrawingMode( B_OP_OVER );
//	newButton *btn;
	BRect r;
	r = Bounds();
	//r.left += 2;
	//r.top += 1;
	//r.bottom -= 1;
#define WB	12
	r.right = r.left + 11;
	BMessage *msg;
	for( int i = 0; i < 7; i++)
	{
		msg  = new BMessage('itm');		
		msg->AddString( "cmd", "*" );
		msg->AddString( STR_TTIPS, chan_modeTT[ i ] );
		btn[ i ] = new newButton( r, "_", chan_mode_name[i], msg, 1 );
		btn[ i ]->SetFontSize( 10.0 );
		AddChild( btn[ i ] );
		r.OffsetBy( WB, 0 );
	}

}


ChatModeView::~ChatModeView()
{
}
bool ChatModeView::is_t(void)
{
	return btn[ eT]->IsCheck();	
}
void ChatModeView::SetMode( char *sz_mode)
{
	if( !(sz_mode[0] == '+' || sz_mode[0] == '-') )
		return;
	bool b =  sz_mode[0] == '+';
	int len = strlen( sz_mode );
	BMessage *msg;
	newButton *p_btn;
	char sz_cmd[128];
	sprintf( sz_cmd, "/MODE %s %cX", m_chat_name, ( b ? '-' : '+') );
	char *ptr = strchr( sz_cmd, 'X');
	
	for( int x = 1; x < len; x++)
	{		
		switch( sz_mode[ x ] )
		{
			case 't':
				p_btn = btn[ eT];
				break;
			case 'm':
				p_btn = btn[ eM];
				break;
			case 'n':
				p_btn = btn[ eN];
				break;
			case 's':
				p_btn = btn[ eS];
				break;
			case 'i':
				p_btn = btn[ eI ];
				break;
			case 'p':
				p_btn = btn[ eP];
				break;
			case 'o':
				p_btn = btn[ eO];
				break;				
			case 'b':
				return;				
			default:
				continue;
		}
		p_btn->Check( b );
		msg = p_btn->Message();
		*ptr = sz_mode[ x ];
		msg->ReplaceString( "cmd", sz_cmd);		
	}
	BWindow *w = Window();
	if( w )
	{
		ChatView* cv = (ChatView*) w->FindView("ChatView");
		if( cv )
			cv->check_topic();
	}		
}

void ChatModeView::SetEnable( bool b )
{
	BMessage *msg;
	char sz_cmd[128];
	sprintf( sz_cmd, "/MODE %s *X", m_chat_name );
	char *ptr = strchr( sz_cmd, 'X');
	char *ptr2 = strchr( sz_cmd, '*');
	for( int i = 0; i < 7; i++)
	{
		msg = btn[ i ]->Message();
		btn[ i ]->SetEnabled( b);
		const char *label = btn[ i ]->Label();
		*ptr = label[ 0 ];
		*ptr2 = btn[ i ]->IsCheck() ? '-' : '+';
		msg->ReplaceString( "cmd", sz_cmd);
	}
	Invalidate();
	BWindow *w = Window();
	if( w ) w->UpdateIfNeeded();
}
void ChatModeView::Draw(BRect rc)
{
	rc = Bounds();
	draw_3Drect( this, rc );
}
