#ifndef _CHATVIEW_H_
#define _CHATVIEW_H_

#include <View.h>
#include <Invoker.h>
class nickitem;
class BFile;
class ChatView : public BView
{
	const char *m_chat_name;
	BTextControl* m_topicV;
public:
	ChatView(BRect rc, const char *sz_chat_name);
	virtual ~ChatView();
	virtual void AttachedToWindow(void);
	virtual void DetachedFromWindow(void);
	virtual void Draw(BRect updateRect);
	virtual void FrameResized(float width, float height);
	virtual void MouseDown(BPoint point);
	void MessageReceived(BMessage *message);
	
	void SetTopic(char *topic);	
	void AddItem(const char *str);
	void RemoveAll(void);
	bool RemoveItem(const char *str);
	nickitem* FaindItem(const char *str);
	bool HasItem(const char* str);
	bool RenameItem(const char *str, const char*str2);
	void SetOP(const char *str, bool op);

	void check_topic( void );
	void sort_items(void);
protected:
	void make_ctcp_menu(BPopUpMenu* popup, const char* name);
	void update_chatinfo(void);
	void open_log(bool b);
private:
	BFile*	m_file;
};


class ChatInfoView : public BView, public BInvoker
{
public:
	ChatInfoView( BRect rc, uint32 resizeMode = B_FOLLOW_RIGHT |	B_FOLLOW_BOTTOM);
	~ChatInfoView();
	void Draw(BRect Update);
	void SetString( const char *str );
	void SetCreatedData( const char *str );
	virtual void FrameResized(float width, float height);
protected:
	char *m_str;		
	char *m_sz_data;
};

enum e_chan_mode
{
	eT = 0,
	eN,
	eS,
	eI,
	eP,
	eM,
	eO
};

class newButton;
class ChatModeView : public BView
{
public:
	ChatModeView( BRect rc, const char *chat_name);
	~ChatModeView();
	void Draw(BRect Update);
	void SetEnable( bool b );
	void SetMode( char *sz_mode);
	bool is_t(void);
protected:
	//bool t, n, s, i, p, m, o;
	newButton *btn[ 7 ];
	const char *m_chat_name;
};
#endif