#include "IRCApp.h"

#include "ChatWindow.h"
#include "ServerWindow.h"
#include "PrivatWindow.h"

#include "StatusBarView.h"

#include "newItem.h"

#include <ScrollBar.h>
#include <TextControl.h>

#include "irc_view.h"
#include "ChatView.h"
#include "constants.h"
#include "Utils.h"
#include "Prefs.h"

#include "irc_util.h"
//#include "newItem.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//////////////////////////////////////
//int d_strnicmp(const char*str1, const char*str2);
void d_tolower(char *str);
//////////////////////////
///////

ChatWindow::ChatWindow(ServerWindow* sw, const char* name) 
	: BWindow(BRect(30, 30, 380, 200), name, 
        B_DOCUMENT_WINDOW,
        /*B_NOT_ZOOMABLE|B_OUTLINE_RESIZE| B_FRAME_EVENTS*/B_ASYNCHRONOUS_CONTROLS
        ) 
{
	m_network_name = NULL;
	m_sw = sw;
	sw->Lock();
	b_end_of_names = true;
	m_dirty = false;
	BRect rc = Bounds(); 
	m_name = strdup(name);	

	rc.bottom -= B_V_SCROLL_BAR_WIDTH; 
  	ChatView* cv = new ChatView(rc, m_name );
	AddChild( cv );
	 
	rc.left--;
	rc.top = rc.bottom + 1;
	rc.bottom += B_V_SCROLL_BAR_WIDTH + 1;
	rc.right -= B_V_SCROLL_BAR_WIDTH - 0;
	StatusBarView *sbv = new StatusBarView(this, rc);
	sbv->SetResizingMode(B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM);
	sbv->AddList(&m_sw->m_chat_list);
	sbv->AddFirst( m_sw );

	tag_wnd_item *item = new tag_wnd_item;
	item->pWnd = this;
	strcpy( item->name, name);
	sw->m_chat_list.AddItem((void*)item);

	char newTitle[ 512 ];
	sprintf(newTitle, "%s on %s", name, m_sw->get_server() );
	SetTitle(newTitle);

	//m_sw->Lock();
	BMessage *pmsg = (BMessage*)m_sw->get_prefs();
	if( !pmsg->HasRect(name) )
	{
		
		pmsg->AddRect(m_name, Frame() );
	}
	else
	{
		pmsg->FindRect(m_name, &rc);
		MoveTo( rc.LeftTop() );
		ResizeTo( rc.Width(), rc.Height() );
	}
	//m_sw->Unlock();	
 	Show();
 	sw->Unlock();
}
bool ChatWindow::QuitRequested()
{
	if( m_sw )
	{
		BMessage msg('irc');
		char priv_msg[ 512 ];
		m_sw->Lock();
		const char* part_txt;
		Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
		prefs->Lock();
		prefs->GetMsg()->FindString( "_part_", &part_txt );
		prefs->Unlock();
		sprintf(priv_msg, "/PART %s %s", m_name,  part_txt);
		m_sw->Unlock();
		msg.AddString("cmd", priv_msg);	
		m_sw->msg_to_irc(&msg);
		QuitBeforeSW();
	}
	
	return true;
}
void ChatWindow::QuitBeforeSW(void)
{
	StatusBarView* sbv = (StatusBarView*)FindView("statusbar");
	sbv->AddFirst(NULL);
	sbv->AddList(NULL);	
	
	m_sw->Lock();
	BMessage *pmsg = (BMessage*)m_sw->get_prefs();
	pmsg->ReplaceRect(m_name, Frame());
	m_sw->Unlock();

	tag_wnd_item* item = find_item_by_wnd( &m_sw->m_chat_list, this);
	m_sw->m_chat_list.RemoveItem( (void*)item );
	delete item;
	m_name[0] = '\0';
	m_sw->Activate(true);
	m_sw = NULL;
}
ChatWindow::~ChatWindow()
{
	m_sw = NULL;
	delete m_name;
}

void ChatWindow::WindowActivated(bool active)
{
	BWindow::WindowActivated(active);
	m_dirty = false;
}
void ChatWindow::w_print(const char* str, int idx)
{

	if(!str)
		return;
	
	int32 len_str = strlen (str) + 1;
	if(len_str < 1)
	{
		return;
	}
	IRCView* irc_txt = (IRCView*)FindView("IRCView");
	if ( !irc_txt)
	{
		return;
	}
	irc_txt->w_print(str, idx );

	m_dirty = !IsActive();
}
void ChatWindow::do_msg(BMessage* message)
{
	int16 ret_code = -1;
	const char *from = NULL;
	const char *command = NULL;
	const char *c_params = NULL;
	char *params = NULL;
	char *ptr = NULL, *ptr1 = NULL, *ptr2 = NULL, *ptr3 = NULL;
	char sz_msg[1024];
	
	ChatView* cv = (ChatView*)FindView("ChatView");
		
	message->FindString ("params", &c_params);
	if(c_params)
	{	
		params = strdup( c_params );
		int len = strlen(params);
		if ( params[ len - 1] == '\n')
			params[ len - 1] = '\0';
	}
	message->FindInt16 ("code", &ret_code);

	switch (ret_code)
	{
		case 324:
		{
			//dipa #Russian +tnr 
			ptr1 = ptr2 = ptr3 = NULL;
			if( !params_get3( params, &ptr1, &ptr2, &ptr3 ) )
				break;
			w_print( ptr2, eMode  );
			w_print( " has MODE ", eMode );
			w_print( ptr3,  eMode );
			w_print( "\n", 0);
			ChatModeView *cm = (ChatModeView*)FindView("vChatMode");
			if( cm )
				cm->SetMode( ptr3 );						
		}break;
		case 329:
		{
			//dipa #minsk 930102162
			ptr1 = ptr2 = ptr3 = NULL;
			if( !params_get3( params, &ptr1, &ptr2, &ptr3 ) )
				break;
			time_t t = ( time_t ) atol ( ptr3 );
    			struct tm *tim;
    			tim = localtime( &t );
			char *str_time = strdup( asctime(tim) );
			/*w_print( ptr2,  eInformation );
			w_print( " created at ",  eInformation );
			w_print( str_time, eInformation );
			*/
			ptr = strrchr( str_time, ' ' );
			*ptr = '\0';
			ptr = strchr( str_time, ' ' );
			
			ChatInfoView *ci = (ChatInfoView*) FindView( "vChatInfo" );
			ci->SetCreatedData( ptr );
			delete str_time;
		}break;
		
		case 332:
			cv->SetTopic(strchr(params, ':') + 1);
		break;
		case 333:
		{
			ptr1 = ptr2 = ptr3 = NULL;
			char *ptr4 = NULL;
			if( !params_get4( params, &ptr1, &ptr2, &ptr3, &ptr4) )
				break;
			time_t t = ( time_t ) atol ( ptr4 );
    			struct tm *tim;
    			tim = localtime( &t );
			char *str_time = strdup( asctime(tim) );
			w_print( ptr2,  eTopic );
			w_print( " TOPIC created by <",  eTopic );
			w_print( ptr3,  eTopic );
			w_print( "> ",  eTopic );
			w_print( str_time, eTopic );
			delete str_time;				
		}break;
		
		case 353:
		{
			if( !b_end_of_names)
			{
				cv->RemoveAll();
				//break;
			}
			b_end_of_names = true;	
			ptr = strchr(params, ':');
			if(!ptr)
				break;
			ptr++;
			/*ptr2 = strtok( ptr, " ");
			while( 1 )
			{					
				if( ptr2 )
					cv->AddItem( ptr2 );
				else
					break;
				ptr2 = strtok( NULL, " ");	
			}*/
			int count = 0;
			char sz_mod_nick[64] = {0};
			while( true )
			{					
				sz_mod_nick[0] = '\0';
				int ret = get_word( ptr, count++, sz_mod_nick);
				if( !ret )
					break;
				cv->AddItem( sz_mod_nick );	
			}				
		}	
		break;
		case 366:
		{	b_end_of_names = false;			
			cv->sort_items();
			ChatModeView* cm = (ChatModeView*)FindView("vChatMode");
			nickitem* item = cv->FaindItem( m_sw->get_nick() );
			cm->SetEnable( (item->get_type() == 1) );
			cv->check_topic( );	
		}	
		break;
		
		case -1:
			break;
	}
	message->FindString ("from", &from);
	//w_print(from, 2);	
	
	message->FindString ("command", &command);
	if ( command)
	{
		if( strcmp( command, "PRIVMSG" ) == 0 && params)
		{
			ptr = strchr( params, ':');
			if ( *(ptr + 1) == '\1')
			{
				if( !strncmp( ptr+2, "ACTION", 6) )
				{
					sprintf(sz_msg, "ACTION <%s> %s\n", from,  ptr + 9);
					w_print( sz_msg, eAction  );
				}
			}
			else
			{
				sprintf(sz_msg, "<%s> %s\n", from,  ptr + 1);
				//w_print( ptr + 1,  0);
				w_print( sz_msg, eNormal_Txt  );
			}
			goto end;
		}
		if( command && strcmp( command, "JOIN") == 0 )
		{
			cv->AddItem( from );
			cv->sort_items();
			const char *c_prefix;
			message->FindString ("prefix", &c_prefix);
			if( c_prefix )
			{
				const char* c_host = strchr(c_prefix,'!' );
				if( c_host )
					sprintf(sz_msg, "JOIN %s (%s)\n", from, c_host + 1);
				else
					sprintf(sz_msg, "JOIN %s (%s)\n", from, c_prefix);	
			}
			else
				sprintf(sz_msg, "JOIN %s\n", from);	
			w_print( sz_msg, eJoin );
			goto end;
		}
		if( strcmp( command, "PART") == 0 || strcmp( command, "QUIT") == 0 )
		{
			if( cv->RemoveItem( from ) )
			{
				sprintf(sz_msg, "%s %s %s\n", command, from, params);
				w_print( sz_msg, eQuit );				
				const char *nick = m_sw->get_nick();
				if(nick)
				{					
					if( strcmp( nick, from) == 0)
						cv->RemoveAll();
				}
			}
			goto end;	
		}
		if( strcmp( command, "KICK") == 0  )
		{
			//cv->RemoveAll();
			ptr = strchr(params, ' ');
			if(ptr)
			{
				ptr++;
				ptr2 = strchr(ptr, ':');
				if(ptr2)
				{
					*ptr2 = '\0';
					ptr2++;
					sprintf(sz_msg, "%s %s %s %s\n", from, command, ptr, ptr2);
					w_print( sz_msg, eKick );
					char sz_nick[64] = {0};
					get_word(ptr, 0, sz_nick);
					cv->RemoveItem( sz_nick );
					const char *nick = m_sw->get_nick();
					if( nick )
					{					
						if( strcmp( nick, sz_nick ) == 0)
							cv->RemoveAll();							
					}
				}
			}
			goto end;
		}
		if( strcmp( command, "MODE") == 0)
		{			
			char sz_mod_nick[64] = {0};
			nickitem* nick_item = NULL;
			int ret = get_word( params, 2, sz_mod_nick);
			if( ret )
			{
				nick_item = cv->FaindItem( sz_mod_nick );
			}
			
			if( nick_item == NULL )//params[ 0 ] == '#' || params[ 0 ] == '$' )
			{
				// #pppr +nt 
				ptr = params + strlen( m_name ) + 1;
				ChatModeView *cm = (ChatModeView*) FindView( "vChatMode" );
				cm->SetMode( ptr );
				sprintf(sz_msg, "%s %s %s\n", command, from, params);
				w_print( sz_msg, eMode );
				goto end;
			}
							
						
			if( nick_item  )
			{
				char *ptr_to_op = strstr( params, "+o" );
				int is_op_mode = -2;
				if( ptr_to_op )
					is_op_mode = 1;
				ptr_to_op = strstr( params, "-o" );
				if( ptr_to_op )
					is_op_mode = 0;
				if( is_op_mode != -2)
				{
					int start_nicks = 3;
					while( true )
					{					
						cv->SetOP( nick_item->get_name() , is_op_mode );
						sprintf(sz_msg, "%s has %s %s\n", from, is_op_mode ? "Opped" : "DeOpped" , nick_item->get_name() );					
						w_print( sz_msg, eMode );
						
						sz_mod_nick[0] = '\0';
						ret = get_word( params, start_nicks++, sz_mod_nick);
						if( !ret )
							break;
						nick_item = cv->FaindItem( sz_mod_nick );
						if( nick_item == NULL )
							break;
					}	
					cv->sort_items();
					goto end;						
				}
										
			}
			sprintf(sz_msg, "%s %s %s\n", command, from, params);
			w_print( sz_msg, eMode );
			goto end;
		}
		if(strcmp( command, "NICK") == 0)
		{
			
			if( cv->RenameItem(from, strchr(params, ':') + 1) )
			{	
				sprintf(sz_msg, "%s %s %s\n", from, command,  params + 1);
				w_print( sz_msg, eNick );
				cv->sort_items();		
			}
		}
		if(strcmp( command, "TOPIC") == 0)
		{
			ptr = strchr(params, ':') + 1;
			cv->SetTopic(ptr);
			sprintf(sz_msg, "%s set the Topic to \"%s\"\n", from, ptr);
			w_print( sz_msg, eTopic );	
		}
	}

end:	
	if ( params ) 
		delete ( params );
}
const char* ChatWindow::get_nick( void )
{
	if( m_sw) 
		return m_sw->get_nick(); 
	return NULL; 
}
void ChatWindow::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		case 'itm':			
		{
			message->what = 'irc';				
			m_sw->msg_to_irc(message);
		}break;
		case 'prv':
		{
			const char *str;
			message->FindString("user_name", &str);
			tag_wnd_item *exist_wnd = find_item_by_name( &m_sw->m_privat_list, str);
			if(exist_wnd == NULL)
				new PrivatWindow(m_sw,  str);	
			else
				exist_wnd->pWnd->Activate(true);	
		}
		break;
		case 'irc':
			do_msg(message);
			break;
		case 'ntr':
		{
			BMessage *l_target;
			if( message->FindPointer("target", (void**)&l_target) != B_OK)
				break;
			switch( l_target->what)
			{
				case 'umg':
				{	
					char priv_msg[600];
					
					BTextControl* mms = (BTextControl*)FindView("message");
					const char* sz_txt =  mms->Text();
					BMessage msg('irc');
					if ( sz_txt[0] == '/')
					{
						if( strncasecmp( sz_txt, "/ME ", 4) == 0)
						{
							sprintf( priv_msg, "/ME %s %s", m_name, sz_txt + 4);
							msg.AddString("cmd", priv_msg );
							sprintf( priv_msg, "ACTION <%s> %s\n", m_sw->get_nick(),  sz_txt + 4);
							w_print( priv_msg, eAction  );
						}
						else 
							msg.AddString("cmd", sz_txt);
					}	
					else
					{
						
						sprintf(priv_msg, "/MSG %s %s", m_name, sz_txt);
						msg.AddString("cmd", priv_msg);
						sprintf(priv_msg, "<%s> %s\n",  m_sw->get_nick(), sz_txt);						
						w_print(priv_msg, eOwn_Txt );							
					}
					
					m_sw->msg_to_irc(&msg);
					mms->SetText(NULL);
				}break;						
				case 'tpc':
				{
					BTextControl* topic = (BTextControl*)FindView("_n_topic_edit");
					const char* sz_txt =  topic->Text();
					BMessage msg('irc');
					char topic_msg[600];
					sprintf(topic_msg, "/TOPIC %s %s", m_name, sz_txt);
					msg.AddString("cmd", topic_msg);
					m_sw->msg_to_irc(&msg);		
				}	
				break;
			}
		}
		break;	
	}
	BWindow::MessageReceived(message);
}
