#include <View.h>
#include "IRCApp.h"
#include "Prefs.h"

#include "DefCommands.h"
#include "constants.h"
#include "commands_const.h"

#include "edit_list_item.h"
#include "ListEditCtl.h"
#include "newButton.h"
#include "Utils.h"


DefComWindow::DefComWindow( BRect frame , const char* sz_pos, window_look look, window_feel feel ) 
	: BWindow( frame, "Defined Commands", look, feel, B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS)
{
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();
	strcpy( m_w_pos, sz_pos);
		
//	BRect frame = Frame();
	frame = Frame();
	if( !pref_msg->HasRect( m_w_pos) )
  		pref_msg->AddRect( m_w_pos, frame);
  	else
  	{	
		pref_msg->FindRect( m_w_pos, &frame);
		MoveTo(frame.LeftTop());
		ResizeTo( frame.Width(), frame.Height() );
	}
	  
	prefs->Unlock();

	BRect rc = Bounds(); 
	BView* bv = (BView*)new a3DView(rc, "m_view", B_FOLLOW_ALL, B_WILL_DRAW);
	SET_VIEW_COLORS( bv );
	AddChild( bv );
	rc.top += 12;
	rc.left += 8;
	rc.right -= 8;
	rc.bottom -= 36;
	ListEditCtl *el = new ListEditCtl( rc);
	bv->AddChild( el );

	BButton *btn;
	rc = Bounds();
	rc. top = rc.bottom - 26;
	rc.bottom = rc.top + 20;
	rc.left = rc.right - 160;
	rc.right = rc.left + 74;
	btn = (BButton*) new newButton(rc, "Ok", "Ok", new BMessage('okay') );
	bv->AddChild(btn);
	btn->SetTarget(this); 
	rc.OffsetBy( 80, 0);
	btn = (BButton*) new newButton(rc, "Cancel", "Cancel", new BMessage('canl'));
	bv->AddChild(btn);
	btn->SetTarget(this); 
	
	
	//InsertElements( lv );
	Show();
}

DefChatWindow::DefChatWindow(BRect frame) : DefComWindow( frame, "def_chat_pos") 
{
	Lock();
	SetTitle("Favorites");
	ListEditCtl *ptr = (ListEditCtl*) FindView( ID_list_edit );
	ptr->SetColumName( "Chat" );
	ptr->Invalidate();
	Unlock();
}
DefComWindow::~DefComWindow()
{
}
void DefComWindow::Quit( void )
{
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	prefs->GetMsg()->ReplaceRect( m_w_pos, Frame() );	
	prefs->Unlock();

	BListView *lv = (BListView*)FindView( "cmd_list" );
	int32 count = lv->CountItems();
	//const BListItem **ppList = lv->Items();

	for( int32 i = 0; i < count; i++)
	{
		//delete ppList[i]; 
		delete lv->RemoveItem( (int32)0 );
	}	
	lv->MakeEmpty();
	
	BWindow::Quit();
}
void DefChatWindow::InsertElements( void )
{
	BListView *lv = (BListView*)FindView( "cmd_list" );
	int32 i;
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();

	Lock();
	for( i = 0; ; i++ )
  	{
  		const char* sz_cmd;;
  		if( pref_msg->FindString( "def_chats", i , &sz_cmd )!= B_OK)
			break;
		lv->AddItem(new edit_item( sz_cmd ));
  	}
	
	lv->AddItem(new edit_item( ));
	Unlock();
	prefs->Unlock();
}
void DefComWindow::InsertElements( void )
{
	BListView *lv = (BListView*)FindView( "cmd_list" );
	int32 i;
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();
	Lock();
	for( i = 0; i < PROTECTED_ITEM;  i++ )
  	{
  		edit_item *ptr = new edit_item( c_commands[ i ] );
  		ptr->locked() = true;
  		lv->AddItem( ptr );
  	}
	for( i = 0; ; i++ )
  	{
  		const char* sz_cmd;;
  		if( pref_msg->FindString("def_commands", i , &sz_cmd )!= B_OK)
			break;
		lv->AddItem(new edit_item( sz_cmd ));
  	}
	lv->AddItem(new edit_item( ));
	Unlock();
	prefs->Unlock();
}
bool DefComWindow::QuitRequested()
{
	return true;
}
void DefComWindow::FrameResized(float new_width, float new_height)
{
	BView *btn;
	BRect rc = Bounds();
	rc. top = rc.bottom - 26;
	rc.bottom = rc.top + 20;
	rc.left = rc.right - 160;
	rc.right = rc.left + 74;
	btn = FindView( "Ok" );
	btn->MoveTo(rc.LeftTop() );
	rc.OffsetBy( 80, 0);
	btn = FindView("Cancel");
	btn->MoveTo(rc.LeftTop() );
	
	btn = FindView( ID_list_edit );
	new_width -= 16;
	new_height -= ( 12 + 36);
	btn->FrameResized( new_width, new_height);
}

void DefComWindow::OnOkay(void)
{
	BListView *lv = (BListView*)FindView( "cmd_list" );
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *msg = prefs->GetMsg();
	msg->RemoveName("def_commands");
	int32 count = lv->CountItems();
	for(int32 i = PROTECTED_ITEM; i < count; i++ )
	{
  		const char *ptr = ((edit_item*)lv->ItemAt(i))->get_ptr();
  		if( ptr && strlen( ptr ) > 0 )
  			msg->AddString("def_commands", ptr );
  	}
	prefs->Unlock();
	Quit();
}
void DefChatWindow::OnOkay(void)
{
	BListView *lv = (BListView*)FindView( "cmd_list" );
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *msg = prefs->GetMsg();
	msg->RemoveName("def_chats");
	int32 count = lv->CountItems();
	for(int32 i = 0; i < count; i++ )
	{
  		const char *ptr = ((edit_item*)lv->ItemAt(i))->get_ptr();
  		if( ptr && strlen( ptr ) > 0 )
  			msg->AddString("def_chats", ptr );
  	}
	prefs->Unlock();
	Quit();
}
void DefComWindow::MessageReceived(BMessage* message)
{
 	BListView *lv = (BListView*)FindView( "cmd_list" );
 	switch(message->what)
	{
		case 'okay':
		{
			((edit_listView*)lv)->StopEdit();
			OnOkay();			
		}break;
		case 'canl':
		{
			Quit();
		}break;	
		default:
		break;
	}
   BWindow::MessageReceived(message);
}
