#include <Alert.h>
#include "IRCApp.h"
#include "MainWindow.h"
#include <malloc.h>
#include "Prefs.h"
#include "init_prefs.h"

#include "tips.h" 
IRCApp::IRCApp() : BApplication("application/x-vnd.dipa-Bardak")
{
  m_WindowPos.Set(-1, -1);
}


void IRCApp::ReadyToRun(void)
{  
  // Use previous position user left window at unless this is the
  // first time and their is no previous position
  //
	m_prefs = new Prefs("Bardak settings","Bardak");	
	if( !init_main_prefs( m_prefs->GetMsg() ) )
	{
		BAlert* alert = new BAlert("ERROR", "Initialization faled\nCheck your system", "OK", NULL, NULL, B_WIDTH_AS_USUAL,
					B_STOP_ALERT);
		 alert->Go();
	}
	load_servers( m_prefs->GetMsg() );	
	
	m_prefs->GetMsg()->FindPoint("IRCAppWindow", &m_WindowPos);
	
	m_tserver = new tips_server();

	const float kWindowWidth = 218;
	const float kWindowHeight = 25;
	const float kTitleBarHeight = 26;
	BRect frameRect(0, 0, kWindowWidth, kWindowHeight);
	if (m_WindowPos.x == -1 && m_WindowPos.y == -1)
		frameRect.OffsetTo(6, kTitleBarHeight);
	else
		frameRect.OffsetTo(m_WindowPos.x, m_WindowPos.y);
	new MainWindow(frameRect);
}

IRCApp::~IRCApp(void)
{
	save_servers( m_prefs->GetMsg() );	
	delete m_prefs;
  	//delete m_servers_prefs;
	m_prefs = NULL;
	//m_servers_prefs = NULL;	  
}
//#include <TranslationUtils.h> 
//#include "DefCommands.h"
#include <StorageKit.h>

#include <SupportDefs.h>
#include <TypeConstants.h>

#include <Message.h>
#include <Mime.h>
#include <stdio.h>

void IRCApp::AboutRequested()
{
  char sz_Info[256];
  sprintf(sz_Info, "\nBardak (%s)\n\nby Dmitry Pavlushko (dipa@altavista.net) \nhttp://www.izap.com/~dipa", csz_Version);
  BAlert* alert = new BAlert("About", sz_Info, "OK");
  alert->Go();
  //new DefComWindow( BRect( 100, 100, 450, 300));

  //BWindow* aboutWindow;
  //aboutWindow = new AboutWindow;
  //aboutWindow->Show();
  
  
}

bool IRCApp::QuitRequested()
{
     //
 	delete m_tserver; 
	m_tserver = NULL;
	
 	//bool ok = 
 	QuitWinLoop();
	//if (ok)
	{
  		//int32 i = 0;		
  		BWindow* pWin;
  		
  		while ( 1 )
  		{
  			pWin = WindowAt(0);
  			if(  pWin && pWin->Lock() ) 
				pWin->Quit();
			if( CountWindows() == 0 )
				break;	
		}	
		
  		m_prefs->Lock();
  		m_prefs->GetMsg()->ReplacePoint("IRCAppWindow", m_WindowPos);
  		m_prefs->Unlock();
    		
		//BApplication::QuitRequested();

		//delete m_prefs;
  		//delete m_servers_prefs;
	
	}
	//return ok;
	return true;
	
}
void IRCApp::SetWindowPos(BPoint p)
{
	m_WindowPos = p;
}
bool IRCApp::QuitWinLoop()
{
	bool ok = true;
	status_t err;
	BWindow* pWin;
	int32 i=0;
	while (ok && (pWin = WindowAt(i++))) 
	{
		MainWindow* pDudeWin = dynamic_cast<MainWindow*>(pWin);
		if (pDudeWin && pDudeWin->Lock()) 
		{
			BMessage quitMsg(B_QUIT_REQUESTED);
			BMessage reply;
			BMessenger winMsgr(pDudeWin);
			pDudeWin->Unlock();
			err = winMsgr.SendMessage(&quitMsg, &reply);
			if (err == B_OK) {
				bool result;
				err = reply.FindBool("result", &result);
				if (err == B_OK) {
					ok = result;
				}
			}
		}
	}
	return ok;
}
