#include <Window.h>
#include <ScrollView.h>

#include "ListEditCtl.h"

#include "constants.h"
#include "Utils.h"
#include "edit_list_item.h"
#define HEADER_H		18
ListEditCtl::ListEditCtl( BRect rc )
	: BView(rc, ID_list_edit, B_FOLLOW_ALL, B_WILL_DRAW)// | B_NAVIGABLE_JUMP)
{
	rc = Bounds();
	rc.top += HEADER_H;//B_H_SCROLL_BAR_HEIGHT;
	rc.right -= B_V_SCROLL_BAR_WIDTH + 1;
	rc.left++;
	rc.bottom--;
	BListView* lv = (BListView*) new /*BListView*/edit_listView(rc, "cmd_list", B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL );
	lv->SetViewColor(sc_viewcolor);
	//lv->SetHighColor(sc_highcolor);
	//lv->SetLowColor(sc_lowcolor);
	
	BScrollView *sv = new BScrollView( "sv_cmd_list", lv, 
            /*B_FOLLOW_RIGHT | B_FOLLOW_TOP_BOTTOM*/B_FOLLOW_ALL, B_WILL_DRAW, false, true, B_NO_BORDER);
  	strcpy(m_name, "Command");
  	AddChild(sv);
  	SetFont( be_bold_font );
  	SetFontSize( 12.0 );
}

ListEditCtl::~ListEditCtl()
{
}
void ListEditCtl::AttachedToWindow(void)
{
	SETUP_VIEW_COLORS;
}
void ListEditCtl::DetachedFromWindow(void) 
{
}
void ListEditCtl::FrameResized(float new_width, float new_height)
{
	BRect rc = Bounds();
	rc.bottom = rc.top + HEADER_H;	
	Invalidate( rc );
	Window()->UpdateIfNeeded();
}
void ListEditCtl::StopEdit(void)
{
	edit_listView *lv = (edit_listView*)FindView( "cmd_list" );
	lv->StopEdit();
}
void ListEditCtl::SetColumName( const char* sz)
{
	strcpy( m_name, sz );
}
void ListEditCtl::Draw(BRect rc)
{
	BView::Draw( rc );
	rc = Bounds();
	draw_3Drect( this, rc, true);
	
	rc.bottom = rc.top + HEADER_H - 2;
	draw_3Drect( this, rc);
	rc.top = rc.bottom + 1;
	rc.bottom = rc.bottom + 0;
	draw_3Drect( this, rc);
	rc = Bounds();
	rc.bottom= rc.top + HEADER_H - 2;
	rc.left += 15;
	//rc.right = rc.left + 14;
	draw_3Drect( this, rc);
	rc.left -= 15;
	rc.right = rc.left + 14;
	draw_3Drect( this, rc);
	rc = Bounds();
	//draw_3Drect( this, rc, true);
	rc.bottom = rc.top + HEADER_H;
	font_height height;
	
     	GetFontHeight(&height); 
	MovePenTo( 18 , (rc.top + rc.bottom) /2 + ((height.ascent + height.leading) / 4 ));	
	SetDrawingMode(B_OP_OVER);
	rgb_color hc = HighColor();
	SetHighColor( 0, 0, 64 ); 
	DrawString( m_name ); 	
	
   	SetHighColor(hc);
   	SetDrawingMode (B_OP_COPY); 
}