#include "constants.h"

#include <MenuBar.h>
#include <MenuItem.h>
#include <Alert.h>

#include "IRCApp.h"
#include "MainView.h"
#include "MainWindow.h"
#include "ServerWindow.h"
#include "DebugWindow.h"

#include "newButton.h"
#include "tips.h"
#include "Utils.h"

#include "SettingsView.h"
#include "ServerView.h"
#include "newButton.h"
#include "DefCommands.h"

DebugWindow *g_debug;

MainView::MainView(BWindow* window)
	: BView(window->Bounds(), "MainView", B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW  /*| B_NAVIGABLE_JUMP | B_PULSE_NEEDED*/ )
{
//	g_view = this;  
	g_debug = NULL;
	window->AddChild(this);
	//CreateMenus();
  
	BRect r = window->Bounds();
	//r.OffsetTo(B_ORIGIN);
	r.InsetBy(2, 2);
	//r.top = 22;
	//r.bottom += 2;
	//r.left = r.right - 22;
	//r.bottom -= 4;
  
	r.left = 10;
	r.right = 72;
  /*r.bottom -= 8;
  r.top += 3;
  */
	BButton *btn;
	BMessage *msg;
	msg = new BMessage(MI_FILE_START);
	msg->AddString( STR_TTIPS, "Start IRC Session");
	btn = (BButton*) new bmpButton( r.LeftTop(), "Start", 42, -1, msg );//new newButton(r, "Start", "Start",  msg );
	AddChild(btn);
	btn->SetTarget(this); 

	r.OffsetBy( r.right + 4, 0);
	r.right = r.left + 16;
	msg = new BMessage(MI_FILE_SETTINGS);
	msg->AddString( STR_TTIPS, "Preferences");
	btn = (BButton*) new bmpButton( r.LeftTop(), "Settings", 30, -1, msg );
	AddChild(btn);
	btn->SetTarget(this); 
 	
 	r.left = r.left + 26;
	msg = new BMessage('udcm');
	msg->AddString( STR_TTIPS, "Commands");
	btn = (BButton*) new bmpButton( r.LeftTop(), "_m_", 36, -1,  msg );
	AddChild(btn);
	btn->SetTarget( this );  

	r.left = r.left + 26;
	msg = new BMessage('dchm');
	msg->AddString( STR_TTIPS, "Favorites");
	btn = (BButton*) new bmpButton( r.LeftTop(), "_#_", 33, -1,  msg );
	AddChild(btn);
	btn->SetTarget( this ); 
 	r.left = r.left + 26;

	msg = new BMessage( MI_WINDOW_DEBUG );
	msg->AddString( STR_TTIPS, "Debug Window");
	btn = (BButton*) new bmpButton( r.LeftTop(), "DCC", 43, -1, msg );
	AddChild(btn);
	btn->SetTarget( this ); 
	
 	r.left = r.left + 26;
	msg = new BMessage(B_ABOUT_REQUESTED);
	msg->AddString( STR_TTIPS, "About");
	btn = (BButton*) new bmpButton( r.LeftTop(), "About", 34, -1, msg );
	AddChild(btn);
	btn->SetTarget( be_app ); 
  
  
	MakeFocus(true);
}

void MainView::AttachedToWindow(void)
{	
	BView::AttachedToWindow();
	SETUP_VIEW_COLORS;
}

void MainView::Draw(BRect rc)
{
	BView::Draw(rc);
	rc = Bounds();
	draw_3Drect(this, rc);  

	//rc = Bounds();
	rc.left += 2;
	rc.InsetBy( 0 ,  3); 
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_HIGH);
	rc.left += 1;
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_LOW);	
	rc.left += 2;
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_HIGH);
	rc.left += 1;
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_LOW);	
}
/*
void MainView::Pulse()
{

	bmpButton *ptr = (bmpButton*)FindView("Settings");
	if( !ptr->IsCheck() )
		return;
	int32 count = be_app->CountWindows();
	bool b = false;
	for( int32 i = 0; i < count; i++)
	{
		BWindow* w = be_app->WindowAt( i );
		if( w )
		{
			w->Lock();
			const char* title = w->Title();
			
			if ( title && strcmp( title, "Settings") == 0 )
				b = true;
			w->Unlock();
		}
	}
	if( !b )
	{
		ptr->Check( false );
	}
	
}
*/

void MainView::MessageReceived(BMessage* message)
{
  switch (message->what)
  {
	case 'udcm':
	{
		DefComWindow *ptr = new DefComWindow( BRect( 100, 100, 450, 300) );
		ptr->InsertElements();
	}	break;
    case 'dchm':
    	{
    		DefComWindow *ptr = new DefChatWindow( BRect( 100, 100, 300, 300) );
    		ptr->InsertElements();
    	} break;
    case MI_FILE_SETTINGS:
    {  
    		if( !SettingsWindow::m_one )
    			new SettingsWindow();
    		else
    			SettingsWindow::m_one->Activate();
    		//bmpButton *ptr = (bmpButton*)FindView("Settings");
		//ptr->Check( true );
    }   
    break;
    case MI_FILE_START:
    {
      /*ServerWindow *sw = */new ServerWindow();
      //BMessage *msg = new BMessage(WM_ACTIVATE);      
    }
    break;  
    case MI_WINDOW_DEBUG:
	{
		if(g_debug == NULL)
			g_debug = new DebugWindow();
		else
			;//g_debug->Active();
	}break;
    default:
      BView::MessageReceived(message);
    break;
  }
}
