#include "IRCApp.h"
#include "MainWindow.h"
#include "constants.h"
#include "Prefs.h"
#include "Utils.h"

#include "MainView.h"
#include "SettingsView.h"
#include "color_font.h"
#include <Screen.h>
#include <TabView.h>

MainWindow* g_window;
  
MainWindow::MainWindow(BRect frame)
	: BWindow(frame, "Bardak", B_TITLED_WINDOW, 
		B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_NORMAL_WINDOW_FEEL | B_ASYNCHRONOUS_CONTROLS)
{
  g_window = this;
  SetSizeLimits( 1, 999, 1, 999);
  ResizeTo( frame.Width(), frame.Height() );
  /*BRect viewRect = Bounds();
  MainView* theView = */new MainView(this);
  Show();
}
void MainWindow::MessageReceived(BMessage* message)
{
	/*switch (message->what)
	{
	case WM_SERVER_QUIT:
		
	break;
	}*/
	BWindow::MessageReceived(message);
}
void MainWindow::Quit(void)
{
	//be_app->PostMessage(B_QUIT_REQUESTED);
	BWindow::Quit();
}
bool MainWindow::QuitRequested()
{
  // Inform the application of the window's position before it closes
  // so the application can record it. This must be done before the window
  // is closed because after the window is closed the coordinates are
  // no longer valid
  //
  	/*BWindow* pWin;
  	int32 i = 0;
	while ( (pWin = be_app->WindowAt(i++)) && pWin->Lock() ) 
	{
			pWin->Quit();
	}
	*/
	//while( be_app->CountWindows() );
  	((IRCApp*) be_app)->SetWindowPos(Frame().LeftTop());
  	be_app->PostMessage(B_QUIT_REQUESTED);
  return true;
}

SettingsWindow* SettingsWindow::m_one = NULL;
SettingsWindow::SettingsWindow() 
	: BWindow(BRect(0, 0, 0, 0), "Preferences", 
        //B_TITLED_WINDOW,
        //B_FLOATING_WINDOW_LOOK,
        B_TITLED_WINDOW_LOOK,
        B_NORMAL_WINDOW_FEEL,
        B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS
        ) 
{
	m_one = this;
	const float width = 380;
	const float height = 280;
	// Calculate centered coordinates for app's current screen.
	//
	be_app->Lock();
	BRect screen = BScreen(be_app->WindowAt(0)).Frame();
	be_app->Unlock();
	BRect r;
	r.left = (screen.Width() - width) / 2;
	r.right = r.left + width;
	r.top = (screen.Height() - height) / 2;
	r.bottom = r.top + height;
	
	// Center the window
	//
	MoveTo(r.LeftTop());
	ResizeTo(width, height);
	r = Bounds(); 
	BView *bv = (BView *)new a3DView(r, "emptyView", B_FOLLOW_ALL, B_WILL_DRAW);
	//bv->SetViewColor(216,216,216);
	SET_VIEW_COLORS(bv);
	AddChild(bv);
	r.InsetBy(4., 4.);
	r.bottom -= 28;
	// Now create the view
	//SettingsView *sv = new SettingsView(this);
	BTabView *sv = new BTabView(r, "tab_view",B_WIDTH_FROM_WIDEST,
	                            B_FOLLOW_ALL,
	                            B_WILL_DRAW | B_NAVIGABLE_JUMP );
	//sv->SetViewColor(216,216,216,0); 
	bv->AddChild(sv);
	
	SET_VIEW_COLORS(sv);
		Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	m_prefs = new BMessage( prefs->GetMsg() );
	prefs->Unlock();
	
	SettingsTab::m_prefs = m_prefs;
	/*
	sv->AddTab(new BView( r, "General", B_FOLLOW_ALL_SIDES, B_WILL_DRAW ),NULL);
	sv->AddTab(new BView( r, "Servers", B_FOLLOW_ALL_SIDES, B_WILL_DRAW ),NULL);
	sv->AddTab(new BView( r, "Colors/Fonts", B_FOLLOW_ALL_SIDES, B_WILL_DRAW ),NULL);
	sv->AddTab(new BView( r, "Messages", B_FOLLOW_ALL_SIDES, B_WILL_DRAW ),NULL);
	sv->AddTab(new BView( r, "DCC", B_FOLLOW_ALL_SIDES, B_WILL_DRAW ),NULL);
	
	
	int w_tab = 0;
	int i, tab_count = sv->CountTabs();
	for( i = 0; i < tab_count; i++ )
		w_tab += sv->TabFrame( i ).IntegerWidth();
	
	w_tab += 20;
	
	if( w_tab > width )
		ResizeTo( w_tab, height);
	
	for( i = 0; i < tab_count; i++ )
		delete sv->RemoveTab(0);
	*/
	r = sv->Bounds(); 
	r.bottom -= sv->TabHeight() - 2; 

	
///////  Ading Tabs
	GeneralTab *gt = new GeneralTab( r, "General" );
	BRect rc = gt->Bounds();
	rc.bottom -= sv->TabHeight() + 4; 
		
		gt->AddTab(new UserViewTab( rc ));
		gt->AddTab(new ServersViewTab( rc ));
		gt->AddTab(new MsgViewTab( rc ));
	
	sv->AddTab( gt, NULL );	

	gt = new GeneralTab( r, "Colors/Fonts" );
		
		gt->AddTab(new ColorsViewTab( r ) );
		gt->AddTab(new FontViewTab( r ) );
		
	sv->AddTab( gt, NULL );	

	sv->AddTab(new DCCViewTab( r ),NULL);
	sv->AddTab(new FirewallViewTab( r ),NULL);
		
	prefs->Lock();
	
	BMessage *pref_msg = prefs->GetMsg();
	int16 active_tab = 0;
	pref_msg->FindInt16( "active_tab", &active_tab );
	sv->Select( (int32)active_tab);
	
	prefs->Unlock();
	
	BButton *btn;
	r = Bounds();
	r. top = r.bottom - 26;
	r.bottom = r.top + 20;
	r.left = r.right - 160;
	r.right = r.left + 74;
	btn = (BButton*) new newButton( r, "Ok", "Ok", new BMessage('okay') );
	bv->AddChild(btn);
	btn->SetTarget(this); 
	r.OffsetBy( 80, 0);
	btn = (BButton*) new newButton( r, "Cancel", "Cancel", new BMessage('canl'));
	bv->AddChild(btn);
	btn->SetTarget(this); 
	Show();
}

SettingsWindow::~SettingsWindow()
{
	m_one = NULL;
	delete m_prefs;
}
void SettingsWindow::Quit(void)
{
	//if( !m_is_ok )
	//	return BWindow::Quit();
	End( 3 );	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	BMessage *pref_msg = prefs->GetMsg();
	prefs->Lock();
	BTabView *tv = (BTabView*)FindView( "tab_view" );
	int32 active_tab = tv->Selection();
	pref_msg->ReplaceInt16( "active_tab", (int16)active_tab );
	prefs->Unlock();
	BWindow::Quit();
	SettingsTab::m_prefs = NULL;

}
bool SettingsWindow::QuitRequested( void )
{
	return true;
}
void SettingsWindow::End( int b)
{
	Lock();
	BTabView *tv = (BTabView*)FindView( "tab_view");
	int32 i, count = tv->CountTabs();
	for( i = 0; i < count; i++)
	{
		SettingsTab *tab = dynamic_cast<SettingsTab*>(tv->ViewForTab( i ));
		if( tab )
		{
			switch( b  )
			{
			case 1:
				tab->OnOk();
				break;
			case 2:
				tab->OnCancel();
				break;	
			case 3:
				tab->OnClose();					
				break;
			}
		}	
	}
	if( b == 1 )
	{
		Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
		prefs->Lock();
		*(prefs->GetMsg()) = *m_prefs;
		prefs->Unlock();
	}	
	Unlock();
}
void SettingsWindow::MessageReceived(BMessage* message)
{
 	switch(message->what)
	{
		case 'okay':
		{
			End( 1 );
			Quit();
		}break;
		case 'canl':
		{
			End( 2 );
			Quit();
		}break;	
		default:
		break;
	}
   BWindow::MessageReceived(message);
}
