#include "Prefs.h"
//#include "constants.h"

#include <stdio.h>
#include <Alert.h>
#include <Directory.h>
#include <Entry.h>
#include <File.h>
#include <FindDirectory.h>
#include <Path.h>

//#include "constants.h"


Prefs::Prefs(const char* name, const char* dir_name)
	: BLocker()
{
	m_PrefsEntry = NULL;
	m_SettingMessage = NULL;
	m_DefaultMessage = new BMessage();
	
	MakeDefault();
	
	BPath		path;
	BDirectory	dir;
	BEntry*		entry = new BEntry();
	
	::find_directory(B_USER_SETTINGS_DIRECTORY, &path, true);
	dir.SetTo(path.Path());
	
	if(dir_name != NULL)
	{
		BEntry	entry;
		if(dir.FindEntry(dir_name, &entry) == B_NO_ERROR)
		{
			BDirectory	bufDir(&entry);
			dir = bufDir;
		}else
		{
			dir.CreateDirectory(dir_name, &dir);
		}
	}
	
	if(dir.FindEntry(name, entry) == B_NO_ERROR)
	{
		m_PrefsEntry = entry;
		LoadPrefs();
	}else
	{
		delete entry;
		BFile	file;
		if(dir.CreateFile(name, &file) == B_NO_ERROR)
		{
			m_PrefsEntry = new BEntry();
			dir.FindEntry(name, m_PrefsEntry);
			m_SettingMessage = new BMessage(m_DefaultMessage);
		}else
		{
			
		}
	}
	
}


Prefs::~Prefs()
{
	StorePrefs();
	
	delete	m_PrefsEntry;
	delete	m_SettingMessage;
}

void Prefs::LoadPrefs()
{
	BFile	file(m_PrefsEntry, B_READ_ONLY);
	if(file.InitCheck() == B_NO_ERROR)
	{
		delete m_SettingMessage;
		m_SettingMessage = new BMessage();
		if( m_SettingMessage->Unflatten(&file) != B_OK )
		{
			delete m_SettingMessage;
			m_SettingMessage = new BMessage(m_DefaultMessage);
		}
	}else
	{
		(new BAlert(B_EMPTY_STRING,
				"Error...\n"
				"The setting file is not found.",
				"OK"))->Go();
	}
		
}


void Prefs::StorePrefs()
{
/*	for( int i = 0; i < int(sizeof(irc_event_color)/sizeof(irc_event_color[0])); i++)
	{	
		if( m_SettingMessage->HasInt16( "event_colors", i ) )
			m_SettingMessage->ReplaceInt16( "event_colors", i, irc_event_color[ i ] );		
		else
			m_SettingMessage->AddInt16("event_colors", irc_event_color[ i ]);
	}
*/	
	
	BFile	file(m_PrefsEntry, B_WRITE_ONLY | B_CREATE_FILE);
	if(file.InitCheck() == B_NO_ERROR)
	{
		file.SetSize(0);
		m_SettingMessage->Flatten(&file);
	}else
	{
		(new BAlert(B_EMPTY_STRING,
				"Error...\n"
				"Can not create the settings file:(((",
				"OK"))->Go();
	}
}


void Prefs::MakeDefault()
{
		
	m_DefaultMessage->AddString("Vesrion", 	"first");
/*	m_DefaultMessage->AddString("nick", "be_user");
	m_DefaultMessage->AddString("nick2", "be_user_2");
	
	m_DefaultMessage->AddString("name", "my name");
	m_DefaultMessage->AddString("userinfo","empty");
	m_DefaultMessage->AddString("server", "ca.undernet.org:6667");
	m_DefaultMessage->AddString("server", "irc.dal.net");
	for( int i = 0; i < int(sizeof(irc_event_color)/sizeof(irc_event_color[0])); i++)
		m_DefaultMessage->AddInt16("event_colors", irc_event_color[ i ]);
*/	
}

void Prefs::PrintToStream()
{
	::printf("\nDefault Settings\n");
	m_DefaultMessage->PrintToStream();
	
	::printf("\nUser Settings\n");
	m_SettingMessage->PrintToStream();
}

