#ifndef __Prefs_h__
#define __Prefs_h__

#include <Locker.h>
#include <GraphicsDefs.h>

const char	PREFS_FILE_NAME[] = "BARDAK_DEFAULT_FILE";

struct server_user_info
{
	bool	is_default;
	bool	is_ident;
	char	nick1[ 32 ];
	char	nick2[ 32 ];	
	char	server[128];
}; 

class Prefs:public BLocker
{
public:
			Prefs(const char* name = PREFS_FILE_NAME
					, const char* dir_name = NULL);
	virtual		~Prefs();
	
	void	LoadPrefs();
	void	StorePrefs();
	
	void	PrintToStream();
	BMessage* GetMsg(void)
	{
		return m_SettingMessage;
	}
protected:
	virtual void	MakeDefault();
	void			SetDefaultData(const char* name
									, const void* data
									, ssize_t numBytes);
	
private:
	BEntry*		m_PrefsEntry;
	BMessage*	m_SettingMessage;
	BMessage*	m_DefaultMessage;
};

#endif
