//License:
//    This license applies to this file, as well as any component of Santa's Gift Bag.
//    
//    Copyright Brian Tietz, all rights reserved.
//    
//    All source and compiled code included in the Santa's Gift Bag distribution is being made publicly
//    available and free to use in freeware and shareware products with a price under $25 (I believe that
//    shareware should be cheap). For shareware with a price higher than $25 or commercial products, please 
//    contact me to arrange a licensing agreement. I can be reached at:
//    
//    briant@timelinevista.com
//

#include <ScrollBar.h>
#include "Colors.h"
#include "ScrollViewCorner.h"


ScrollViewCorner::ScrollViewCorner(float Left,float Top)
: BView(BRect(Left,Top,Left+B_V_SCROLL_BAR_WIDTH,Top+B_H_SCROLL_BAR_HEIGHT),NULL,B_FOLLOW_RIGHT |
	B_FOLLOW_BOTTOM,B_WILL_DRAW)
{
	SetHighColor(BeShadow);
	SetViewColor(BeInactiveGrey);
}


ScrollViewCorner::~ScrollViewCorner()
{ }


void ScrollViewCorner::Draw(BRect Update)
{
	if(Update.bottom >= B_H_SCROLL_BAR_HEIGHT)
		StrokeLine(BPoint(0.0,B_H_SCROLL_BAR_HEIGHT),BPoint(B_V_SCROLL_BAR_WIDTH,B_H_SCROLL_BAR_HEIGHT));
	if(Update.right >= B_V_SCROLL_BAR_WIDTH)
		StrokeLine(BPoint(B_V_SCROLL_BAR_WIDTH,0.0),
			BPoint(B_V_SCROLL_BAR_WIDTH,B_H_SCROLL_BAR_HEIGHT-1.0));
}


