#include "IRCApp.h"
#include "ServerWindow.h"


#include "ChatWindow.h"
#include "PrivatWindow.h"

#include <ScrollBar.h>
#include <Menu.h>
#include <MenuItem.h>

#include "ServerView.h"

#include "StatusBarView.h"
#include "ToolBar.h"
#include "newButton.h"
#include <string.h>
#include "Prefs.h"
#include "irc_view.h"
#include <stdio.h>
#include <stdlib.h>
#include "Utils.h"
#include "constants.h"
#include "tips.h"
#include "newItem.h"

#include "irc_util.h"
#include <sys/stat.h>

//////////////////////////////////////
//int d_strnicmp(const char*str1, const char*str2);
//void d_tolower(char *str);
//////////////////////////
///////

tag_wnd_item * find_item_by_name(const BList *list, const char* sz_name)
{
	int32 i, count = list->CountItems();
	for( i = 0; i < count; i++)
	{
		tag_wnd_item* item = (tag_wnd_item*)list->ItemAt( i );
		if( strcasecmp ( sz_name, item->name) == 0)
		{
			return item;
		} 	
	}
	return NULL;
}

tag_wnd_item * find_item_by_wnd(const BList *list, const BWindow *pWnd)
{
	int32 i, count = list->CountItems();
	for( i = 0; i < count; i++)
	{
		tag_wnd_item* item = (tag_wnd_item*)list->ItemAt( i );
		if( pWnd == item->pWnd )
			return item;
	}
	return NULL;

}




//------------------------
ServerWindow::ServerWindow() 
	: BWindow(BRect(30, 30, 380, 200), "Server", 
        B_DOCUMENT_WINDOW,
        /*B_NOT_ZOOMABLE|B_OUTLINE_RESIZE|B_FRAME_EVENTS*/
        B_ASYNCHRONOUS_CONTROLS
        ) 
{
	m_irc = NULL;


//////  setings	font
	Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	
	m_srv_msg = new BMessage();
	BRect frame = Frame();
	if( !prefs->GetMsg()->HasRect("LastServerSize") )
  		prefs->GetMsg()->AddRect("LastServerSize", frame);
  	else
  	{	
		prefs->GetMsg()->FindRect("LastServerSize", &frame);
		MoveTo(frame.LeftTop());
		ResizeTo( frame.Width(), frame.Height() );
	}
	
	
	prefs->Unlock();
////////////////////	

	BRect rc = Bounds(); 
	rc.bottom = 26;
	new ToolBarView(this, rc);
	rc = Bounds(); 
	rc.top += 26;
	rc.bottom -= B_V_SCROLL_BAR_WIDTH; 
	/*ServerView *sv = */new ServerView(this, rc);
	rc.left--;
	rc.top = rc.bottom + 1;
	rc.bottom += B_V_SCROLL_BAR_WIDTH + 1;
	rc.right -= B_V_SCROLL_BAR_WIDTH - 0;
	StatusBarView *sbv = new StatusBarView(this, rc);
	sbv->SetResizingMode(B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM);
	sbv->AddList(&m_chat_list);	

	Show();
}
void ServerWindow::Quit(void)
{
	StatusBarView* sbv = (StatusBarView*)FindView("statusbar");
	sbv->AddFirst(NULL);
	sbv->AddList(NULL);
	RemoveChild( sbv );
	delete sbv;
	
	Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BRect frame = Frame();
	prefs->GetMsg()->ReplaceRect("LastServerSize", frame);
	prefs->Unlock();
	BWindow *pDeletedWnd;
	int32 i, count = m_chat_list.CountItems();
	for( i = 0; i < count; i++)
	{

		tag_wnd_item* item = (tag_wnd_item*)m_chat_list.ItemAt( 0 );
		if( !item )
			continue;
		pDeletedWnd = item->pWnd;
		((ChatWindow*)item->pWnd)->QuitBeforeSW();
		pDeletedWnd->Quit();
	}
	count = m_privat_list.CountItems();
	for( i = 0; i < count; i++)
	{
		tag_wnd_item* item = (tag_wnd_item*)m_privat_list.ItemAt( 0 );
		//item->pWnd->PostMessage(B_QUIT_REQUESTED, item->pWnd);
		if( !item )
			continue;		
		pDeletedWnd = item->pWnd;
		((PrivatWindow*)item->pWnd)->QuitBeforeSW();
		pDeletedWnd->Quit();		
	}
	
	if( m_irc )
	{
		Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
		prefs->Lock();
		prefs->GetMsg()->ReplaceMessage( m_irc->get_network_name(), m_srv_msg);
		prefs->Unlock();	
		m_srv_msg->MakeEmpty();
		RemoveHandler(m_irc);
		delete m_irc;
		m_irc = NULL;
	}
	//delete m_prefs;
	delete m_srv_msg;
	BWindow::Quit();
}
bool ServerWindow::QuitRequested()
{
 
  return true;
}
void ServerWindow::WindowActivated(bool active)
{
	BWindow::WindowActivated(active);
	m_dirty = false;
}

void ServerWindow::w_print(const char* str, int idx, bool end)
{

	if(!str)
		return;
	
	int32 len_str = strlen (str) + 1;
	if(len_str < 1)
	{
		return;
	}
	IRCView* irc_txt = (IRCView*)FindView("IRCView");
	if ( !irc_txt)
	{
		return;
	}
	irc_txt->w_print(str, idx);

	if ( end && str[ strlen( str ) ] != '\n' )
		irc_txt->w_print("\n", idx);
	m_dirty = !IsActive();
}
void ServerWindow::connect(void)
{
		newComboBox* cmb = (newComboBox*)FindView("server_combo");
		newButton * net_btn = (newButton*)FindView("ntn_network");
		Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
		if(m_irc)
		{
			w_print("<<<  stop connection >>>\n",  eInformation, true );
			cmb->Enable(true);
			net_btn->SetEnabled(true);
			RemoveHandler(m_irc);
			
			prefs->Lock();
			prefs->GetMsg()->ReplaceMessage( m_irc->get_network_name() , m_srv_msg);
			prefs->Unlock();				
			m_srv_msg->MakeEmpty();
			irc* tem_irc = m_irc;
			m_irc = NULL;
			try
			{
				delete tem_irc;			
			}catch(...)
			{/*jopa dela*/
				w_print( "try()/catch() instruction\n" , eError_Message );
			}
				
		  	update_title();		  	
			bmpButton *btn = (bmpButton*)FindView("Connect");
			if(btn)
				btn->ChangeBmp( 31, -1 );
			btn->Message()->ReplaceString( STR_TTIPS, "Connect");
			ServerView* sv = (ServerView*)FindView("ServerView");
			sv->ActivateProgress(0);
			return;
		}
		cmb->Enable(false);
		net_btn->SetEnabled(false);
		const char* sz_txt =  cmb->GetString();
		server_user_info u_info;
		u_info.is_default = true;
		strcpy( u_info.server, sz_txt );
		
		const server_user_info *cb_data = (const server_user_info*)cmb->GetDataPtr();
		if( cb_data )
			if( !cb_data->is_default && strcmp( cb_data->server, sz_txt ) == 0)
				memcpy( &u_info, cb_data, sizeof( u_info) );			
		prefs->Lock();
		prefs->GetMsg()->ReplaceString("last_network", net_btn->Label() );
		// update last_network
		BMessage net_msg;
		if( prefs->GetMsg()->FindMessage( "IRCNetworks", &net_msg) == B_OK)
		{
			int32 count = 0;
			type_code type_found;
			net_msg.GetInfo( "Network_names", &type_found,  &count);
			const char *sz_net_name;
			for( int32 i = 0; i < count; i++)
			{			
				if( net_msg.FindString( "Network_names", i, &sz_net_name) != B_OK )
					continue;
				int32 count2 = 0;
				net_msg.GetInfo( sz_net_name , &type_found,  &count2 );
				for( int32 j = 0; j < count2; j++)
				{
					const server_user_info  *pptr = NULL;
					ssize_t bytes;
					if( net_msg.FindData(sz_net_name, B_RAW_TYPE, j, (const void**)&pptr, &bytes) != B_OK)
						continue;
					if( strcmp( u_info.server, pptr->server) == 0 )	
					{
						memcpy( &u_info, pptr, sizeof( u_info) );
						break;//updated
					}	
				}	
			}		
		}
		
		m_irc = new irc((BLooper*)this);
		AddHandler(m_irc);
		m_irc->set_user_info( &u_info, net_btn->Label() );
	  	bool use_socks5 = false;
		prefs->GetMsg()->FindBool( "use_socks5", &use_socks5);
		prefs->Unlock();		
		if (use_socks5)// setup socks5
		{
			prefs->Lock();
			const char *socks5_host;
			prefs->GetMsg()->FindString( "socks5_host", &socks5_host); 
			const char *socks5_port;
			prefs->GetMsg()->FindString( "socks5_port", &socks5_port);
			short s5_port = atoi( socks5_port );
			const char *socks5_user;
			prefs->GetMsg()->FindString( "socks5_usr_name", &socks5_user);
			const char *socks5_password;
			prefs->GetMsg()->FindString( "socks5_password", &socks5_password);			
			m_irc->set_socks5_info( socks5_host, s5_port, socks5_user, socks5_password);
			prefs->Unlock();
		}
	  	update_title();
	  		
		w_print("<<<  starting connection >>>\n", eInformation );
		m_irc->start();
		bmpButton *btn = (bmpButton*)FindView("Connect");
		if(btn)
		 	btn->ChangeBmp( 32, -1 );
		btn->Message()->ReplaceString( STR_TTIPS, "Disconnect"); 	
		prefs->Lock();
		if( !prefs->GetMsg()->HasMessage( m_irc->get_network_name() ) )
		{
			m_srv_msg->MakeEmpty();
			prefs->GetMsg()->AddMessage( m_irc->get_network_name(), m_srv_msg );
		}
		prefs->GetMsg()->FindMessage( m_irc->get_network_name(), m_srv_msg);					
		prefs->Unlock();				
}
void ServerWindow::update_title(void)
{
	char sz_title[256] = "Server";
	if( m_irc )
	{
		const server_user_info *info = m_irc->get_user_info();
		sprintf(sz_title, "%s <%s>", info->server, m_irc->get_cur_nick() );
	}	
	if( strcmp( Title(), sz_title) != 0 )
		SetTitle(sz_title); 

}
void ServerWindow::msg_to_irc(BMessage* msg)
{
	if(!m_irc)
	{
		w_print("no connection\n",  eError_Message );
		return;
	}
	
	if( msg->HasString("cmd") )
	{	
		const char *sz_cmd = NULL;
		msg->FindString("cmd", &sz_cmd);
		if( strncasecmp( sz_cmd, "/LIST", 5) == 0)
		{
			ServerView* sv = (ServerView*)FindView("ServerView");
			sv->ActivateProgress(1 );
		}		
	}		
	PostMessage (msg,  m_irc);
}
void ServerWindow::do_msg(BMessage* message)
{
	int16 ret_code = -1;
	const char *from = NULL;
	const char *command = NULL;
	const char *c_params = NULL;
	char *params = NULL;
	bool to_print = true;
	char *ptr= NULL,*ptr1 = NULL, *ptr2 = NULL, *ptr3 = NULL, *ptr4 = NULL;
	
	ChatWindow* wchat = NULL;
	PrivatWindow* wprivat = NULL;
	
	if (message->HasString ("params") )
		message->FindString ("params", &c_params);
	if(c_params)
	{	
		params = strdup( c_params );
		int len = strlen(params);
		if ( params[ len - 1] == '\n')
			params[ len - 1] = '\0';
	}
	
	if ( message->HasInt16 ("code") )
	{
		message->FindInt16 ("code", &ret_code);
		if( ret_code >= 400 && ret_code <= 599 && ret_code != 433 ) // all errors
		{
			if( params_get3( params, &ptr1, &ptr2, &ptr3 ) )
			{	w_print( ptr2 , eError_Message );
				w_print( ptr3 , eError_Message , true);	
			}
			else
			{
				char sz_err[128];
				sprintf( sz_err, "%s %s %s\n", from,  command, params);
				w_print( sz_err , eError_Message );
			}					
			to_print = false;
			goto end;
		}

		switch (ret_code)
		{
			case 433:
			{ 
				if( !m_irc )
					goto end;
					
				char sz_cmd[128];
				sprintf( sz_cmd, "%s\n", params);
				w_print( sz_cmd , eError_Message );				
				BMessage msg ('irc');
				const char* sz_nick;
				Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
				prefs->Lock();
				prefs->GetMsg()->FindString("nick", &sz_nick);
				if( sz_nick && !strcmp( m_irc->get_cur_nick(), sz_nick) )
					prefs->GetMsg()->FindString("nick2", &sz_nick);				
				prefs->Unlock();
				
				if( !sz_nick || !strcmp( m_irc->get_cur_nick(), sz_nick) )
				{
					w_print( "type /nick new_nick\n" , eError_Message );
					to_print = false;
					goto end;	
				}					
				sprintf(sz_cmd, "/NICK %s", sz_nick);
				msg.AddString ("cmd", sz_cmd);
				PostMessage (&msg,  m_irc);
				sprintf( sz_cmd, "set nick : %s\n", sz_nick);
				w_print( sz_cmd , eInformation );
				to_print = false;
				goto end;
			}break;
			case 321:
			{
				ServerView* ptr = (ServerView*)FindView("ServerView");
				if ( !ptr )
					break;
				ptr->RemoveAll();
				to_print = false;
				goto end;
			}break;
			case 322:
			{
				if( !m_irc )
					goto end;
				
				ServerView* sv = (ServerView*)FindView("ServerView");
				sv->AddItem( params + strlen(m_irc->get_cur_nick()) + 1  ); 
				//sv->ProgressStep();				
				to_print = false;
				//snooze(10 * 1000); 
				goto end;
			}break;
			case 323://end of /list
			{
				ServerView* sv = (ServerView*)FindView("ServerView");
				sv->ActivateProgress(0);
				ptr = strchr( params, ':' );
				if( ptr && ++ptr)
				{
					to_print = false;
					w_print( ptr , eInformation, true);
				}	
				goto end;
			}break;
			case 332:
			{
				ptr = strchr(params, ' ');
				if(!ptr)
					break;
				ptr++;
				ptr2 = strchr(ptr, ':');
				if(!ptr2)	
					break;
				*ptr2 = '\0';
				wchat = find_chat( ptr );
				if(wchat)
				{
					wchat->PostMessage(message, (BHandler*)wchat);
					to_print = false;
				}
				*ptr2 =	 ':';				
			}
			break;
			case 333:
			{
				ptr1 = ptr2 = ptr3 = ptr4 = NULL;
				if( !params_get4( params, &ptr1, &ptr2, &ptr3, &ptr4) )
					break;
				wchat = find_chat( ptr2 );
				if(wchat)
				{
					wchat->PostMessage(message, (BHandler*)wchat);
					to_print = false;
					goto end;
				}
				time_t t = ( time_t ) atol ( ptr4 );
    				struct tm *tim;
    				tim = localtime( &t );
				char *str_time = strdup( asctime(tim) );
				w_print( ptr2,  eMode );
				w_print( " TOPIC created by <",  eMode );
				w_print( ptr3,  eMode );
				w_print( "> ",  eMode );
				w_print( str_time, eMode, true );
				delete str_time;				
			}break;
			case 351: // version replay
			{
				ptr = params + strlen(m_irc->get_cur_nick());
				ptr2 = strchr( params, ':' );
				if( ptr2 )
				{
					*ptr2 = '\0';
					ptr2++;
				}
				w_print( "*** Server Version: ", eInformation );
				w_print( ptr, eInformation, true );				
								
				to_print = false;
				goto end;
			}
			break;
			case 353:
			{
				ptr = strchr(params, '#');
				if(!ptr)
				{
					ptr = strchr(params, '$');
					if(!ptr)
						break;
				}
					
				//ptr+=2;
				ptr2 =  strchr(params, ' ');
				if(!ptr2)
					break;
				*ptr2 = '\0';
				wchat = find_chat( ptr );
				*ptr2 = ' ';
				if(!wchat  )
					break;
				wchat->PostMessage(message, (BHandler*)wchat);	
				to_print = false;
				goto end;
			}break;
			case 366:
			{
				ptr = strchr(params, ' ');
				if(!ptr)
					break;
				wchat = find_chat( ptr+1 );
				if(!wchat)
					break;
				wchat->PostMessage(message, (BHandler*)wchat);	
				to_print = false;
				goto end;
			}break;
			
			case 0:		case 4:
				w_print( params , eServer_Notice, true);
				to_print = false;
				goto end;
			break;
			
			case 1: 	case 2:	case 3:
			case 5:		case 203:	case 204:
			case 206:	case 211:	case 251:
			case 252:	case 253:	case 254:
			case 255:	case 256:	case 375:			
			case 265:	case 266:	case 371:
			case 372:	//case 376:			
			{
				update_title();
				if( !m_irc )
					goto end;
				
				ptr = params + strlen(m_irc->get_cur_nick());//strchr( params, ':');
				if( !ptr )
					break;
				ptr++;	
				if( ptr && *ptr == ':' )
					ptr++;
				w_print( ptr , eServer_Notice, true);
				to_print = false;
				/*if( ret_code == 376)
				{
					
				}*/
				goto end;
			}break;
			
			
			case 219://end of /stats
			case 376://end of /motd
			case 262://end of /trace
			case 374://end of /info
			case 7:   //End of /map
			case 315: //End of /WHO list.
			case 318: //End of /WHOIS list.
			{
				ptr = strchr( params, ':');
				ptr++;	
				w_print( ptr , eInformation, true);
				to_print = false;
				goto end;
			}
			break;
			case 302:
			{
				ptr = strchr( params, ':');
				w_print( "HOST " , eServer_Notice );
				w_print( ptr + 1 , eServer_Notice, true );
				to_print = false;
				goto end;
			}break;
			case 324:
			{
				//dipa #Russian +tnr 
				ptr1 = ptr2 = ptr3 = NULL;
				if( !params_get3( params, &ptr1, &ptr2, &ptr3 ) )
					break;
				to_print = false;
				wchat = find_chat( ptr2 );
				if( wchat )
				{
					wchat->PostMessage(message, (BHandler*)wchat);
					goto end;				
				}
				w_print( ptr2, eMode  );
				w_print( " has MODE ", eMode );
				w_print( ptr3,  eMode, true );
				goto end;								
			}break;
			case 329:
			{
				//dipa #minsk 930102162
				ptr1 = ptr2 = ptr3 = NULL;
				if( !params_get3( params, &ptr1, &ptr2, &ptr3 ) )
					break;
				to_print = false;
				wchat = find_chat( ptr2 );
				if( wchat )
				{
					wchat->PostMessage(message, (BHandler*)wchat);
					goto end;				
				}				
				
				time_t t = ( time_t ) atol ( ptr3 );
    				struct tm *tim;
    				tim = localtime( &t );
				char *str_time = strdup( asctime(tim) );
				w_print( ptr2,  eMode );
				w_print( " created at ",  eInformation );
				w_print( str_time, eMode, true );
				delete str_time;
				goto end;
			}break;
			case 221:
			{
				ptr = strchr( params, ' ');
				if( !ptr )
					break;
				*ptr = '\0'; ptr++;
				w_print( params, eMode );
				w_print( " has MODE ", eMode );	
				w_print( ptr, eMode, true );
				///1/////////////////////////
				int len = strlen( ptr );
				for( int i = 0; i < len; i++)
				{
					char sz_view[] = "_X_";
					sz_view[1] = ptr[i];
					newButton *bt = (newButton*)FindView( sz_view );
					if( bt )
					{
						bt->Check( (ptr[ 0 ] == '+') );				
						char sz_cmd[128];
						sprintf( sz_cmd, "/MODE $nname %c%c", (ptr[ 0 ] == '+') ? '-' : '+', ptr[i] );						
						bt->Message()->ReplaceString( "cmd", sz_cmd );
					}	
				}				
				///1///////////////////////
				to_print = false;
				goto end;
			}break;
			case -1:
				goto end;
		}// code
		
	}
	else ret_code = -1;
	
	if (message->HasString ("from") )
		message->FindString ("from", &from);				
	if ( message->FindString ("command") )
		message->FindString ("command", &command);
	
	if ( params ) 
		wchat = find_chat( params );
	if(from)
		wprivat = find_privat( from );
	
	if ( command)
	{
	 	if( !m_irc )
			goto end;
				
	 	if (strcmp(command, "JOIN") == 0)
	 	{
			wchat = find_chat( params + 1);
			if( strcmp(from, m_irc->get_cur_nick()) == 0)
			{			
				if ( wchat == NULL)
					wchat = new ChatWindow(this,  params + 1);	
				
				BButton *btn = (BButton*)FindView("ntn_network");
				wchat->m_network_name = btn->Label();					
				BMessage msg('irc');
				char to_cmd[ 128 ];
				sprintf( to_cmd, "/MODE %s", params + 1 );
				msg.AddString("cmd", to_cmd );							
				msg_to_irc(&msg);
				to_print = false;						
			}
			else
			;//	wchat->PostMessage(message, wchat);
		}
		
		if (strcmp(command, "QUIT") == 0 || strcmp(command, "NICK") == 0)
		{
			to_print = !to_all_chats(message);
			update_title();
			//to_print = false;
		}
		else
			if (wchat)
			{
				wchat->PostMessage(message, (BHandler*)wchat);
				to_print = false;
				goto end;
			}

		if( strcmp(command, "PRIVMSG") == 0 && wchat == NULL && wprivat == NULL)
		{
			ptr = strchr(params, ':');
			if( ptr )
			{
				ptr--;
				*ptr = '\0';
				if( strcasecmp(params, get_nick() ) == 0)
				{
					wprivat = new PrivatWindow(this,  from);				
					to_print = false;
				}
				*ptr = ' ';	
			}
		}
		if( strcmp(command, "NOTICE") == 0)
		{
			w_print( strchr( params, ':') + 1 , eNotice, true);
			to_print = false;
		}
		

		if(wprivat)
		{
			wprivat->PostMessage(message, (BHandler*)wprivat);	
			to_print = false;
		}
		if( strcmp(command, "MODE") == 0)
		{
			w_print( from , eMode );
			w_print( " has MODE ", eMode );
			ptr = strchr( params, ':') + 1;
			w_print( ptr, eMode, true );
			///1/////////////////////////////
			int len = strlen( ptr );
			for( int i = 1; i < len; i++)
			{
				char sz_view[] = "_X_";
				sz_view[1] = ptr[i];
				newButton *bt = (newButton*)FindView( sz_view );
				if( bt )
				{
					bt->Check( (ptr[ 0 ] == '+') );				
					char sz_cmd[128];
					sprintf( sz_cmd, "/MODE $nname %c%c", (ptr[ 0 ] == '+') ? '-' : '+', ptr[i] );
					bt->Message()->ReplaceString( "cmd", sz_cmd );
				}
			}				
			///1/////////////////////////////
			to_print = false;
		}	
	 }
	
end:
	if(ret_code == -1 && from == NULL && command == NULL && params == NULL)
		to_print = false;
	if( to_print )
	{
		//w_print(from, eNick );	
		//w_print(command, eNote );
		char sz_code[32];
 		sprintf (sz_code, "[%i]", ret_code);				
 		w_print(sz_code , eMode );
		w_print(params , eNormal_Txt, true );	
	}	
 
	if ( params ) 
		delete ( params );
}
ChatWindow* ServerWindow::find_chat(const char* sz_chat)
{
	ChatWindow* wchat = NULL;
	char *sz = strdup (sz_chat);
	
	char *ptr = strchr(sz, ' ');
	if( ptr )
		*ptr = '\0';
	
	tag_wnd_item* item = find_item_by_name( &m_chat_list, sz);
	if(item)
		wchat = (ChatWindow*)item->pWnd;

	delete (sz);
	return wchat;
}
PrivatWindow* ServerWindow::find_privat(const char* sz_privat)
{
	PrivatWindow* wprivat = NULL;
	tag_wnd_item* item = find_item_by_name( &m_privat_list, sz_privat);
	if(!item)
		return NULL;
	wprivat = (PrivatWindow*)item->pWnd;
	return wprivat;
}

bool ServerWindow::to_all_chats(BMessage *msg)
{
	int32 count = m_chat_list.CountItems( );
	for( int32 i = 0; i < count; i++)
	{
		tag_wnd_item* item = (tag_wnd_item*)m_chat_list.ItemAt( i );
		item->pWnd->PostMessage(msg, item->pWnd);
	}
	return (bool)count;
}

void ServerWindow::make_favorites_menu(void)
{
	bmpButton* btn = (bmpButton*)FindView( "channels");
	btn->Check( true );
	BRect rc =  btn->Bounds();
	btn->ConvertToScreen(&rc);
			
	BPopUpMenu* popup = new BPopUpMenu("channels_menu", false);//, false );
	popup->SetFont(be_plain_font);
	
	//////  setings	
	Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();
	
	
	char sz_cmd[128];
	
	for( int i = 0; ; i++ )
  	{
  		const char* sz_chat;
  		if( pref_msg->FindString( "def_chats", i , &sz_chat )!= B_OK)
			break;
		sprintf( sz_cmd, "/JOIN %s", sz_chat);
		BMessage *msg = new BMessage( 'itm' );
		msg->AddString( "cmd", sz_cmd );
		popup->AddItem( new BMenuItem( sz_chat, msg) );	
  	}		
	prefs->Unlock();
	//popup->AddSeparatorItem();
	//popup->AddItem( new BMenuItem( "Edit...", NULL) );		
	
	popup->SetTargetForItems( this );
	popup->Go( BPoint( rc.left + 1, rc.bottom + 1) , true, true, rc); 

	delete popup;
	btn->Check( false );
}
#include <SupportKit.h>
void ServerWindow::MessageReceived(BMessage* message)
{

 	switch(message->what)
	{
		case 'ntr'://'umg':
		{
			BMessage *l_target;
			if( message->FindPointer("target", (void**)&l_target) != B_OK)
				break;
			switch( l_target->what)
			{
				case 'umg':
				{	
					BTextControl* mms = (BTextControl*)FindView("message");
					const char* sz_txt =  mms->Text();
					w_print( sz_txt , eOwn_Txt , true );
					BMessage msg('irc');
					msg.AddString("cmd", sz_txt);							
					mms->SetText(NULL);
					msg_to_irc(&msg);
					
				}break;
				case 'stsp':
					connect();
				break;
			}
		}	break;	
		case 'sort':
		{
			int16 type;
			message->FindInt16( "sort_type" , &type );
			BListView* ptr = (BListView*)FindView("channel_list");
			BLocker *ptr_lock = dynamic_cast<BLocker*>(ptr);
			ptr_lock->Lock();
			chanelItem* itm = (chanelItem*)ptr->ItemAt(0);
			itm->set_cmp_type( type );
			ptr->SortItems( chan_cmp );	
			ptr_lock->Unlock();
		}break;
		case 'itm':
		{
			message->what = 'irc';
			msg_to_irc(message);
		}break;
		case 'itmU':
		{
			if( m_irc )
			{
				message->what = 'irc';
				const char *sz_cmd;	
				message->FindString( "cmd", &sz_cmd);
				BString bstr( sz_cmd );
				bstr.Replace( "$nname", m_irc->get_cur_nick(), 6 ,0 );
				message->ReplaceString( "cmd", bstr.String() );
				msg_to_irc(message);
			}	
		}break;
		
		case 'stsp': 		
		{
			if( message->HasBool("continue") )
				connect();
			else	
			{	if(m_irc)
					connect();
			}		
		}
		break;
		
		case WM_ACTIVATE:
         		Activate(true);
       	break; 
	
		case 'irc':
			if( m_irc )
				do_msg(message);
		break;
		
		case 'inf':
		{
			const char* str;
			if ( !message->FindString ("txt", &str))
			{
				bool this_error = false;
				message->FindBool( "this_error", &this_error);
				w_print(str,  this_error ? eError_Message : eInformation );
			}
		} break;
	
		case 'chan':
		{
			make_favorites_menu();
		} break;
	}

   BWindow::MessageReceived(message);
}
