#ifndef _SERVERWINDOW_H
#define _SERVERWINDOW_H
#include "irc.h"
#include <Window.h>
#include "DirtyWnd.h"

class ChatWindow;
class PrivatWindow;


class ServerWindow : public BWindow, public DirtyWnd
{
public:

	ServerWindow();
	virtual void MessageReceived(BMessage* message);
	virtual bool QuitRequested();
	virtual void Quit(void);
	virtual void WindowActivated(bool active);
	
// messages
//	BMessage		m_chats;
//	BMessage		m_privat;
	BList			m_chat_list;
	BList			m_privat_list;

	void msg_to_irc(BMessage* msg);

//	BMessage*	m_prefs;
	const char *get_nick(void)
	{
		if(m_irc)
			return m_irc->get_cur_nick();
		return NULL;
	}
	const char* get_server(void)
	{
		if(m_irc)
			return m_irc->get_server_name();
		return NULL;
	}
	const BMessage* get_prefs(void){ return m_srv_msg; }
protected:
	irc*			m_irc;	
	BMessage *m_srv_msg;
	ChatWindow* find_chat(const char* sz_chat);
	PrivatWindow* find_privat(const char* sz_privat);
	void w_print(const char* srt, int color, bool end = false);
	void connect(void);
	void do_msg(BMessage* message);


	bool to_all_chats(BMessage *msg);
	void make_favorites_menu(void);
	void update_title(void);
	int32	m_count_canels;
};
#define WM_ACTIVATE		'003'
#endif