#include "SettingsView.h"
#include "newButton.h"
#include "constants.h"
#include <Box.h>
//#include <Font.h>
#include <CheckBox.h>
#include <ScrollView.h>
#include <MenuItem.h>
#include <Menu.h>
#include <MenuField.h>
#include "newItem.h"
#include "Prefs.h"
#include "IRCApp.h"

#include "edit_list_item.h"
#include "ListEditCtl.h"

#include <string.h>
#include <stdio.h>
#include <malloc.h>
#include <TabView.h>

////////////////////////////////////
//////
//////
BMessage* SettingsTab::m_prefs = NULL;


////////////////////
GeneralTab::GeneralTab(BRect rect, const char* name)
  :BView(rect, name,  
    B_FOLLOW_ALL_SIDES, 
	B_WILL_DRAW)
{
	sprintf(m_name, "%s_active_tab", name);
	rect.left --;
	rect.right --;
	rect.top += 2;
	m_tbv = new BTabView(rect, "gen_tab_view",B_WIDTH_FROM_WIDEST,
	                            B_FOLLOW_ALL, B_WILL_DRAW);
	AddChild(m_tbv);
	//m_tbv->SetTabHeight( 16 ); 
	//SET_VIEW_COLORS(m_tbv);	
}
void GeneralTab::AddTab(BView* vt)
{
	m_tbv->AddTab( vt,NULL);
}
void GeneralTab::AttachedToWindow(void)
{	
	Window()->Lock();
	SETUP_VIEW_COLORS;
	int16 itab = 0;
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	BMessage *pref_msg = prefs->GetMsg();
	prefs->Lock();
	
	if( pref_msg->HasInt16( m_name ) )
		pref_msg->FindInt16( m_name,  &itab);
	m_tbv->Select( (int32)itab);	
	prefs->Unlock();

	Window()->Unlock();
	
	BView::AttachedToWindow();
}
void GeneralTab::DetachedFromWindow()
{
	Window()->Lock();
	int16 itab = m_tbv->Selection();
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	BMessage *pref_msg = prefs->GetMsg();
	prefs->Lock();

	if( pref_msg->HasInt16( m_name ) )
		pref_msg->ReplaceInt16( m_name, itab );
	else
		pref_msg->AddInt16( m_name, itab );
	prefs->Unlock();
	Window()->Unlock();
	BView::DetachedFromWindow();	
}
void GeneralTab::OnOk( void )
{
	int32 i, count = m_tbv->CountTabs();
	for( i = 0; i < count; i++)
	{
		SettingsTab *tab = dynamic_cast<SettingsTab*>(m_tbv->ViewForTab( i ));
		tab->OnOk();
	}
}
void GeneralTab::OnCancel( void )
{
	int32 i, count = m_tbv->CountTabs();
	for( i = 0; i < count; i++)
	{
		SettingsTab *tab = dynamic_cast<SettingsTab*>(m_tbv->ViewForTab( i ));
		tab->OnCancel();
	}
}
void GeneralTab::OnClose(void)
{
			
	int32 i, count = m_tbv->CountTabs();
	for( i = 0; i < count; i++)
	{
		SettingsTab *tab = dynamic_cast<SettingsTab*>(m_tbv->ViewForTab( i ));
		tab->OnClose();
	}
	
}



/////////////////////////////
///////
UserViewTab::UserViewTab(BRect rect)
  :BView(rect, "User",  
    B_FOLLOW_ALL_SIDES, 
	B_WILL_DRAW /*| B_FRAME_EVENTS*/)
{
	BRect rc = rect;
	rc.InsetBy(5, 5);
	rc.bottom -= 60;
	BBox *box = new BBox(rc,"info");
	box->SetLabel("Default User Info");
	AddChild(box);
	const char* nick;
	m_prefs->FindString("nick", &nick);
	BTextControl *_nick = new BTextControl(BRect(10,15, rc.Width()/1.5 - 1 ,25), "nick", "Nicknames:", nick,NULL);
	_nick->SetDivider(70);
	box->AddChild(_nick);
	BTextView *tv = _nick->TextView();
	tv->SetMaxBytes( 30 );
	m_prefs->FindString("nick2", &nick);
	_nick = new BTextControl(BRect(rc.Width()/1.5 + 1, 15, rc.Width() - 10 ,25),"nick2", NULL, nick, NULL);
	box->AddChild(_nick);
	tv = _nick->TextView();
	tv->SetMaxBytes( 30 );
	
	BRect rc_tmp = _nick->Frame();
	 
	const char* name;
	m_prefs->FindString("name", &name);
	_nick = new BTextControl(BRect(10,rc_tmp.bottom+3, rc.Width() - 10, 25),"name","Full Name:", name, NULL);
	_nick->SetDivider(70);
	box->AddChild(_nick);
	 
	rc_tmp = _nick->Frame();
	const char* userinfo;
	m_prefs->FindString("userinfo", &userinfo);  
	_nick = new BTextControl(BRect(10,rc_tmp.bottom+3, rc.Width() - 10,25),"userinfo","User Info:", userinfo, NULL);
	_nick->SetDivider(70);
	box->AddChild(_nick);
	rc_tmp = _nick->Frame();
	 
	box->ResizeTo(rc.Width(), rc_tmp.bottom - rc.top + 10 );	
	rc = box->Frame();
	 
	rc.top = rc.bottom + 10;
	rc.bottom = rect.bottom - 34;
	box = new BBox(rc,"modes");
	box->SetLabel("Default User Modes");
	AddChild(box);
	 
	rc.top += 6;
	rc.bottom = rc.top + 14;
	rc.left += 5;
	 
	//  BCheckBox *check = new BCheckBox(BRect(10,15,100,25),"invisible","Invisible",NULL);
	//  box->AddChild(check);
	 
	rc = Bounds();
	rc.left += 4;
	rc. top = rc.bottom - 32;
	int16  cur_type = B_MS_WINDOWS_CONVERSION;
	m_prefs->FindInt16("encoding", &cur_type);		
		
	BMenu *menu = new BMenu("en");
	int count = sizeof(sc_en) / sizeof(sc_en[0]);
	for( int i = 0; i < count; i++)
	{
		BMenuItem *mitem = new BMenuItem(sc_en[ i ].name , NULL);
		if( sc_en[ i ].type == cur_type )
			mitem->SetMarked( true );
		menu->AddItem(  mitem );
	}
	menu->SetTriggersEnabled(false);
	menu->SetLabelFromMarked(true);
	
 	BMenuField *menu_fld = new BMenuField( rc, "Encoding", "Encoding", menu);  
 	menu_fld->SetDivider( StringWidth("Encoding") + 4);
 	//box->AddChild(menu_fld);
 	AddChild(menu_fld);
	//menu->SetTargetForItems(this);
}
void UserViewTab::AttachedToWindow(void)
{	
	SETUP_VIEW_COLORS;
	
	BView::AttachedToWindow();
}

void UserViewTab::OnOk( void )
{
	BView* bv = FindView("nick");
	const char *sz_txt;

	if(bv)
	{
		sz_txt =  ((BTextControl*)bv)->Text();
		m_prefs->ReplaceString("nick", sz_txt);
	}
	bv = FindView("nick2");
	if(bv)
	{
		sz_txt =  ((BTextControl*)bv)->Text();
		m_prefs->ReplaceString("nick2", sz_txt);
	} 
	bv = FindView("name");
	if(bv)
	{
		sz_txt =  ((BTextControl*)bv)->Text();
		m_prefs->ReplaceString("name", sz_txt);
	} 
	bv = FindView("userinfo");
	if(bv)
	{
		sz_txt =  ((BTextControl*)bv)->Text();
		m_prefs->ReplaceString("userinfo", sz_txt);
	}     

	BMenuField *menu_fl = (BMenuField*)FindView("Encoding");
	BMenu *menu = menu_fl->Menu();
	
	BMenuItem *mitem = menu->FindMarked();
	int32 idx = menu->IndexOf(mitem);
	m_prefs->ReplaceInt16("encoding", (int16)sc_en[ idx ].type); 
}


/////////////////////////////
///////
//#include "tips.h"
#define DY_IDENT	50
#define DX_DIV		1.75
ServersViewTab::ServersViewTab(BRect rect)
  :BView(rect, "Servers",  
    B_FOLLOW_ALL_SIDES, 
	B_WILL_DRAW /*| B_NAVIGABLE | B_NAVIGABLE_JUMP*/)

{

	BRect rc = Bounds();
	m_cur_item = NULL;
	*m_sz_network = '\0';
	
	//rc.right = rect.Width()/2.5;
	rc.InsetBy( 5, 0 );
	rc.bottom -= DY_IDENT;
	rc.bottom -= 8;
	rc.right -= 2;
	BBox *box = new BBox( rc );
  	//box->SetLabel("IRC Server");
  	AddChild( box );

	rc = box->Bounds();
	rc.InsetBy( 10, 8 );
	rc.top += 18;
	rc.right = (rc.left + rc.right)/DX_DIV;

	ListEditCtl *el = new ListEditCtl( rc);
	el->SetColumName( "Server:port");
	box->AddChild( el );
	BListView *lv = (BListView*)FindView( "cmd_list" );
	lv->SetSelectionMessage(new BMessage(LV_SELCHANGE));
	  	
 	BMenu *menu = new BMenu("m_svrs_");
 	menu->SetTriggersEnabled(false);
 	menu->SetLabelFromMarked(true);
 	
  	BMenuField *menu_fld = new BMenuField( rc, "mf_server", "Networks: ", menu);  
  	menu_fld->SetDivider( StringWidth("Networks: ") + 4);
  	box->SetLabel( menu_fld );
   
  	BMessage net_msg;
	if( m_prefs->FindMessage("IRCNetworks", &net_msg) == B_OK )
	{
		int32 count = 0;
		type_code type_found;
		net_msg.GetInfo( "Network_names", &type_found,  &count);
		
		for( int32 i = 0; i < count; i++)
		{
			const char *sz_name;
			if( net_msg.FindString( "Network_names", i, &sz_name) != B_OK )
				continue;
			BMessage *menu_msg = new BMessage('mnet');
			menu_msg->AddString("net_name", sz_name);
			BMenuItem *mitem = new BMenuItem( sz_name , menu_msg );
 			if( !i )
 			{
 				//strcpy( m_sz_network, sz_name);
 				mitem->SetMarked( true );
 				
 				FillControls( sz_name );
 			}	
 			menu->AddItem(  mitem ); 			
			}
	}
  	
	//lv->AddItem(new edit_item( ));

	rc = box->Bounds();
	rc.InsetBy( 10, 8 );
	rc.top += 6;
	rc.left = (rc.left + rc.right)/DX_DIV;
	rc.OffsetBy( 6, 0 );
	rc.right -= 4;
	BBox *box2 = new BBox( rc );
  	box2->SetLabel("Logon User Info");
  	box->AddChild( box2 );
  	int h = 10;
  	BCheckBox *ch_bx = new BCheckBox( BRect( 6, h , rc.Width() - 8 , 25), "udui", "Use Default User Info", new BMessage('udui') );
  	box2->SetLabel( ch_bx );
  	ch_bx->SetEnabled( false );
  	
  	h+= (14 + 6 );
  	BTextControl *_nick = new BTextControl(BRect( 6, h , rc.Width() - 8 , 25), "nick", "Nick.", NULL,NULL);
  	_nick->SetDivider(30);
  	box2->AddChild(_nick);
  	_nick->SetEnabled( false );
  	BTextView *tv = _nick->TextView();
  	tv->SetMaxBytes( 30 );	
	
	h+= (14 + 8 );
	_nick = new BTextControl( BRect( 6,  h  , rc.Width() - 8 , 25), "nick2", "Alt.", NULL,NULL);
  	_nick->SetDivider(30);
  	_nick->SetEnabled( false );
  	box2->AddChild(_nick);
  	tv = _nick->TextView();
  	tv->SetMaxBytes( 30 );	
	
	h+= (14 + 10 );
	ch_bx = new BCheckBox( BRect( 6, h , rc.Width() - 8 , 25), "uidt", "Use Ident Server", new BMessage('uidt') );
  	box2->AddChild( ch_bx );
  	ch_bx->SetEnabled( false );

	
	// box view
  	rc = Bounds();
     
	rc.InsetBy(5,10);
	rc.top = rc.bottom - (DY_IDENT - 6);
	box = new BBox( rc );
  	box->SetLabel("Ident Server");
  	AddChild( box );
  	rc = box->Bounds();
  	rc.top += 16;
  	rc.left +=6;
  	rc.bottom -=2;
  	rc.right = rc.left + 100;
  	
  	const char *sz_ident;
	m_prefs->FindString("ident_name", &sz_ident );
			  	
  	BTextControl *tc = new BTextControl( rc, "_ident_", "Ident:", sz_ident, NULL);
	tc->SetDivider( 34 );
	box->AddChild( tc );
	rc.OffsetBy( 110, 0 );
	rc.right -= 10;
	m_prefs->FindString("ident_server", &sz_ident );
	tc = new BTextControl( rc, "_serv_", "Server:", sz_ident, NULL );
	tc->SetDivider( 44 );
	box->AddChild( tc );
  	rc.right += 10;
  	rc.OffsetBy( 100, 0 );

	bool is_active;
	m_prefs->FindBool( "active_ident" , &is_active );
  	BCheckBox *chk = new BCheckBox( rc,"_active_","Active Server", new BMessage('idmn'));
	chk->SetValue( is_active ? B_CONTROL_ON : B_CONTROL_OFF );
	box->AddChild( chk );
  
}
void ServersViewTab::UpdatePrefs(const char* psz_name)
{
	BMessage net_msg;
	BListView *lv = (BListView*)FindView( "cmd_list" );
	
	int32 j = 0, count2 = 0;
	
	if( m_prefs->FindMessage("IRCNetworks", &net_msg) != B_OK )
		return;
	
	net_msg.RemoveName(psz_name);

  	((edit_listView*)lv)->StopEdit();
	
	UpdateUserPrefs();
	
	count2 = lv->CountItems();	
	for( j = 0; j < count2; j++ )
	{
  		edit_item* item = (edit_item*)lv->ItemAt(j);
  		const server_user_info* pptr = (server_user_info*)item->get_data();		
		if( pptr &&  item->get_ptr() && strlen( item->get_ptr() ) > 0 )
			net_msg.AddData( psz_name, B_RAW_TYPE, (const void*)pptr, sizeof(server_user_info) );  			
	}

	m_prefs->ReplaceMessage("IRCNetworks", &net_msg);
}
void ServersViewTab::FillControls( const char* psz_name)
{
	BMessage net_msg;
	BListView *lv = (BListView*)FindView( "cmd_list" );
	
	int32 count2 = 0;
	type_code type_found;
	
	((edit_listView*)lv)->StopEdit();	

	if( m_sz_network[0] )
		UpdatePrefs( m_sz_network ); 	
	OnClose();	
	
	strcpy( m_sz_network, psz_name );
	
	if( m_prefs->FindMessage("IRCNetworks", &net_msg) != B_OK )
		return;

	count2 = 0;	
	net_msg.GetInfo( psz_name , &type_found,  &count2 );
	for( int32 j = 0; j < count2; j++)
	{
		const server_user_info  *pptr = NULL;
		ssize_t bytes;
		if( net_msg.FindData(psz_name, B_RAW_TYPE, j, (const void**)&pptr, &bytes) != B_OK)
			continue;
		server_user_info  *user_info = new server_user_info;
		memcpy( user_info, pptr, sizeof( server_user_info) );
		edit_item *pItem = new edit_item( user_info->server );
		pItem->set_data( user_info );		 
		lv->AddItem( pItem ); 
	}
	lv->AddItem(new edit_item( ));

}

void ServersViewTab::AttachedToWindow(void)
{	
	BView::AttachedToWindow();
	SETUP_VIEW_COLORS;
	BListView *lv = (BListView*)FindView( "cmd_list" );
	lv->SetTarget(this);
	BCheckBox *b_ck = 	(BCheckBox*) FindView("udui");
	b_ck->SetTarget( this );
	b_ck = (BCheckBox*) FindView("_active_");
	b_ck->SetTarget( this );
	b_ck = (BCheckBox*) FindView("uidt");
	b_ck->SetTarget( this );
	
	BMenuField *menu_fl = (BMenuField*)FindView("mf_server");
	BMenu *menu = menu_fl->Menu();
	menu->SetTargetForItems(this);
	
	lv->Invoke( lv->SelectionMessage() );	

}
void ServersViewTab::OnClose(void)
{
	
	BListView *lv = (BListView*)FindView( "cmd_list" );
	//const BListItem **ppList = lv->Items();  	
	int32 i, count;
	count = lv->CountItems() - 1;
	m_cur_item = NULL;

	try
	{
	for( i = count; i >= 0; i-- )
	{
		delete (server_user_info*)((edit_item*)lv->ItemAt( i ))->get_data();
		delete (edit_item*)lv->RemoveItem( i );
	}	
	}catch(...){}
	lv->MakeEmpty();
	
}
void ServersViewTab::OnOk(void)
{

	UpdateUserPrefs();
	if( *m_sz_network )
		UpdatePrefs( m_sz_network );
	*m_sz_network ='\0';		
	
	//int32 i, count = lv->CountItems();

	if( m_prefs->HasString("server"))
		m_prefs->RemoveName("server"); //delete old (version <=2.2) settings
    	
	BTextControl *tc = (BTextControl *)FindView( "_ident_" );
	m_prefs->ReplaceString("ident_name",  tc->Text() );

	tc = (BTextControl *)FindView( "_serv_" );
	m_prefs->ReplaceString( "ident_server",  tc->Text() ); 	

	m_prefs->ReplaceBool( "active_ident" ,  ((BControl*)FindView( "_active_" ))->Value() == B_CONTROL_ON );

}
#include <Beep.h>
#include <TabView.h>
void ServersViewTab::DetachedFromWindow()
{
	BListView *lv = (BListView*)FindView( "cmd_list" );
	((edit_listView*)lv)->StopEdit();
	lv->DeselectAll( );	
}

void ServersViewTab::UpdateUserPrefs(void)
{
	BCheckBox *b_ck = 	(BCheckBox*) FindView("udui");
	BCheckBox *b_id = 	(BCheckBox*) FindView("uidt");
	BTextControl *nick1 = (BTextControl*)FindView("nick");
	BTextControl *nick2 = (BTextControl*)FindView("nick2");
	BCheckBox *b_id_act =  (BCheckBox*) FindView("_active_");
	BListView *lv = (BListView*)FindView( "cmd_list" );
	
	int32 cur_sel = lv->CurrentSelection();
	if( m_cur_item )
	{
		server_user_info *user_info = (server_user_info*)m_cur_item->get_data();
		if( user_info )
		{
			try
			{
				strcpy( user_info->nick1, nick1->Text());
				strcpy( user_info->nick2, nick2->Text());
				const char *ptr =  m_cur_item->get_ptr();
				if( ptr && *ptr) 
					strcpy( user_info->server,  ptr);
			}catch(...){ m_cur_item = NULL; }		
		}		
	}
	
	if( cur_sel >= 0 )
	{
		b_ck->SetEnabled( true );
		edit_item *item = (edit_item*)lv->ItemAt( cur_sel );
		server_user_info *user_info = (server_user_info*)item->get_data();
		if( !user_info )
		{
			user_info = new server_user_info;
			user_info->is_default = true;
			item->set_data( user_info );
		}	
		if( user_info->is_default )
		{
			const char *nick;
			if( Window()->Lock() )
			{
				BTabView* tbv = (BTabView*)(Window()->FindView( "tab_view" ));
				if(tbv)
				{
					BView *user_view = tbv->ViewForTab( 0 );
					if( user_view )
					{
						BTextControl *tc = (BTextControl*)user_view->FindView("nick");
						//m_prefs->FindString("nick", &nick);
						nick = tc->Text();
						nick1->SetText( nick );
						m_prefs->FindString("nick2", &nick);
						nick2->SetText( nick );					
						b_id->SetValue( b_id_act->Value() );
					}
				}		
				Window()->Unlock();
			}	
		}	
		else
		{
			nick1->SetText( user_info->nick1 );
			nick2->SetText( user_info->nick2 );
			b_id->SetValue( user_info->is_ident );
		}
		b_ck->SetValue( user_info->is_default );
		nick1->SetEnabled( !user_info->is_default );
		nick2->SetEnabled( !user_info->is_default );
		b_id->SetEnabled( !user_info->is_default );
		m_cur_item = item;
	}
	else
	{
		m_cur_item = NULL;
		b_ck->SetEnabled( false );
		nick1->SetText(NULL);
		nick1->SetEnabled( false );
		nick2->SetText(NULL);
		nick2->SetEnabled( false );
		b_id->SetEnabled( false );
	}
}
void ServersViewTab::MessageReceived(BMessage *message)
{
	
	BCheckBox *b_ck = 	(BCheckBox*) FindView("udui");
	BCheckBox *b_id = 	(BCheckBox*) FindView("uidt");
	BCheckBox *b_id_act =  (BCheckBox*) FindView("_active_");
	
	BTextControl *nick1 = (BTextControl*)FindView("nick");
	BTextControl *nick2 = (BTextControl*)FindView("nick2");
	BListView *lv = (BListView*)FindView( "cmd_list" );

	int32 cur_sel = lv->CurrentSelection();
		
	switch (message->what)
	{
		case 'mnet':
		{
			const char *sz_name;
			message->FindString( "net_name", &sz_name);
			if( Window()->Lock() )
			{
				lv->DeselectAll();
				FillControls(sz_name);
				Window()->Unlock();
			}	
		}	
		break;
		case 'uidt':
			if( cur_sel >= 0 )
			{
				edit_item *item = (edit_item*)lv->ItemAt( cur_sel );
				server_user_info *user_info = (server_user_info*)item->get_data();
				user_info->is_ident = (bool)b_id->Value();
			}
		break;
		case 'idmn':
		{
			//bool b = (bool)b_ck->Value();
			if( cur_sel >= 0 )
			{
				edit_item *item = (edit_item*)lv->ItemAt( cur_sel );
				server_user_info *user_info = (server_user_info*)item->get_data();
				if( user_info->is_default )
				{
					b_id->SetValue( b_id_act->Value() );
				}
				
			}		
		}
		break;
		case 'udui':
		{
			bool b = (bool)b_ck->Value();
			if( cur_sel >= 0 )
			{
				edit_item *item = (edit_item*)lv->ItemAt( cur_sel );
				server_user_info *user_info = (server_user_info*)item->get_data();
				user_info->is_default = b;
				nick1->SetEnabled( !b );
				nick2->SetEnabled( !b );		
				b_id->SetEnabled( !b );
			}	
		}
		break;
		case  'Xdel':
			m_cur_item = NULL;
		case LV_SELCHANGE:
			UpdateUserPrefs();		
    		break;  
		default:
			BView::MessageReceived(message);
		break;
	}  
}
//////////////////////////
//////////////// MsgViewTab::MsgViewTab

MsgViewTab::MsgViewTab(BRect rc)
  :BView(rc, "Messages",  B_FOLLOW_ALL_SIDES, B_WILL_DRAW /*| B_FRAME_EVENTS*/)
{

	rc.InsetBy(5,5);
	rc.bottom -= 4;
	rc.top += 4;
	//BRect rect = rc;	
	BBox *box = new BBox(rc,"default");
  	box->SetLabel("Default Messages");
  	AddChild(box);

  	rc.top += 20;
	rc.left += 8;
	rc.right -=16;
	
	
	rc.bottom = rc.top + 12;
	const char *txt;
	m_prefs->FindString( "_part_", &txt);	
	BTextControl *tc = new BTextControl(rc, "_part_", "Part Message", txt,NULL);
  	tc->SetDivider(90);
  	box->AddChild( tc );
  	
  	//rc = tc->Bounds();
	rc.OffsetBy( 0, rc.bottom - rc.top + 16 );
	m_prefs->FindString( "_quit_", &txt);
	tc = new BTextControl(rc, "_quit_", "Quit Message", txt, NULL);
  	tc->SetDivider(90);
  	box->AddChild( tc );
	
/*	rc.OffsetBy( 0, rc.bottom - rc.top + 16 );
	pref_msg->FindString( "_kick_", &txt);
	tc = new BTextControl(rc, "_kick_", "Kick msg:", txt, NULL);
  	tc->SetDivider(90);
  	box->AddChild( tc );
*/		
}
void MsgViewTab::AttachedToWindow(void)
{	
	BView::AttachedToWindow();
	SETUP_VIEW_COLORS;
}

void MsgViewTab::OnOk(void)
{

	BTextControl *tc = (BTextControl*)FindView( "_part_" );
	const char *sz_txt =  tc->Text();
	m_prefs->ReplaceString( "_part_", sz_txt );	
	
	tc = (BTextControl*)FindView( "_quit_" );
	sz_txt =  tc->Text();
	m_prefs->ReplaceString( "_quit_", sz_txt );	
/*	
	tc = (BTextControl*)FindView( "_kick_" );
	sz_txt =  tc->Text();
	pref_msg->ReplaceString( "_kick_", sz_txt );	
*/	
}
//////////////////////////

//////////////////////////
//////////////// DCCViewTab::MsgViewTab
DCCViewTab::DCCViewTab(BRect rc)
  :BView(rc, "DCC",  B_FOLLOW_ALL_SIDES, B_WILL_DRAW /*| B_FRAME_EVENTS*/)
{

	rc.InsetBy(5,5);
	rc.bottom -= 4;
	rc.top += 4;
	//BRect rect = rc;	
	bool b_value = false;
	BBox *box = new BBox(rc,"default");
  	//box->SetLabel("Default messages");
  	AddChild(box);
	
	rc.left += 8;
	rc.right -=16;

	rc.top += 12;
	BCheckBox *check = new BCheckBox( BRect(rc.left, rc.top , rc.right, rc.top + 14),"_chk1", "Auto Accept DCC Chat",NULL);
	box->AddChild(check);
	check->ResizeToPreferred();
	rc.top += check->Bounds().bottom + 8;
	m_prefs->FindBool( "_dcc_auto_chat_", &b_value );		
	check->SetValue( b_value ? B_CONTROL_ON : B_CONTROL_OFF );
	
	check = new BCheckBox( BRect(rc.left, rc.top , rc.right, rc.top + 14),"_chk2", "Auto Accept DCC Send",NULL);
	box->AddChild(check);
	check->ResizeToPreferred();
	rc.top += check->Bounds().bottom + 12;
	m_prefs->FindBool( "_dcc_auto_send_", &b_value );		
	check->SetValue( b_value ? B_CONTROL_ON : B_CONTROL_OFF );
	
	const char csz_LabelName[] = "DCC waiting time:";
	char sz_aw_time[16];
	int16 aw_time = 120;
	m_prefs->FindInt16( "_dcc_answer_time_", &aw_time );
	sprintf( sz_aw_time, "%i", aw_time);		
	int label_width = (int)StringWidth(csz_LabelName );
	BTextControl *tc = new BTextControl( BRect(rc.left, rc.top , rc.left + 8 + label_width + 40, rc.top ) , "_dcc_answer_time_", csz_LabelName, sz_aw_time, NULL );
	tc->SetDivider( label_width + 8);
  	box->AddChild( tc );
  	BTextView *tv = tc->TextView();
  	tv->SetMaxBytes( 3 );
  	rc.top += tc->Bounds().bottom + 10;
  	
	int16 dcc_size = 0;
	m_prefs->FindInt16( "_dcc_buffer_size_", &dcc_size );			
	BMenu *menu = new BMenu("_kb_");
	BMenuItem *mitem = new BMenuItem( "512" , NULL);
	menu->AddItem(  mitem );
	if( dcc_size == 0 ) mitem->SetMarked( true );
	mitem = new BMenuItem( "1024" , NULL);
	menu->AddItem(  mitem );
	if( dcc_size == 1 ) mitem->SetMarked( true );
	
 	menu->SetTriggersEnabled(false);
 	menu->SetLabelFromMarked(true);
 	
  	BMenuField *menu_fld = new BMenuField( BRect(rc.left, rc.top , rc.right, rc.top) , "mf_kb", "DCC Send Frame Size", menu);  
  	menu_fld->SetDivider( StringWidth("DCC Send Frame Size") + 8 );
  	//box->AddChild(menu_fld);
  	box->AddChild(menu_fld);
	//menu->SetTargetForItems(this);
	rc.top += check->Bounds().bottom + 10;
	
	//rc.bottom = rc.top + 12;
	const char *txt = "";
	m_prefs->FindString( "_dcc_folder_", &txt);
	
	rc.right -= 34;	
	tc = new BTextControl( rc, "_rfolder_", "Receive Folder:", txt, NULL );
  	tc->SetDivider(90);
  	box->AddChild( tc );
  	rc. left = rc.right + 4;
  	rc.right += 34;
  	rc.top += 2;
  	rc.bottom = rc.top + tc->Bounds().Height() - 4;
  	BButton *btn = (BButton*) new newButton( rc, "_bws_", "...", new BMessage('bws') );
	box->AddChild(btn);
  	//btn->SetTarget( this );
  	
}
void DCCViewTab::AttachedToWindow(void)
{	
	BView::AttachedToWindow();
	Window()->Lock();
	SETUP_VIEW_COLORS;
	BButton *btn = (BButton*) FindView( "_bws_" );
	btn->SetTarget( this );
	Window()->Unlock();
}

void DCCViewTab::OnOk()
{
	m_prefs->ReplaceBool( "_dcc_auto_chat_" ,  ((BControl*)FindView( "_chk1" ))->Value() == B_CONTROL_ON );
	m_prefs->ReplaceBool( "_dcc_auto_send_" ,  ((BControl*)FindView( "_chk2" ))->Value() == B_CONTROL_ON );
	
	BMenuField *mf = (BMenuField*)FindView("mf_kb");
	BMenu *m = mf->Menu();
	
	BMenuItem *mi = m->FindMarked();
	int32 idx = m->IndexOf( mi );
	m_prefs->ReplaceInt16("_dcc_buffer_size_", (int16) idx);
	
	BTextControl *tc = (BTextControl*)FindView( "_rfolder_" );
	m_prefs->ReplaceString( "_dcc_folder_", tc->Text() );
}

#include <Messenger.h>
#include <Path.h>

void DCCViewTab::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case 'bws':
		{
			BMessage *msg= new BMessage('dir?');
			
			DirFilePanel *dirSelect = new DirFilePanel( new BMessenger( this, NULL ) , new DirFilter ); 
			msg->AddPointer( "_this_", (BFilePanel*)dirSelect );
			dirSelect->SetMessage( msg );
			dirSelect->SetTarget( this );
			
			
			BWindow *w = dirSelect->Window();
			w->SetFlags( B_AVOID_FRONT );
			dirSelect->Show();
		}	
		break;
		case B_CANCEL:
		{
			
			if( message->HasPointer("_this_") )
			{
				DirFilePanel *ptr = NULL;
				message->FindPointer("_this_", (void**)&ptr);			
				delete ptr;			
			}				
			
		}break;
		
		case 'slct':
		case 'dir?':
		{			
			entry_ref ref;
			message->FindRef( "refs", &ref); 
			BEntry entry( &ref );
			BPath path( &entry );
			BTextControl *tc = (BTextControl*)FindView( "_rfolder_" );
			tc->SetText( path.Path() );
			
			if( message->what == 'slct' && message->HasPointer("_this_") )
			{
				BFilePanel *ptr = NULL;
				message->FindPointer("_this_", (void**)&ptr);			
				delete ptr;
			}	
			
		}
		break;
		default:
			BView::MessageReceived(message);
		break;
	}  
}


//////////////////////////
//////////////// FirewallViewTab
#define DX_TXT	22
FirewallViewTab::FirewallViewTab(BRect rc)
  :BView(rc, "FireWall",  B_FOLLOW_ALL_SIDES, B_WILL_DRAW /*| B_FRAME_EVENTS*/)
{

	const char *txt = "";
	bool use_socks5 = false;
	m_prefs->FindBool( "use_socks5", &use_socks5);

	rc.InsetBy(5,9);
	//rc.bottom -= 4;
	//rc.top += 4;
	BBox *box = new BBox(rc,"default");
	rc = box->Bounds();
  	BCheckBox *ch_bx = new BCheckBox( BRect( 6, 0 , rc.Width() - 8 , 25), "soc5", "Use SOCKS 5", new BMessage('soc5') );
  	box->SetLabel( ch_bx );
  	ch_bx->SetEnabled( true );
  	ch_bx->SetValue( double(use_socks5) );
  	
  	AddChild(box);
  	rc.top += 20;
  	rc.bottom = rc.top + 16;
  	rc.InsetBy(10, 0);

	m_prefs->FindString( "socks5_host", &txt);
	BTextControl *tc = new BTextControl(rc, "host", "Host Name:", txt,NULL);
	tc->SetDivider(90);
	tc->TextView()->SetMaxBytes( 64 );
	rc.OffsetBy(0, DX_TXT);
	box->AddChild(tc);

	m_prefs->FindString( "socks5_usr_name", &txt);
	tc = new BTextControl(rc, "user", "User Name:", txt,NULL);
	tc->TextView()->SetMaxBytes( 31 );
	tc->SetDivider(90);
	rc.OffsetBy(0, DX_TXT);
	box->AddChild(tc);

	m_prefs->FindString( "socks5_password", &txt);
	tc = new BTextControl(rc, "pass", "Password:", txt,NULL);
	tc->TextView()->SetMaxBytes( 31 );
	tc->SetDivider(90);
	rc.OffsetBy(0, DX_TXT);
	box->AddChild(tc);
	
	rc.right = rc.left + 90 + 60;
	m_prefs->FindString( "socks5_port", &txt);
	tc = new BTextControl(rc, "port", "Port:", txt, NULL);
	tc->TextView()->SetMaxBytes( 9 );
	tc->SetDivider(90);
	rc.OffsetBy(0, DX_TXT);	
	box->AddChild(tc);

	UpdateControls();
	
}
void FirewallViewTab::AttachedToWindow(void)
{	
	SETUP_VIEW_COLORS;
	BView::AttachedToWindow();
	BCheckBox *b_ck = 	(BCheckBox*) FindView("soc5");
	b_ck->SetTarget( this );

}
void FirewallViewTab::OnOk(void)
{
	BCheckBox *b_ck = 	(BCheckBox*) FindView("soc5");	
	BTextControl *host = (BTextControl*)FindView("host");
	BTextControl *user = (BTextControl*)FindView("user");
	BTextControl *pass = (BTextControl*)FindView("pass");
	BTextControl *port =  (BTextControl*)FindView("port");

	m_prefs->ReplaceBool( "use_socks5",  (bool)b_ck->Value() ); 	
	m_prefs->ReplaceString( "socks5_host",  host->Text() ); 	
	m_prefs->ReplaceString( "socks5_usr_name",  user->Text() ); 	
	m_prefs->ReplaceString( "socks5_password",  pass->Text() ); 	
	m_prefs->ReplaceString( "socks5_port",  port->Text() ); 	
}

void FirewallViewTab::UpdateControls(void)
{
	BCheckBox *b_ck = 	(BCheckBox*) FindView("soc5");
	
	BTextControl *host = (BTextControl*)FindView("host");
	BTextControl *user = (BTextControl*)FindView("user");
	BTextControl *pass = (BTextControl*)FindView("pass");
	BTextControl *port =  (BTextControl*)FindView("port");
	bool b = (bool)b_ck->Value();
	host->SetEnabled( b );
	user->SetEnabled( b );		
	pass->SetEnabled( b );
	port->SetEnabled( b );	
}
void FirewallViewTab::MessageReceived(BMessage *message)
{
	
		
	switch (message->what)
	{
		case 'soc5':
		{
			UpdateControls();
		}
		break;
		default:
			BView::MessageReceived(message);
		break;
	}  
}
	










////////////////////////         OPEN DIR
///////////////////////////**************************
DirFilePanel::DirFilePanel( BMessenger* target, 
                              BRefFilter* filter ) 
  : BFilePanel( B_OPEN_PANEL, target, NULL, 
                B_DIRECTORY_NODE, false, NULL, filter, true) 
{ 
 m_filter = filter;
  BWindow  *w; 

  //  1) Get the window from the FilePanel 
  //     so we can find the window's children 

  w = Window(); 
  if (w->Lock()) 
  { 
    BRect btnrect; 

    //  2) Find the first view in the window, 
    //     and from that view we find the cancel button 

    BView *v = w->ChildAt(0); 
    BView *cancelBtn = v->FindView("cancel button"); 

    if (cancelBtn) { 
      BView *parentview; 
      float charWidth; 

      //  3) Construct and add the new 'Select Current 
      //     Directory' button 

      charWidth  = cancelBtn->StringWidth("Select Current Directory"); 
      btnrect = cancelBtn->Frame(); 
      btnrect.right = btnrect.left - 10; 
      btnrect.left = btnrect.right - charWidth - 40; 
      //BInvoker *ic = (BControl*)v->FindView("default button");
      //BMessage *msg2 = new BMessage( ic->Message() );
      m_CurrentDirBtn = new BButton(btnrect, 
        "current dir button", "Select Current Directory", NULL, B_FOLLOW_RIGHT + B_FOLLOW_BOTTOM); 

      //  4) Set the target for the new button 

      m_CurrentDirBtn->SetTarget(*target); 

      parentview = cancelBtn->Parent(); 
      parentview->AddChild( m_CurrentDirBtn); 

      //  5) Set the message for the new button 

     	entry_ref ref; 
     BMessage *msg = new BMessage('slct'); 
     GetPanelDirectory(&ref); 
     msg->AddRef("refs",&ref); 
     msg->AddPointer( "_this_", (BFilePanel*)this );
     m_CurrentDirBtn->SetMessage(msg); 
     
    } 

    w->Unlock(); 

  } 
} 
DirFilePanel::~DirFilePanel()
{
	if( m_filter )
		delete m_filter;
}
void DirFilePanel::SelectionChanged() 
{ 
  BWindow *wind; 

  wind = Window(); 

  if (wind->Lock()) 
  { 
    entry_ref currRef; 

    GetPanelDirectory(&currRef); 

    //  modify the btn's msg 

    BMessage *msg = m_CurrentDirBtn->Message(); //new BMessage('slct'); 
    msg->ReplaceRef("refs",&currRef); 
    //m_CurrentDirBtn->SetMessage(msg); 

    wind->Unlock(); 
  } 
} 

bool DirFilter::Filter(const entry_ref* e, BNode* n, 
                   struct stat* s, const char* mimetype) 
{ 
  if (strcmp("application/x-vnd.Be-directory", 
             mimetype) == 0) 
    return true; 
  else if (strcmp("application/x-vnd.Be-volume", 
                  mimetype) == 0) 
    return true; 
  else 
    return false; 
} 





