#ifndef SETTINGSVIEW_H
#define SETTINGSVIEW_H


#include "newButton.h"
#include <View.h>

class SettingsTab
{
public:
	virtual void OnOk(void) = 0;
	virtual void OnCancel(void){ };
	virtual void OnClose(void){ };
static	BMessage* m_prefs;
};
/////////////
class BTabView;

class GeneralTab : public BView, public SettingsTab
{
	BTabView*	m_tbv;
	char m_name[64];
public:
	GeneralTab(BRect rc, const char* name);
	void AttachedToWindow(void);
	void DetachedFromWindow();
	void OnOk(void);
	void OnCancel(void);
	void OnClose(void);
	
	void AddTab(BView* vt);
};
///////////////////////////
class UserViewTab : public BView, public SettingsTab
{
public:
	UserViewTab(BRect rc);
	virtual ~UserViewTab(){}
	void AttachedToWindow(void);
	//void DetachedFromWindow();
	//void MessageReceived(BMessage *message);
	
	void OnOk(void);
//	virtual void OnCancel(void);
};
class edit_item;

class ServersViewTab : public BView, public SettingsTab
{
public:
	ServersViewTab(BRect rc);
	virtual ~ServersViewTab(){}
	void MessageReceived(BMessage *message);
	void AttachedToWindow(void);
	void DetachedFromWindow();
	void OnOk(void);
	void OnClose(void);
private:
	void FillControls( const char* psz_name);
	void UpdatePrefs(const char* psz_name);
	void UpdateUserPrefs(void);
	edit_item* m_cur_item;
	char m_sz_network[64];
};


class MsgViewTab : public BView, public SettingsTab
{
public:
	MsgViewTab(BRect rc);
	virtual ~MsgViewTab(){}
//	void MessageReceived(BMessage *message);
	void AttachedToWindow(void);
//	void DetachedFromWindow();
	void OnOk(void);

private:
};

class DCCViewTab : public BView, public SettingsTab
{
public:
	DCCViewTab(BRect rc);
	virtual ~DCCViewTab(){}
	void MessageReceived(BMessage *message);
	void AttachedToWindow(void);
//	void DetachedFromWindow();
	void OnOk(void);

private:
};
class FirewallViewTab : public BView, public SettingsTab
{
public:
	FirewallViewTab(BRect rc);
	virtual ~FirewallViewTab(){}
	void MessageReceived(BMessage *message);
	void AttachedToWindow(void);
	void OnOk(void);
private:
	void UpdateControls(void);
};


/////// open dir dlg
#include <FilePanel.h>
class DirFilePanel : public BFilePanel 
{ 
public: 
	DirFilePanel( BMessenger* target, 
                   BRefFilter* filter=NULL ); 
	virtual ~DirFilePanel();
	void SelectionChanged(); 
	
private: 
	BButton *m_CurrentDirBtn;
	BRefFilter* m_filter;
}; 

class DirFilter : public BRefFilter 
{ 
public: 
	bool Filter(const entry_ref* e, BNode* n, struct stat* s,  const char* mimetype); 
}; 

#define MB_ADD		 'mad1'
#define MB_REMOVE	 'mrev'
#define LV_SELCHANGE 'lvch'

#endif