#include "constants.h"
#include "IRCApp.h"
#include "MainWindow.h"
#include "ServerWindow.h"
#include "SettingsView.h"

#include "ToolBar.h"
#include "Prefs.h"
#include "Utils.h"
#include "newButton.h"
#include <stdio.h>
#include "textFilter.h"
#include "myText.h"
#include "tips.h"

#include <Box.h>
#include <StringView.h>
#include <Menu.h>
#include <MenuItem.h>
#include <MenuField.h>
#include <MenuBar.h>

ToolBarView::ToolBarView(BWindow* window, BRect rc)
	: BView(rc, "ToolBarView", B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW | B_NAVIGABLE_JUMP|B_FRAME_EVENTS)
{
	SET_VIEW_COLORS( this );
	//SetLowColor( 240, 240, 240 );
	//SetViewColor(192,192,192);//(200,200,180);
	window->AddChild(this);
	BMessage *msg;
	BRect rc_cmb;
	rc = Bounds();
/*	{
		BMenu *menu = new BMenu("en");
	  	BMenuBar *mb = new BMenuBar( BRect( 10, 2, 110 , 24) ,"ww", B_FOLLOW_ALL, B_ITEMS_IN_ROW, false);

		for( int i = 0; i < 20; i++)
	 	{
	 		
	 		BMenuItem *mitem = new BMenuItem("helo heh 000000000000 009999999 111111" , NULL);
	 		menu->AddItem(  mitem );
	 	}
	 	menu->SetTriggersEnabled(false);
	 	menu->SetLabelFromMarked(true);
	 	
	  	BMenuField *menu_fld = new BMenuField( BRect( 10, 2, 110 , 24) , "Encoding", NULL, menu);  
	  	//box->AddChild(menu_fld);
	  	//menu->SetMaxContentWidth( 100 );
	 	mb->AddItem(  menu_fld );
	  	AddChild(mb);
	  	//AddChild(menu_fld);
	  	//menu_fld->MenuBar()
	  	//menu_fld->ResizeTo( 100, 22 );
	}
*/	
	
	
	msg = new BMessage('stsp');
	msg->AddBool("continue", true);
	BMessage *btn_msg = new BMessage('btnt');
	btn_msg->AddString( STR_TTIPS, "IRC Network");
	newButton *net_btn = new newButton( BRect( 0,0, 100, 18 ), "ntn_network", "*", btn_msg);

	AddChild( net_btn );

	net_btn->SetTarget( this );
	net_btn->SetFont( be_plain_font);
	net_btn->FirstClick( true );
	rc_cmb = net_btn->Bounds();
	rc_cmb.OffsetTo( 10, (rc.top + rc.bottom)/2 - (rc_cmb.Height()/2));
	net_btn->MoveTo(rc_cmb.LeftTop());

	m_combo = new newComboBox( BRect(0, 0, 220,30) , "server_combo", msg );
	AddChild(m_combo);
	rc_cmb = m_combo->Bounds();
	
	rc_cmb.OffsetTo( 114, (rc.top + rc.bottom)/2 - (rc_cmb.Height()/2));
	m_combo->MoveTo(rc_cmb.LeftTop());

	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage net_msg;
	const char* sz_last_network = NULL;
	if( prefs->GetMsg()->FindString("last_network", &sz_last_network) == B_OK )
	{
		BMessage default_net_msg;
		if( prefs->GetMsg()->FindMessage( sz_last_network, &default_net_msg) == B_OK )
		{
			const server_user_info  *default_user_info = NULL;
		
			if( default_net_msg.HasData("default_server2.4", B_RAW_TYPE) )
			{			
				ssize_t bytes = 0;
				if( default_net_msg.FindData("default_server2.4", B_RAW_TYPE, 0, (const void**)&default_user_info, &bytes) == B_OK)
					m_combo->SetString( default_user_info->server, (const void*) default_user_info, bytes);
			}	
		}	
	}
	
	if( prefs->GetMsg()->FindMessage( "IRCNetworks", &net_msg) == B_OK)
	{		
		
		int32 count = 0;
		type_code type_found;
		net_msg.GetInfo( "Network_names", &type_found,  &count);
		bool is_reset = false;
		const char *sz_name;
		for( int32 i = 0; i < count; i++)
		{
			
			if( net_msg.FindString( "Network_names", i, &sz_name) != B_OK )
				continue;
			if( strcmp( sz_last_network, sz_name) == 0)
			{
				ResetCombo( sz_name );		
				net_btn->SetLabel( sz_name );
				is_reset = true;
			}
		}
		if( !is_reset )
		{
			net_msg.FindString( "Network_names", 0, &sz_name);
			ResetCombo( sz_name );		
			net_btn->SetLabel( sz_name );		
		}		
	}
	
	

	prefs->Unlock();

	msg = new BMessage('stsp');
	msg->AddBool("continue", true);
	rc = m_combo->Frame();
	rc.OffsetBy(rc.Width() + 4, 0);
	rc.right = rc.left + 120;
	//newButton *btn = new newButton(rc, "Connect", "Connect",msg);
	msg->AddString( STR_TTIPS, "Connect");
	bmpButton *btn = new bmpButton( rc.LeftTop(), "Connect", 31, -1, msg );
	AddChild(btn);
	rc.OffsetBy( 28, 0 );
	msg = new BMessage('chan');
	msg->AddString( STR_TTIPS, "Favorites");
	btn = new bmpButton( rc.LeftTop(), "channels", 38, -1,  msg );
	btn->FirstClick( true );
	AddChild(btn);
	
	rc.OffsetBy( 32, 0 );
	rc.top +=1;
	rc.right += 0;
	BBox *box = new BBox( rc, "umode");
	//box->SetLabel("User Mode");
	rc.top = 2;
	rc.left = 4;
	BStringView *stv = new BStringView( rc, "_stv_", "User Mode:");
	stv->SetFontSize( 11.0 );
	stv->ResizeToPreferred();
	rc = stv->Bounds();
	stv->ResizeTo( rc.Width(), 14 );
	AddChild( box );
	box->AddChild( stv );
	rc = stv->Frame();
	rc.InsetBy( 0, 2 );
	rc.left = rc.right + 4;
	rc.right = rc.left + 12;

#define BT_OF 15
	msg  = new BMessage('itmU');		
	msg->AddString( STR_TTIPS, "Invisible" );
	msg->AddString( "cmd", "/MODE $nname +i" );
	newButton *ubt = new newButton( rc, "_i_", "i", msg, 1 );
	ubt->SetFontSize( 10.5 );
	box->AddChild( ubt );
	rc.OffsetBy( BT_OF, 0 );

	msg  = new BMessage('itmU');		
	msg->AddString( "cmd", "/MODE $nname +s" );
	msg->AddString( STR_TTIPS, "Receive Server Notices" );
	ubt = new newButton( rc, "_s_", "s", msg, 1 );
	ubt->SetFontSize( 10.5 );
	box->AddChild( ubt );
	rc.OffsetBy( BT_OF, 0 );

	msg  = new BMessage('itmU');		
	msg->AddString( "cmd", "/MODE $nname +w" );
	msg->AddString( STR_TTIPS, "Receive Wallops" );
	ubt = new newButton( rc, "_w_", "w", msg, 1 );
	ubt->SetFontSize( 10.5 );
	box->AddChild( ubt );
	
	
	MakeFocus(true);
}
void ToolBarView::Draw(BRect updateRect)
{
	BRect rc = Bounds();

	rc.right+=2;
	rc.left -=2;
	
	draw_3Drect(this, rc);  
	BView::Draw(updateRect);
	
	rc = Bounds();
	rc.left += 2;
	rc.InsetBy( 0 ,  3); 
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_HIGH);
	rc.left += 1;
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_LOW);	
	rc.left += 2;
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_HIGH);
	rc.left += 1;
	StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_LOW);	

}
void ToolBarView::AttachedToWindow(void)
{
	//BButton *net_btn = (BButton*)FindView("ntn_network");
	//net_btn->SetTarget(this);
}
void ToolBarView:: ResetCombo( const char* net_name)
{
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage net_msg;
	
	if( prefs->GetMsg()->FindMessage( "IRCNetworks", &net_msg) == B_OK)
	{
		m_combo->RemoveAll();
		int32 count = 0;
		type_code type_found;
		net_msg.GetInfo( net_name , &type_found,  &count );
		for( int32 j = 0; j < count; j++)
		{
			const server_user_info  *pptr = NULL;
			ssize_t bytes;
			if( net_msg.FindData(net_name, B_RAW_TYPE, j, (const void**)&pptr, &bytes) != B_OK)
				continue;
			if( !pptr) 
				continue;
			m_combo->AddString( pptr->server, (const void*)pptr,  bytes);					
		}
	}
	prefs->Unlock();	
}
#include <Beep.h>
void ToolBarView::MessageReceived(BMessage* message)
{
	switch (message->what)
	{
		case 'btnt':
		{
			newButton * btn = (newButton*)FindView("ntn_network");
	
			//////  setings	
			Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
			prefs->Lock();
			BMessage net_msg;
			if( prefs->GetMsg()->FindMessage( "IRCNetworks", &net_msg) == B_OK)
			{
				btn->Check( true );
	 			BRect rc =  btn->Bounds();
				btn->ConvertToScreen(&rc);
				
	 			int32 count = 0;
				type_code type_found;
				net_msg.GetInfo( "Network_names", &type_found,  &count);
				BPopUpMenu* popup = new BPopUpMenu("irc_networks", false);//, false );
				popup->SetFont(be_plain_font);
				popup->SetTriggersEnabled(false);
 				popup->SetLabelFromMarked(true);
 				const char *sz_btn = btn->Label();
				for( int32 i = 0; i < count; i++)
				{
					const char *sz_name;
					if( net_msg.FindString( "Network_names", i, &sz_name) != B_OK )
						continue;
					BMenuItem* item = new BMenuItem( sz_name,  NULL);
					popup->AddItem( item );
					if( strcmp( sz_btn, sz_name) == 0)
						item->SetMarked( true );
						  		
				}
				popup->SetTargetForItems( this );
				BMenuItem *ret = popup->Go( BPoint( rc.left + 1, rc.bottom + 1) , true, true, rc); 
				if( ret )
				{
					btn->SetLabel( ret->Label() );
					ResetCombo( ret->Label() );
					m_combo->SetString( NULL, NULL, 0);
					BMessage default_net_msg;
					if( prefs->GetMsg()->FindMessage( ret->Label(), &default_net_msg) == B_OK)
					{
						const server_user_info  *default_user_info = NULL;
						if( default_net_msg.HasData("default_server2.4", B_RAW_TYPE) )
						{			
							ssize_t bytes;
							if( default_net_msg.FindData("default_server2.4", B_RAW_TYPE, 0, (const void**)&default_user_info, &bytes) == B_OK)
								m_combo->SetString( default_user_info->server, (const void*) default_user_info, bytes);
						}
					}		
				}
				delete popup;
				btn->Check( false );
				
				
			}
			prefs->Unlock();
		}
		break;  
 
		default:
			BView::MessageReceived(message);
		break;
	}
}