#include "Utils.h"
//#include <InterfaceKit.h>
#include <View.h>
#include <Bitmap.h>

/*void draw_frame(BView* view,BRect& rc, bool b)
{
  rgb_color light = {255,255,255,232};
  rgb_color dark2 = {128,128,128,255};
  rgb_color dark = {96,96,96,255};
  rgb_color prev = view->HighColor();
  
  view->SetHighColor( b?dark:dark2 );
  view->StrokeLine(BPoint(rc.left, rc.bottom),BPoint(rc.left, rc.top));
  view->StrokeLine(BPoint(rc.right - 1, rc.top));
  if(!b)
  {
    view->SetHighColor( light);
    view->StrokeLine(BPoint(rc.left+1, rc.bottom),BPoint(rc.left+1, rc.top+1));
    view->StrokeLine(BPoint(rc.right - 1, rc.top + 1));
  }
  view->SetHighColor( b?light:dark );
  view->StrokeLine(BPoint(rc.right, rc.top),BPoint(rc.right, rc.bottom));
  view->StrokeLine(BPoint(rc.left, rc.bottom));
  view->SetHighColor(prev);
}
*/
const  rgb_color c_light = {255,255,255};
const  rgb_color c_dark  = {172,172,172};
  
void draw_3Drect(BView* view,BRect rc, bool b)
{
  rgb_color prevH = view->HighColor();
  rgb_color prevL = view->LowColor();
  
  view->SetHighColor( b ? c_dark : c_light );
  view->SetLowColor( b ? c_light : c_dark );

  view->StrokeLine(rc.LeftBottom(),rc.LeftTop(), B_SOLID_HIGH); 
  view->StrokeLine(rc.LeftTop(),rc.RightTop(), B_SOLID_HIGH);
  rc.left++; rc.top++;
  view->StrokeLine(rc.RightTop(),rc.RightBottom(), B_SOLID_LOW);
  view->StrokeLine(rc.RightBottom(),rc.LeftBottom(), B_SOLID_LOW);

  view->SetHighColor(prevH);
  view->SetLowColor(prevL);
}

void draw_frame(BView* view,BRect rc, bool b)
{
  rgb_color dark2 = {62,62,62};
  rgb_color prevH = view->HighColor(); 
  view->SetHighColor(dark2);
  view->StrokeRect(rc, B_SOLID_HIGH);
  view->SetHighColor(prevH);
  
  rc.InsetBy(1, 1);  
  draw_3Drect(view, rc, b);  
  //rc.InsetBy(-1, -1);  
}

a3DView::a3DView( BRect area,	const char * name,
	uint32 resize,
	uint32 flags) :
	BView(area, name, resize, flags | B_FRAME_EVENTS)
{
	//SetViewColor(B_TRANSPARENT_32_BIT); /* we redraw everything */
	//SetHighColor(0,0,128);
	//SetLowColor(220,220,220);
}

void a3DView::Draw( BRect area )
{
	//area = area; /* silence compiler */
	BRect r(Bounds());
	r.InsetBy(1,1);
	// erase background 
	//FillRect(r, B_SOLID_LOW);
	rgb_color white = { 255, 255, 255, 255 };
	rgb_color dark = { 128, 128, 128, 255 };
	// 3d frame 
	r = Bounds();
	BeginLineArray(4);
	AddLine(r.LeftTop(), r.RightTop(), white);
	AddLine(r.LeftTop(), r.LeftBottom(), white);
	AddLine(r.RightTop(), r.RightBottom(), dark);
	AddLine(r.LeftBottom(), r.RightBottom(), dark);
	EndLineArray();
	
	/* contents -- draw last to show if it flickers */
	//DrawString("No Flicker", BPoint(4,20));
	//draw_3Drect( this, r);
}

void a3DView::FrameResized( float width, float height)
{
	BView::FrameResized(width, height);
	if (width > oldBounds.right) {
		BRect r(oldBounds.right, 0, width, height);
		Invalidate(r);
	}
	else {
		BRect r(width, 0, width, height);
		Invalidate(r);
	}
	if (height > oldBounds.bottom) {
		BRect r(0, oldBounds.bottom, width, height);
		Invalidate(r);
	}
	else {
		BRect r(0, height, width, height);
		Invalidate(r);
	}
	oldBounds = Bounds();
}


IconView::IconView( BRect area,	const char * name, BBitmap *bmp,
	uint32 resize,
	uint32 flags) :
	BView(area, name, resize, flags | B_FRAME_EVENTS)
{
	SetViewColor(B_TRANSPARENT_32_BIT); 
	//SetHighColor(0,0,128);
	SetLowColor(220,220,220);
	m_bmp = bmp;
}
IconView::~IconView( )
{
	if( m_bmp )
		delete m_bmp;
}
void IconView::Draw( BRect area )
{
	BRect r(Bounds());
	FillRect(r, B_SOLID_LOW);
		if ( m_bmp ) 
	{
		SetDrawingMode(B_OP_OVER);
		DrawBitmap(m_bmp);//, BPoint(0, 0) );
		SetDrawingMode(B_OP_COPY);
	}
	draw_3Drect( this, r);	
}

