#include "IRCApp.h"
#include "Prefs.h"

#include <ScrollView.h>
#include <StatusBar.h>
#include <StringView.h>
#include <Window.h>

#include "ServerView.h"
//#include "ChatView.h"
#include "chanels_view.h"
#include "constants.h"
#include "newItem.h"
#include "list_header.h"
#include "Utils.h"
#include "newButton.h"
#include "tips.h"

#define TOP_H	(B_H_SCROLL_BAR_HEIGHT - 0)

chanels_view::chanels_view(BWindow* window, BRect rc)
	: BView(rc, "_channels_view_", B_FOLLOW_RIGHT |  B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW /*| B_NAVIGABLE_JUMP*/|B_FRAME_EVENTS)
{
	rc = Bounds();
	rc.bottom = rc.top + TOP_H - 3;
	rc.left = rc.right - TOP_H + 1;
	BMessage* msg = new BMessage( 'clls' );
	msg->AddString( STR_TTIPS, "Collaps");
	newButton *btn = new newButton( rc, "<->", ">>", msg, 1 );
	btn->SetFontSize( 9.5 );
	btn->SetResizingMode( B_FOLLOW_RIGHT |  B_FOLLOW_TOP);
	AddChild( btn );
	
		
	rc = Bounds();	
  	rc.top += btn->Bounds().bottom + 2 + B_H_SCROLL_BAR_HEIGHT;
  	rc.right = Bounds().right - B_V_SCROLL_BAR_WIDTH;
  	rc.bottom -= 2 * B_H_SCROLL_BAR_HEIGHT;
  	BListView* lv = //new BListView(rc, "channel_list", B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL );
  						(BListView*) new newListView(rc, "channel_list", B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL );
  	
  	lv->SetViewColor(sc_viewcolor);
	lv->SetHighColor(sc_highcolor);
	lv->SetLowColor(sc_lowcolor);
	
	rc = Bounds();	
  	rc.top += btn->Bounds().bottom + 1 ;
  	rc.right = Bounds().right;
  	rc.bottom = rc.top + B_H_SCROLL_BAR_HEIGHT;
  	list_header *lh = new list_header( rc,  lv);
	lh->add_column( "channel", 60);
	lh->add_column( "users", 40);
	lh->add_column( "topic", 200);
	AddChild( lh );
	((newListView*)lv)->put_prefs( (void*)lh );
	
  	BScrollView *sv = new BScrollView("sw_channel_list", lv, 
            /*B_FOLLOW_RIGHT | B_FOLLOW_TOP_BOTTOM*/B_FOLLOW_ALL, B_WILL_DRAW, true, true, B_NO_BORDER);
	AddChild(sv);
  	sv->ScrollBar( B_HORIZONTAL )->AddFilter( lh );
  	
  	SET_VIEW_COLORS( sv );
  	
  	rc = Bounds();
  	rc.top = rc.bottom - B_H_SCROLL_BAR_HEIGHT + 2; 	
  	//rc.right = rc.left + 70;
  	//ChatInfoView *ci = new ChatInfoView( rc, B_FOLLOW_LEFT_RIGHT |  B_FOLLOW_BOTTOM);  	
  	rc.OffsetBy( 0, 2 );
  	BStringView *ci = new BStringView( rc, "channels_info", "channel(s) : 0", B_FOLLOW_LEFT_RIGHT |  B_FOLLOW_BOTTOM);  	
  	AddChild( ci );
  	ci->SetFontSize( 11.5 );
  	//ci->SetString( "Count : 0" );	
  	
  	rc = ci->Bounds();
  	rc.left += 94;
    	BStatusBar *stb = new BStatusBar( rc, "progress");//,"progress", "progress" );
	ci->AddChild(stb);
	//stb->SetFlags( sv->Flags() );
	stb->SetResizingMode( B_FOLLOW_ALL );//B_FOLLOW_LEFT_RIGHT |  B_FOLLOW_BOTTOM);
	stb->ResizeToPreferred();
	stb->SetBarHeight( rc.Height() - 1);	
	stb->MoveBy( 0, -stb->BarHeight() - 5 );
	
	//stb->SetHighColor( 255 , 0, 0 );
	stb->SetMaxValue(1000);		
}

chanels_view::~chanels_view()
{
		//Window()->Unlock();
	/*Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
	ServerView *sv = (ServerView*)Parent();
	prefs->Lock();
	bool b = sv->IsListCollapsed();
	prefs->GetMsg()->ReplaceBool("CollapseList", b );
	prefs->Unlock();	
	*/
}

void chanels_view::AttachedToWindow(void)
{
	SETUP_VIEW_COLORS;
	
	//SetViewColor( 192 , 192, 192 );
	newButton *btn = (newButton*)FindView( "<->" );
	btn->SetTarget( this );
	//ServerView *sv = (ServerView*)Parent();
	
	Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	
	bool b = false;
	prefs->GetMsg()->FindBool("CollapseList", &b);
	prefs->Unlock();
	
	if( b )
	{
		BMessage msg( 'clls' );
		Window()->PostMessage( &msg, this ); //collaps( b );
	}	
}
void chanels_view::DetachedFromWindow(void) 
{
	BMessageFilter *pmf = dynamic_cast<BMessageFilter*>(FindView("_list_header_view_") );
	BScrollView *scv = (BScrollView*)FindView( "sw_channel_list" );
	//Window()->Lock();
	if( scv && pmf )
	{
		(scv->ScrollBar( B_HORIZONTAL ))->RemoveFilter( pmf );
		
	}	

}
void chanels_view::Draw(BRect rc)
{
	rc = Bounds();
	rc.bottom = rc.top + TOP_H - 3;
	rc.right -= ( TOP_H + 0 );
	font_height height;
	GetFontHeight(&height); 
     	MovePenTo( 4 , rc.top +  height.ascent + height.leading);	
	//SetDrawingMode(B_OP_MIN);
	rgb_color hc = HighColor();
	//SetHighColor( 0, 0, 0 ); 
	//DrawString( "Channels List" ); 
	//SetDrawingMode (B_OP_COPY); 	
	
	draw_3Drect( this, rc, false);	
	rc.InsetBy( 4, 0 );
	rc.bottom = rc.top + 3;
	StrokeLine( rc.LeftBottom(), rc.RightBottom() ,B_SOLID_HIGH );
	rc.bottom++;
	StrokeLine( rc.LeftBottom(), rc.RightBottom() ,B_SOLID_LOW );
	
	rc.bottom += 2;
	StrokeLine( rc.LeftBottom(), rc.RightBottom() ,B_SOLID_HIGH );
	rc.bottom++;
	StrokeLine( rc.LeftBottom(), rc.RightBottom() ,B_SOLID_LOW );

	SetHighColor( hc ); 	
}
void chanels_view::collaps( bool b)
{
	newButton *btn = (newButton*)Parent()->FindView( "<->" );
	ServerView *sv = (ServerView*)Parent();
			
	BRect rc2, rc = btn->Frame();
	if( !b && IsHidden() )
	{				
		Show();
		rc2 = Bounds();
		if( Parent()->RemoveChild( btn ) )
		{
			AddChild( btn );
			btn->MoveTo( rc2.right - rc.Width() , rc2.top + 0 );
			sv->CollapseList( false );
			btn->SetLabel(">>");
			btn->Message()->ReplaceString( STR_TTIPS, "Collaps");
		}	
		return;
	}	

	if( b && !IsHidden() )
	{				
		Hide();
		if( RemoveChild( btn ) )
		{
			rc2 = Parent()->Bounds();				
			Parent()->AddChild( btn );
			btn->MoveTo( rc2.right - rc.Width() , rc2.top + 1 );
			sv->CollapseList( true );
			btn->SetLabel("<<");
			btn->Message()->ReplaceString( STR_TTIPS, "Expand");
		}	
	}				
	
}
void chanels_view::MessageReceived(BMessage* message)
{
	switch (message->what)
	{
		case 'clls':
		{
			ServerView *sv = (ServerView*)Parent();
			collaps( !sv->IsListCollapsed() );
		}
		break;
		default:    	
			break;
	}
	BView::MessageReceived(message);
}

/*void chanels_view::FrameResized(float width, float height)
{
   	Window()->Lock();
   	
   	
	Window()->Unlock();
	Window()->UpdateIfNeeded();
	//BView::FrameResized( width, height);
}
*/