#include "color_font.h"

#include "newButton.h"
#include "constants.h"
#include <Box.h>
#include <Font.h>
//#include <CheckBox.h>
#include <ScrollView.h>
#include <MenuItem.h>
#include <Menu.h>
#include <MenuField.h>
#include <PopUpMenu.h>
#include <StringView.h>
#include "newItem.h"
#include "Prefs.h"
#include "constants.h"
//#include "IRCApp.h"

#include "edit_list_item.h"
#include "ListEditCtl.h"

#include <string.h>
#include <stdio.h>
#include <malloc.h>
//#include <TabView.h>


//////////////// ColorsViewTab::ColorsViewTab
#define W_LIST	150
ColorsViewTab::ColorsViewTab(BRect rc)
  :BView(rc, "Colors",  B_FOLLOW_ALL_SIDES, B_WILL_DRAW /*| B_FRAME_EVENTS*/)
{

	rc.InsetBy(8, 6);
	rc.bottom -= 30;

	BBox *box = new BBox( rc );
	AddChild( box );
	rc = box->Bounds();
	//rc.InsetBy(18, 8);
	rc.InsetBy(12, 8);
	rc.bottom -= 24;
	
	BRect rect( rc.left, rc.top, rc.right - 14 - 4, rc.bottom);
	BView *v = new BView( rect, "Colors_Items",  B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
	SET_VIEW_COLORS(v);
  	int i;
	BRect str_rc = v->Bounds();
	font_height	finfo;
	v->GetFontHeight(&finfo);	
	
	str_rc.top += finfo.descent ;
	str_rc.left += 6;
	str_rc.right -= 32 + 2;
	str_rc.bottom = int( str_rc.top + finfo.ascent + 2 * finfo.descent + finfo.leading + 0.5 ); 
	memset( m_btns, 0, sizeof( m_btns ));
	m_menu = new BPopUpMenu("mm_colors", false, false);
	m_menu->SetTriggersEnabled(false);
	//m_menu->SetLabelFromMarked(true);
	for( i = 0; i < num_irc_event_color; i++)
	{
		char sz_name[256] = {'.'};
		strcpy(sz_name, irc_event_name[i]);
		memset( &sz_name[ strlen(irc_event_name[i]) ], '.', sizeof(sz_name) - strlen(irc_event_name[i]) );
		sz_name[255] = '\0';
		BStringView *str_v = new BStringView(str_rc, irc_event_name[i] , sz_name , B_FOLLOW_ALL, B_WILL_DRAW);
		v->AddChild(str_v);		
		
		int16 cl = 0;
		m_prefs->FindInt16( "event_colors", i, &cl ) ;
		m_btns[ i ] = new ColorButton( BRect( str_rc. right, str_rc.top - finfo.descent , str_rc.right + 32, str_rc.bottom - finfo.descent - finfo.leading), cl , new BMessage('cvm' + i));		
		m_btns[ i ]->FirstClick( true );
		v->AddChild( m_btns[ i ] );
		str_rc.OffsetBy(0, str_rc.Height() + 2);
		str_v->SetHighColor( irc_color[ cl ].color );
		if( i == 0 )
		{
			v->SetViewColor( irc_color[ cl ].color );
			str_v->SetHighColor( irc_color[ 1 ].color );
		}
	}
	for( i = 0; i < num_irc_colors ; i++)
	{
		color_item *mitem = new color_item( i );//, new BMessage( 'mclr' ));
		m_menu->AddItem(  mitem );	
	}
	rect = BRect( rect. right, rc.top, rect.right + 14, rc.bottom);
	BScrollView *sb = new BScrollView( "scroll_v", v,
		B_FOLLOW_RIGHT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW, false, true);
  	BScrollBar *sbr = sb->ScrollBar( B_VERTICAL );
  	sbr->SetRange(0, str_rc.top - v->Bounds().Height());
	box->AddChild(sb);
	
	rc.right -= 2;
	rc.top = rc.bottom + 6;
	rc.bottom = rc.top + 20;
	rc.left = rc.right - 68;
	BButton *btn = (BButton*) new newButton( rc, "_default_", "Default", new BMessage('dful') );
	box->AddChild(btn);
	btn->SetFont(be_plain_font);	
}	
	
ColorsViewTab::~ColorsViewTab()
{ 
	delete m_menu; 
}	
void ColorsViewTab::DetachedFromWindow()
{
	BScrollView* sv = (BScrollView*)FindView(  "scroll_v");
	BScrollBar *sbr = sv->ScrollBar( B_VERTICAL );
	sbr->SetValue( 0 );
	//sbr->Target()->ScrollTo(0, sbr->Value());
	BView::DetachedFromWindow();
}
void ColorsViewTab::AttachedToWindow(void)
{	
	
	BView::AttachedToWindow();
	Window()->Lock();
	SETUP_VIEW_COLORS;
	BScrollView* sv = (BScrollView*)FindView(  "scroll_v");
	BScrollBar *sbr = sv->ScrollBar( B_VERTICAL );
	sbr->SetSteps( 18,  5 * 18);
	for( int i = 0; i < num_irc_event_name; i++)
	{
		m_btns[ i ]->SetTarget(this);
	}
	m_menu->SetTargetForItems(this);
	BButton *btn = (BButton*)FindView( "_default_" );
	btn->SetTarget(this);
	Window()->Unlock();
}
void ColorsViewTab::OnOk()
{
	int i = 0;
	for( i = 0; i < num_irc_event_color; i++)
	{
		m_btns[ i ]->SetTarget(this);
		m_prefs->ReplaceInt16( "event_colors", i,  m_btns[ i ]->get_color());
		irc_event_color[ i ] = (em_colors)m_btns[ i ]->get_color();
	}			
}
void ColorsViewTab::OnClose()
{
}

em_colors original_color[] = 
{
	eBlack,	//eBkColor = 0,
	eOrange,	//eNotice,
	eGreen,		//eJoin,
	eMedMetallicBlue,		//ePart,
	//eMedMetallicBlue,			//eQuit,
	eLightBlue,		//eNick,
	ePurple,		//eInvite,	
	eYellow,		//eTopic,
	ePurple,		//eMode,
	eRed,			//eKick,
	eLightMetallicBlue,		//eNote,
	eWhite,		//eChanel_Notice,
	eLightGreen,		//eServer_Notice,
	eGreen,		//eWallop,
	eOrange,		//eCTCP_Query,
	eRed,			//eCTCP_Reply,
	eRed,			//eAction,
	eRed,			//eError_Message,
	eLightMetallicBlue,	//eInformation,
	ePurple,		//eAway_Message,
	eRed,			//eIRC_Operator_Tag,
	eWhite,	//eOwn_Txt,
	eLightGrey			//eNormal_Txt	
};

void ColorsViewTab::MessageReceived(BMessage* message)
{
	
	if( message->what >= 'cvm' &&  message->what < (uint)('cvm' + num_irc_event_name) )
		{
			int idx = message->what - 'cvm';
			BRect rc = m_btns[ idx ]->Bounds();
			rc.OffsetBy( 1, 1 );
			m_btns[ idx ]->ConvertToScreen(&rc);
			m_menu->SetTargetForItems( this );
			color_item* sel = (color_item*)m_menu->Go(rc.LeftBottom());//, false, false, rc ); 
			if( sel )
			{
				int icolor = sel->get_idx();
				m_btns[ idx ]->set_color( icolor ); 
				BView *str_v = FindView( irc_event_name[ idx ] );
				str_v->SetHighColor( irc_color[ icolor ].color );
				str_v->Invalidate();
				if( idx == 0 )
				{
					str_v->SetHighColor( irc_color[ 1 ].color );//bk color!!!
					BView *v = FindView( "Colors_Items" );
					v->SetViewColor( irc_color[ icolor ].color );
					for(int i = 0; i < num_irc_event_color; i++)
					{
						str_v = FindView( irc_event_name[ i ] );
						str_v->SetViewColor( irc_color[ icolor ].color );
						str_v->SetLowColor( irc_color[ icolor ].color );
					}					
					v->Invalidate();
				}
			}
		}
	switch (message->what)
	{
		case 'dful':
			{
				BView *v = FindView( "Colors_Items" );	 				
				v->SetViewColor( irc_color[ original_color[0] ].color );
				for( int i = 0; i < num_irc_event_color; i++)
				{
					m_btns[ i ]->set_color( original_color[i] );
					irc_event_color[ i ] = original_color[i];
					BView *str_v = FindView( irc_event_name[ i ] );
					str_v->SetViewColor( irc_color[ original_color[0] ].color );
					str_v->SetHighColor( irc_color[ original_color[i] ].color );
					str_v->SetLowColor( irc_color[ original_color[0] ].color );
				}				
				v->Invalidate();
			}
		break;  
		default:
			BView::MessageReceived(message);
	break;
	}  
}

/////////////////////////////// FontViewTab 
//////////
//////////
FontViewTab::FontViewTab(BRect rc)
  :BView(rc, "Fonts",  B_FOLLOW_ALL_SIDES, B_WILL_DRAW /*| B_FRAME_EVENTS*/)
{
	rc.InsetBy(8, 6);
	rc.bottom -= 30;

	BBox *box = new BBox( rc );
	AddChild( box );
	rc = box->Bounds();
	BMenu *menu = new BMenu("mm_fonts");
	int32 numFamilies = count_font_families(); 

	const char *font_name;
	
	m_prefs->FindString( "default_font",  &font_name);
	for(int i = 0; i < numFamilies; i++)
 	{
 		font_family family;
 		uint32 flags;
 		if ( get_font_family(i, &family, &flags) == B_OK )
 		{
 			BMenuItem *mitem = new BMenuItem( family , NULL);
 			menu->AddItem(  mitem );
 			if( strcmp( font_name, family) == 0)
 				mitem->SetMarked( true );
 		}	
 	}
 	menu->SetTriggersEnabled(false);
 	menu->SetLabelFromMarked(true);
 	
	rc.InsetBy(8, 8);
 	rc.bottom = rc.top + 16;
  	BMenuField *menu_fld = new BMenuField( rc, "fonts", "Default Fonts: ", menu);  
  	menu_fld->SetDivider( StringWidth( menu_fld->Label() ) + 4);
	box->AddChild(menu_fld);
  	menu_fld->ResizeToPreferred();
  	
  	int16 font_size = 0;
  	m_prefs->FindInt16("default_font_size", &font_size );
  	menu = new BMenu("mm_fonts_size");
 	menu->AddItem(  new BMenuItem( "8 " , NULL) );
 	menu->AddItem(  new BMenuItem( "9 " , NULL) );
 	menu->AddItem(  new BMenuItem( "10" , NULL) );
 	menu->AddItem(  new BMenuItem( "11" , NULL) );
 	menu->AddItem(  new BMenuItem( "12" , NULL) );
 	menu->AddItem(  new BMenuItem( "13" , NULL) );
 	menu->AddItem(  new BMenuItem( "14" , NULL) );
	BMenuItem *marked = menu->ItemAt( int( (font_size - 8) ) );
	marked->SetMarked( true );
	
	menu->SetTriggersEnabled(false);
 	menu->SetLabelFromMarked(true);
 
	rc.left = (rc.left + rc.right) / 1.5;
	menu_fld = new BMenuField( rc, "font_size", "Size: ", menu);    	
  	menu_fld->SetDivider( StringWidth( menu_fld->Label() ) + 4);
  	box->AddChild(menu_fld);
  	//AddChild(menu_fld); 
	
}
void FontViewTab::AttachedToWindow(void)
{	
	BView::AttachedToWindow();
	Window()->Lock();
	SETUP_VIEW_COLORS;
	Window()->Unlock();
}
void FontViewTab::OnOk()
{
	BMenuField *menu_fl = (BMenuField*)FindView("font_size");
	BMenu *menu = menu_fl->Menu();
	
	BMenuItem *mitem = menu->FindMarked();
	int32 idx = menu->IndexOf(mitem);
	m_prefs->ReplaceInt16("default_font_size", (int16) (idx + 8) ); 

	menu_fl = (BMenuField*)FindView("fonts");
	menu = menu_fl->Menu();
	
	mitem = menu->FindMarked();
	m_prefs->ReplaceString("default_font", mitem->Label() ); 
}
void FontViewTab::OnClose()
{
	BWindow *w = Window();
	if( w )
	{
		w->Lock();
		
		w->Unlock();
	}	
}
void FontViewTab::MessageReceived(BMessage* message)
{
	switch (message->what)
	{
		default:
			BView::MessageReceived(message);
		break;
	}  
}

////////// color_item
color_item::color_item( int idx, BMessage *msg )
	:BMenuItem( "", msg )
{
	m_icolor = idx;
}

void color_item::GetContentSize(float* width, float* height)
{
	//*width = 16;
	font_height fheight;
	Menu()->GetFontHeight( &fheight );
	*height = fheight.ascent + fheight.descent + fheight.leading;
	*width = 2 * (*height);
}

void color_item::Draw()
{
	BMenu* menu = Menu();
	if (menu) 
	{
		BRect rc = Frame();
		rc.InsetBy(2, 1);
		drawing_mode dw = menu->DrawingMode();
		menu->SetHighColor( irc_color[m_icolor].color );
		menu->SetDrawingMode(B_OP_COPY);
		menu->FillRect( rc );
		if ( IsSelected() )
		{
			menu->SetDrawingMode( B_OP_INVERT );
			BPoint pts[3];
			/*pts[0].x = ( rc.right + rc.left ) / 2 ;
			pts[0].y = ( rc.top + rc.bottom ) / 2;						
			//menu->FillEllipse( rc.LeftTop(), 4 , 4 );			
			menu->StrokeEllipse( pts[0], 4 , 4 );			
			*/			
			pts[0].x = rc.left + 2;
			pts[0].y = rc.top + 2;
			pts[1].x = rc.left + rc.Height() - 2;
			pts[1].y = (rc.top + rc.bottom)/2;
			pts[2].x = pts[0].x;
			pts[2].y = rc.bottom - 2;
			menu->FillPolygon( pts, 3);
			/*
			pts[0].x = rc.right - 2;
			pts[1].x = rc.right - rc.Height() + 2;
			pts[2].x = pts[0].x;
			menu->FillPolygon( pts, 3);
			*/
		}
		menu->SetDrawingMode( dw );
	}	
}

