#ifndef _CONSTANTS_H
#define _CONSTANTS_H

//#include <InterfaceKit.h>
#include <SupportDefs.h>
#include <GraphicsDefs.h>
#include <UTF8.h>

const rgb_color	sc_viewcolor	= {220, 220, 220};
const rgb_color	sc_highcolor	= {250, 250, 250};
const rgb_color	sc_lowcolor	= {150, 150, 150};
/*
const rgb_color Black =					{0,  0,  0,		255};
const rgb_color White =					{255,255,255,	255};
const rgb_color Red =					{255,0,  0,		255};
const rgb_color Green =					{0,  167,0,		255};
const rgb_color LightGreen =			{90, 240,90,	255};
const rgb_color Blue =					{49, 61, 225,	255};
const rgb_color LightBlue =				{64, 162,255,	255};
const rgb_color Purple =				{144,64, 221,	255};
const rgb_color LightPurple =			{166,74, 255,	255};
const rgb_color Lavender =				{193,122,255,	255};
const rgb_color Yellow =				{255,203,0,		255};
const rgb_color Orange =				{255,163,0,		255};
const rgb_color Flesh =					{255,231,186,	255};
const rgb_color Tan =					{208,182,121,	255};
const rgb_color Brown =					{154,110,45,	255};
const rgb_color Grey = 					{200,200,200,	255};
const rgb_color LightMetallicBlue =		{143,166,240,	255};
const rgb_color MedMetallicBlue =		{75, 96, 154,	255};
const rgb_color DarkMetallicBlue =		{78, 89, 126,	255};
*/
struct _irc_color
{
	rgb_color	color;
	char		name[64];
};

enum em_colors
{
	eBlack = 0,
	eWhite,
	eRed,
	eGreen,
	eLightGreen,
	eBlue,
	eLightBlue,
	ePurple,
//	eLightPurple,
//	eLavender,
	eYellow,
	eOrange,
//	eFlesh,
//	eTan,
	eBrown,
	eGrey,
	eLightGrey,
	eLightMetallicBlue,
	eMedMetallicBlue,
	eDarkMetallicBlue
};

const _irc_color  irc_color[]  = 
{
	{	{0,  0,  0,		255},	"Black"					},
	{	{255,255,255,	255},	"White"					},
	{	{255,0,  0,		255},	"Red"					},
	{	{0,  167,0,		255},	"Green"				},
	{	{90, 240,90,	255},	"LightGreen"			},
	{	{49, 61, 225,	255},	"Blue"					},
	{	{64, 162,255,	255},	"LightBlue"				},
	{	{144,64, 221,	255},	"Purple"				},
//	{	{166,74, 255,	255},	"LightPurple"			},
//	{	{193,122,255,	255},	"Lavender"				},
	{	{255,203,0,		255},	"Yellow"				},
	{	{255,163,0,		255},	"Orange"				},
//	{	{255,231,186,	255},	"Flesh"					},
//	{	{208,182,121,	255},	"Tan"					},
	{	{154,110,45,	255},	"Brown"				},
	{	{200,200,200,	255},	"Grey"					},
	{	{220,220,220,	255},	"LightGrey"			},
	{	{143,166,240,	255},	"LightMetallicBlue"		},
	{	{75, 96, 154,	255},	"MedMetallicBlue"		},
	{	{78, 89, 126,	255},	"DarkMetallicBlue"	}
};
const int num_irc_colors = sizeof(irc_color)/sizeof(irc_color[0]);
enum en_irc_event
{
	eBkColor = 0,
	eNotice,
	eJoin,
//	ePart,
	eQuit,
	eNick,
	eInvite,	
	eTopic,
	eMode,
	eKick,
	eNote,
	eChanel_Notice,
	eServer_Notice,
	eWallop,
	eCTCP_Query,
	eCTCP_Reply,
	eAction,
	eError_Message,
	eInformation,
	eAway_Message,
	eIRC_Operator_Tag,
	eOwn_Txt,
	eNormal_Txt	
};
const char irc_event_name [][64] = 
{
	"BackGround",
	"Notice text",
	"Join text",
//	"Part",
	"Quit & Part text",
	"Nick text",
	"Invite text",
	"Topic text",
	"Mode text",
	"Kick text",
	"Note text",
	"Chanel Notice text",
	"Server Notice text",
	"Wallop text",
	"CTCP Query text",
	"CTCP Reply text",
	"Action text",
	"Error Message text",
	"Information text",
	"Away Message text",
	"IRC Operator Tag text",
	"Own  text",
	"Normal  text"
};
const int num_irc_event_name = sizeof(irc_event_name)/sizeof(irc_event_name[0]);
/*struct tag_irc_event_color
{
	//en_irc_event event;
	em_colors color;	
};*/
extern em_colors irc_event_color[];
extern const int num_irc_event_color;

/* = 
{
	eGrey,			//eBkColor = 0,
	eLightGreen,	//eNotice,
	eGreen,		//eJoin,
	eGreen,		//ePart,
	eMedMetallicBlue,			//eQuit,
	ePurple,		//eNick,
	eYellow,		//eInvite,	
	eLightGreen,	//eTopic,
	ePurple,		//eMode,
	eBrown,		//eKick,
	eLightBlue,		//eNote,
	eGreen,		//eChanel_Notice,
	eGreen,		//eServer_Notice,
	eGreen,		//eWallop,
	eOrange,		//eCTCP_Query,
	eBlue,			//eCTCP_Reply,
	eRed,			//eAction,
	eRed,			//eError_Message,
	eMedMetallicBlue,	//eInformation,
	ePurple,		//eAway_Message,
	eRed,			//eIRC_Operator_Tag,
	eMedMetallicBlue,	//ePravate_Msg,
	eBlack			//eNormal_Txt	
};*/



//////////////////////////
struct tag_enc
{
	int32 type;
	char name[64];
};
static const tag_enc sc_en[ ] = {
  	{ B_ISO1_CONVERSION,						"Western / ISO 8859-1"},
	{ B_ISO2_CONVERSION,						"Central European / ISO 8859-2"},
//	{ B_ISO3_CONVERSION,						"/* ISO 8859-3 */"},
//	{ B_ISO4_CONVERSION,						"/* ISO 8859-4 */"},
	{ B_ISO5_CONVERSION,						"Cyrillic / ISO 8859-5"},
//	{ B_ISO6_CONVERSION,						"/* ISO 8859-6 */"},
	{ B_ISO7_CONVERSION,						"Greek / ISO 8859-7"},
//	{ B_ISO8_CONVERSION,						"/* ISO 8859-8 */"},
//	{ B_ISO9_CONVERSION,						"/* ISO 8859-9 */"},
//	{ B_ISO10_CONVERSION,						"/* ISO 8859-10 */"},
	{ B_MAC_ROMAN_CONVERSION,			"Western / Macintosh Roman"},
//	{ B_SJIS_CONVERSION,						"Japanese / Shift-JIS"},
//	{ B_EUC_CONVERSION,						"EUC Packed Japanese"},
	{ B_JIS_CONVERSION,						"JIS X 0208-1990"},
	{ B_MS_WINDOWS_CONVERSION,			"Western / MS-Windows Codepage 1252"},
//	{ B_UNICODE_CONVERSION,					"Unicode 2.0"},
	{ B_KOI8R_CONVERSION,						"Cyrillic /KOI8-R"},
	{ B_MS_WINDOWS_1251_CONVERSION,	"Cyrillic / MS-Windows Codepage 1251"},
	{ B_MS_DOS_866_CONVERSION,			"MS-DOS Codepage 866"},
//	{ B_MS_DOS_CONVERSION,					"MS-DOS Codepage 437"},
//	{ B_EUC_KR_CONVERSION,					"EUC Korean" },
};

#define  SETUP_VIEW_COLORS		SetViewColor(sc_viewcolor); \
											SetHighColor(sc_highcolor);\
											SetLowColor(sc_lowcolor)

#define  SET_VIEW_COLORS(v)	v->SetViewColor(sc_viewcolor); \
											v->SetHighColor(sc_highcolor);\
											v->SetLowColor(sc_lowcolor)

#endif