#include "dcc.h"

#include <socket.h>


#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include <string.h>
#include <UTF8.h>
#include <OS.h>
#include <File.h>
#include <Path.h>
#include <Roster.h>
#include <Application.h>
#include <Entry.h>
#include <Directory.h>
#include <FilePanel.h>
#include <Messenger.h>
#include <String.h>
#include <Alert.h>
#include "IRCApp.h"
#include "Prefs.h"

#include "PrivatWindow.h"
#include "send_recive.h"

#include "TextEncoding.h"

dcc::dcc()
{
	m_type = -1;
	m_socket = -1;
	m_wnd = NULL;
	m_thread_id = 0;
	m_file = NULL;
	m_pass_socket = -1;
}
dcc::~dcc(void)
{
	close();
	if( m_thread_id )
		kill_thread( m_thread_id );	
	if( m_file )
		delete m_file;	
}
bool dcc::close(void)
{
	m_wnd = NULL;
	if(m_socket != -1)
	{				
		m_wnd = NULL;
		closesocket(m_socket);
		m_socket = - 1;
		status_t ret;
		wait_for_thread( m_thread_id,  &ret );
		m_thread_id = 0;
	}
	return true;
}
bool dcc::new_chat(char *nick, int irc_soket)
{
	sockaddr_in address;
	address.sin_family			= AF_INET;
	address.sin_port				= htons(0); 
	address.sin_addr.s_addr	= INADDR_ANY;
	m_pass_socket = ::socket( AF_INET, SOCK_STREAM, 0 );
	
	if( ( bind( m_pass_socket, ( struct sockaddr *) &address, sizeof( address ) ) < 0 ) || 
	    ( listen( m_pass_socket, 100 ) < 0 ) )
	{
		closesocket( m_pass_socket );
		return false;
	}
	int iSize = sizeof( address );
	getsockname( m_pass_socket, (struct sockaddr*)&address, &iSize );
	uint port = ntohs( address.sin_port );
	char sz_msg[128];
	
	//sockaddr_in my_addr;
	
	sprintf( sz_msg, "PRIVMSG %s :\01DCC CHAT chat %u %u\01\n", nick, (unsigned)ntohl( address.sin_addr.s_addr ), port );
	if( send( irc_soket , sz_msg, strlen( sz_msg ), 0) < 0)
	{
		closesocket( m_pass_socket );
		return false;
	}
	

	m_wnd = (BWindow*) new PrivatWindow( this, nick);
	m_type = 1;
	m_thread_id = spawn_thread( dcc::dcc_call_thread, "dcc_call_thread", B_NORMAL_PRIORITY, this);
	resume_thread( m_thread_id );

	return true;
}
bool dcc::new_send( const char *nick, const char *file, int irc_soket )
{
	sockaddr_in address;
	address.sin_family			= AF_INET;
	address.sin_port				= htons(0); 
	address.sin_addr.s_addr	= INADDR_ANY;
	
	if( !strcasecmp( file, "$file") )
	{
		BLooper *lp = new BLooper( "open/save looper" );
		lp->AddHandler(this);
		lp->Run();
		
		BFilePanel *fPanel = new BFilePanel( B_OPEN_PANEL, new BMessenger( this, lp ), NULL, 0, false, NULL, NULL, true, true);
		fPanel->Window()->SetTitle( "Select a file" );
		BMessage *msg= new BMessage('file');
		msg->AddString( "nick", nick );
		msg->AddInt16( "irc_socket", irc_soket );
		msg->AddPointer( "dialog", fPanel);
		msg->AddPointer( "looper", lp );
		fPanel->SetMessage( msg );
		//	myPanel->SetButtonLabel(B_DEFAULT_BUTTON, "Send");
		fPanel->SetTarget( this );
		fPanel->Show();			
		return true;
	}
	m_file = new BFile(); 
	if( !m_file )
		return false;
		
	m_file->SetTo( file, B_READ_ONLY );
	if( m_file->InitCheck() != B_OK)
	{
		delete m_file;
		m_file = NULL;
		return false;
	}	
	off_t size_t;
	m_file->GetSize( &size_t );
	m_file_size = size_t;
	if( m_file_size < 1 )
	{
		delete m_file;
		m_file = NULL;
		return false;
	}	
	BPath path( file );
	
	m_pass_socket = ::socket( AF_INET, SOCK_STREAM, 0 );
	
	if( ( bind( m_pass_socket, ( struct sockaddr *) &address, sizeof( address ) ) < 0 ) || 
	    ( listen( m_pass_socket, 100 ) < 0 ) )
	{
		closesocket( m_pass_socket );
		delete m_file;
		m_file = NULL;
		return false;
	}
	int iSize = sizeof( address );
	getsockname( m_pass_socket, (struct sockaddr*)&address, &iSize );
	uint port = ntohs( address.sin_port );
	char sz_msg[128];
	
	BString bstr( path.Leaf() );
	bstr.ReplaceAll( " ", "_" );
	sprintf( sz_msg, "PRIVMSG %s :\01DCC SEND %s %u %u %u\01\n", nick, bstr.String(), (unsigned)ntohl( address.sin_addr.s_addr ), port, (unsigned)m_file_size );
	if( send( irc_soket , sz_msg, strlen( sz_msg ), 0) < 0)
	{
		closesocket( m_pass_socket );
		delete m_file;
		m_file = NULL;
		return false;
	}
	
	m_wnd = (BWindow*) new SendResiveWindow( this, false,  file, m_file_size );
	m_type = 2;
	m_thread_id = spawn_thread( dcc::dcc_call_thread, "dcc_call_thread", B_NORMAL_PRIORITY, this);
	resume_thread( m_thread_id );
	return true;
}
int32 dcc::dcc_call_thread(void *arg)
{
	dcc *_this = static_cast<dcc*>( arg );
	{
		BMessage msg('dcc');
		msg.AddString( "text", "Connecting..." );	
		_this->m_wnd->PostMessage( &msg );																		
	}

	if( !_this->get_accept_read( _this->m_pass_socket,120 ) )
	{
		closesocket( _this->m_pass_socket );
		if( _this->m_file )
			delete _this->m_file;
		_this->m_file = NULL;	
		delete _this;
		return 1;
	}
	
	//???????????????
	
	sockaddr_in address;
	address.sin_family			= AF_INET;
	
	int iSize = sizeof( address );
	getsockname( _this->m_pass_socket, (struct sockaddr*)&address, &iSize );
	
	_this->m_socket = accept( _this->m_pass_socket, (struct sockaddr*)&address, &iSize );
	if( _this->m_socket == -1)
	{
		closesocket( _this->m_pass_socket );
		if( _this->m_file )
			delete _this->m_file;
		_this->m_file = NULL;	
		delete _this;
		return 1;
	}
	_this->m_ip = address.sin_addr.s_addr;
	_this->m_port = address.sin_port;
		
		// Connected
		_this->m_thread_id = spawn_thread( (_this->m_type == 1) ? dcc::dcc_chat_thread : dcc::dcc_send_file_thread, 
						"dcc_thread", B_NORMAL_PRIORITY, _this);
		_this->m_type = -1;
		resume_thread( _this->m_thread_id );
		closesocket( _this->m_pass_socket );
		_this->m_pass_socket = -1;
	return 0;
}

bool dcc::get_accept_read(int sock, int sec)
{
	struct fd_set in_fd_set;
	struct timeval tv;

	FD_ZERO(&in_fd_set);
	FD_SET(sock,&in_fd_set);

	tv.tv_sec  = sec;
	tv.tv_usec = 0;

	select( sock + 1, &in_fd_set, 0 , 0 , sec ? &tv : NULL );
	return FD_ISSET(sock, &in_fd_set);
}
#include <Mime.h>
#include <Node.h>
#include <NodeInfo.h>

bool dcc::init_send( char *nick, char *file, char *ip, char *port, char *size)
{
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();
	bool is_auto_accept = false;
	pref_msg->FindBool( "_dcc_auto_send_", &is_auto_accept );			
	char *endpoint;
	const char *download_path = NULL;
	pref_msg->FindString( "_dcc_folder_", &download_path ); 
	prefs->Unlock();
	
	m_ip = strtoul( ip, &endpoint, 10 );
	m_port = atoi( port );
	m_file_size = atol( size );
	const char* file_ext = strrchr( file, '.' );
	
	if( !is_auto_accept )
	{
		char sz_msg[ 128 ];
		sprintf( sz_msg, "Accept DCC SEND.  %s %.2fKb from %s", file,  (float)m_file_size / 1024.f , nick );
		BAlert *alert = new BAlert ("alert", sz_msg, "No",  "Yes", NULL,
			B_WIDTH_AS_USUAL, B_EVEN_SPACING, B_WARNING_ALERT);
		int32 button_index = alert->Go();
		if( button_index == 0 )
			return false;	
	}
	if( file_ext )
  	{
  		file_ext++;
  		
  		BMessage mime_type_msg;
		BMimeType::GetInstalledTypes( &mime_type_msg );
		const char *sz_app_type = NULL;
  	
		type_code type;
		int32 numBytes = 0;
		if ( mime_type_msg.GetInfo("types", &type, &numBytes) == B_OK ) 
		{
			int32 mime_count = 0;
			int32 len;
			while( true )
			{		
				if( mime_type_msg.FindData( "types", type, mime_count++, (const void**)&sz_app_type, &len) != B_OK )
					break;
				BMimeType mime_type( sz_app_type );
				BMessage msg_type;
				if ( mime_type.GetFileExtensions( &msg_type ) == B_OK) 
				{
					int32 i = 0;
					const char *ptr_ext;
					while (true) 
					{
						if ( msg_type.FindString( "extensions", i++, &ptr_ext) != B_OK ) 
							break;
						if( strcmp( ptr_ext, file_ext) == 0)
						{
							strcpy( m_sz_app_type, sz_app_type);
							goto  ext_find;									 
						}	
					}
				}
			}
		}	
	}//if

ext_find:
	
	m_file = new BFile(); 
	
	BPath path;
	if( download_path )
	{
		if( path.SetTo( download_path ) != B_OK )
			goto gg;
		if( path.InitCheck() != B_OK )
			goto gg;
	}
	else
	{
	gg:	
		app_info info;
		be_app->Lock();
		be_app->GetAppInfo(&info);
		be_app->Unlock();
		BEntry ent( &info.ref );
		ent.GetPath( &path );
		path.GetParent( &path );
	}
		
	path.Append( file );

	if( !m_file )
		return false;
	status_t ret = m_file->SetTo( path.Path() , B_READ_WRITE | B_CREATE_FILE | B_FAIL_IF_EXISTS);
	if( ret == B_FILE_EXISTS )
	{
		char sz_msg[ 128 ];
		//appFileInfo.SetTo( &m_file );
		sprintf( sz_msg, "DCC Info: \nFile %s exist, Overwrite ?", path.Path() );
		BAlert *alert = new BAlert ("alert", sz_msg, "Cancel",  "Yes", NULL,
			B_WIDTH_AS_USUAL, B_EVEN_SPACING, B_WARNING_ALERT);
		int32 button_index = alert->Go();
		if( button_index == 1 )
			m_file->SetTo( path.Path() , B_READ_WRITE|B_CREATE_FILE | B_ERASE_FILE );
	}
	 	
	if( m_file->InitCheck() != B_OK )
	{
		delete m_file;
		m_file = NULL;
		return false;	
	}	
	
	
	
	if( ( m_socket = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		delete m_file;
		m_file = NULL;
		return false;
	}
	m_wnd = (BWindow*) new SendResiveWindow( this, true,  file, m_file_size, m_sz_app_type );
	//((SendResiveWindow*)m_wnd)->SetIcon( m_sz_app_type );
	
	m_thread_id = spawn_thread( dcc::dcc_get_file_thread, "dcc_thread", B_NORMAL_PRIORITY, this);
	resume_thread( m_thread_id );
	return true;	
}

bool dcc::init_chat( char *nick, char *ip, char *port)
{
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();
	bool is_auto_accept = false;
	pref_msg->FindBool( "_dcc_auto_chat_", &is_auto_accept );		
	prefs->Unlock();
	if( !is_auto_accept )
	{
		char sz_msg[ 128 ];
		sprintf( sz_msg, "Accept DCC CHAT with %s", nick );
		BAlert *alert = new BAlert ("alert", sz_msg, "No",  "Yes", NULL,
			B_WIDTH_AS_USUAL, B_EVEN_SPACING, B_WARNING_ALERT);
		int32 button_index = alert->Go();
		if( button_index == 0 )
			return false;
	}	
	
	
	char *endpoint;
	m_ip = strtoul( ip, &endpoint, 10 );
	m_port = atoi( port );
	m_wnd = (BWindow*) new PrivatWindow( this,  nick );

	if( ( m_socket = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		return false;
	}	
	m_type = 3;
	m_thread_id = spawn_thread( dcc::dcc_chat_thread, "dcc_thread", B_NORMAL_PRIORITY, this);
	resume_thread( m_thread_id );
	return true;
}

int32 dcc::dcc_send_file_thread(void *arg)
{
	dcc *_this = static_cast<dcc*>( arg );
	char buff [ 1024*1 ];
	
	int buff_size = 512;
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	BMessage *pref_msg = prefs->GetMsg();
	int16 idx = 0;
	pref_msg->FindInt16( "_dcc_buffer_size_", &idx );			
	if( idx )
		buff_size = 1024;
	else
		buff_size = 512;
			
	prefs->Unlock();
	
	
	long received = 0;
	long must_read = 0;
	u_long feedback = 0;
	try
	{
	while( 1 )
	{
		if( received >= _this->m_file_size)
			break;
		must_read = _this->m_file->Read( buff, buff_size );
		if( must_read < 1)
			break;
		if( _this->m_socket != -1 && (must_read = send( _this->m_socket, buff, must_read, 0 ) )< 0 )
			break;
		feedback = 0;
		
		must_read = 0;
		if( _this->m_socket != -1 )
			must_read = recv( _this->m_socket, &feedback, sizeof( feedback ), 0);
		
		if( (unsigned)must_read < sizeof( feedback ) )
			break;
		received = ntohl( feedback );
		_this->m_file->Seek( received, SEEK_SET);
		BMessage msg( 'inc' );
		msg.AddInt32( "len", received );
		_this->m_wnd->PostMessage( &msg );	
	}
	}catch(...) { }
	
	if( _this->m_socket != -1)
		closesocket( _this->m_socket);
	_this->m_socket = -1;
	
	if( _this->m_wnd )
	{
		//BMessage msg( 'qdcc' );
		_this->m_wnd->PostMessage( 'qdcc' );
	}	
	
	//delete _this->m_file;
	//_this->m_file = NULL;
	return 0;
}
int32 dcc::dcc_get_file_thread(void *arg)
{
	dcc *_this = static_cast<dcc*>( arg );
	struct sockaddr_in sa;

	memset( &sa, 0, sizeof( sa) );	
	sa.sin_family = AF_INET;
	sa.sin_port = htons( _this->m_port );
	sa.sin_addr.s_addr = htonl( _this->m_ip );
	long received = 0;
	long must_read = 0;
	u_long feedback = 0;
	char buff [ 1024*4 ];

	
	if( connect( _this->m_socket, (struct sockaddr *)&sa, sizeof(sa)) < 0) 
		goto end;

	try
	{
	while( 1 )
	{
		if( received == _this->m_file_size)
			break;
		must_read = sizeof( buff );
		if( must_read > ( _this->m_file_size - received) )
			must_read = ( _this->m_file_size - received);
		
		if( _this->m_socket != -1 )
			must_read = recv( _this->m_socket, buff, must_read, 0);
		else
			must_read = 0;	
			
		if( must_read > 0 )
		{
			_this->m_file->Lock();
			_this->m_file->Write( buff, must_read );
			_this->m_file->Unlock();
			_this->m_file->Sync();
			received += must_read;
			feedback = htonl( received );
			if( _this->m_socket != -1 )
				send( _this->m_socket, &feedback, sizeof( feedback ), 0); 
			BMessage msg( 'inc' );
			msg.AddInt32( "len", received );
			_this->m_wnd->PostMessage( &msg );
		}else break;	
 	
	}//wile ( 1 )
	} catch(...){ }
end:
	BNodeInfo node_info( (BNode*)_this->m_file );	
	if( node_info.InitCheck() == B_OK )
		node_info.SetType( _this->m_sz_app_type );

	_this->m_file->Unset();	
	if( _this->m_socket != -1)
		closesocket( _this->m_socket);
	_this->m_socket = -1;
	
	if( _this->m_wnd )
	{
		//BMessage msg( 'qdcc' );
		_this->m_wnd->PostMessage( 'qdcc' );
	}	
	
	_this->m_file = NULL;
	return 0;
}

int32 dcc::dcc_chat_thread(void *arg)
{
	dcc *_this = static_cast<dcc*>( arg );
	char buff [512];
	struct sockaddr_in sa;
		
	memset( &sa, 0, sizeof( sa) );	
	sa.sin_family = AF_INET;
	sa.sin_port = htons( _this->m_port );
	sa.sin_addr.s_addr = htonl( _this->m_ip );


	if( _this->m_type == 3)
	{
		_this->m_type = -1;
			
		if(  connect( _this->m_socket, (struct sockaddr *)&sa, sizeof(sa)) < 0) 
		{
			/*closesocket( _this->m_socket );
			_this->m_socket = -1;
			return 0;*/
			goto end;
		}
	}
{	BMessage msg('dcc');
	msg.AddString( "text", "OK\n" );	
	_this->m_wnd->PostMessage( &msg );																		
}
	try
	{
	while( 1 )
	{
		if( _this->get_accept_read(_this->m_socket, 360*1 ) )
		{
			memset(buff , 0, sizeof(buff) );
			if( !_this->readln(buff) )
				break;
			BMessage msg('dcc');
			msg.AddString("text", buff);	
			_this->m_wnd->PostMessage( &msg );
 		}else 
 		{
 			if(errno != EINTR)
 			{
 				switch(errno)
				{
					case EINPROGRESS:  
					     break;
					case EBADF:  
					     break;
					case EFAULT: 
						break;
					case ECONNREFUSED: 
						break;
					case ENOTSOCK: 
						break;
					case ETIMEDOUT: 
						break;
					case ENETUNREACH:
						break;
					case EPIPE: 
						 break;
					// Unhandled error...pass errno to the strerror function
					default: 
					  break;
				}
 				break;
 			}	
 		}	
	}//wile ( 1 )
	}catch(...){}
end:
	if( _this->m_socket != -1)
		closesocket( _this->m_socket);
	_this->m_socket = -1;
	
	if( _this->m_wnd )
	{
		//BMessage msg( 'quit' );
		_this->m_wnd->PostMessage( 'qdcc' );
	}	

	return 0;
}

bool dcc::readln(char * buff)
{ 
	int i=0;
	char ch;
	//m_lock.Lock();
	while(1) 
	{ 
		if(  recv( m_socket , &ch, 1, 0 ) < 1 )
		{
			//if(errno != EINTR)//m_lock.Unlock();
				return false;   
		}
		if(  ch == LF)
		{
			if(buff[ i - 1] == CR)
				i--;
			buff[ i++] = ch;
			buff[ i ] = 0;
			break; 
		}
		if(ch != 0)
			buff[i++]=ch; 
		if( i == 511)
		{
			buff[ i ] = '\0';
			break;
		}
 	}
	//m_lock.Unlock();

	int32 iLen2, iLen1, iState=0;
	iLen2 = iLen1=strlen(buff);

	char* newBuff = new char [iLen1 * 4];
	memset(newBuff, 0, iLen1 * 4);
	strcpy( newBuff, buff);
	iLen2 = iLen1 * 4;
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	prefs->GetMsg()->FindInt16( "encoding", &encoding);
	prefs->Unlock();
//	convert_to_utf8(encoding, newBuff, &iLen1, buff, &iLen2, &iState);
	ConvertToUTF8(encoding, newBuff, &iLen1, buff, &iLen2, &iState);
	
	delete newBuff;
	
	return true;
}

bool dcc::writeln( const char *outbuf )
{ 
	if(m_socket == -1 )
		return false;
	if(!outbuf)
		return false;
	int32 len = strlen(outbuf);
	if (len<1)
		return false;
	

	int32 iState = 0;
	char* newBuff = new char[len * 4];
	int32 len2 = len * 4;
	strcpy(newBuff, outbuf);

	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	prefs->GetMsg()->FindInt16( "encoding", &encoding);
	prefs->Unlock();
	//convert_from_utf8( encoding, outbuf, &len, newBuff,&len2,&iState);
	ConvertFromUTF8( encoding, outbuf, &len, newBuff,&len2,&iState);
	newBuff[len2] = '\0';

	if( send ( m_socket, newBuff, strlen(newBuff), 0) < 0 )
	{	
		//if(errno != EINTR)
		{
			delete[] newBuff;
			return false;
		}	
	}
	//m_lock.Unlock();
	delete[] newBuff;
	
	return true;
}	
void dcc::MessageReceived(BMessage *msg)
{
	char sz_msg[512];
	memset(sz_msg, 0, sizeof(sz_msg));
	const char* txt;
	//bool is_quit = false;
	switch (msg->what) 
	{
		case B_CANCEL:
		case 'file':
		{
			const char *nick;
			msg->FindString( "nick", &nick);
			int16 irc_port;
			msg->FindInt16( "irc_port", &irc_port );
			if( msg->what == 'file' )
			{
				entry_ref ref;
				msg->FindRef( "refs", &ref); 
				BEntry entry( &ref );
				BPath path( &entry );
				new_send( nick, path.Path() , irc_port );
			}	
			BFilePanel *ptr;
			msg->FindPointer("dialog", (void**)&ptr);			
			delete ptr;			
			BLooper *lp;
			msg->FindPointer("looper", (void**)&lp);
			lp->Quit();			
		}
		break;
		case 'irc':
		{
			msg->FindString("cmd", &txt);
			sprintf( sz_msg, "%s\n", txt); 
			writeln(sz_msg);
		}break;
	}
	 //Always handle the defaults
	BHandler::MessageReceived(msg);
}

