#include "edit_list_item.h"
#include <string.h>
#include <malloc.h>
#include "edit_list_item.h"
#include "textFilter.h"
#include "myText.h"
#include "newButton.h"
#include <Bitmap.h>
#include "constants.h"

#define DX_LOCK	16

BBitmap *RetrieveBitmap(const int32 res_id);

BBitmap*	edit_item::m_on_bmp = NULL;
BBitmap*	edit_item::m_off_bmp = NULL;
int32		edit_item::m_reff = 0;

edit_item::edit_item(const char *name)
{
	m_sz = NULL;
	m_data_ptr = NULL;
	if( name )
		m_sz = strdup(  name);
	m_locked = m_suspended = false;
	
	m_reff++;
	//SetHeight( 24.0 );
	if( !m_on_bmp )
		m_on_bmp = RetrieveBitmap( 6 );//"op.trg_bitmap");
	if( !m_off_bmp )
		m_off_bmp = RetrieveBitmap( 5 );//"vo.trg_bitmap");
}
edit_item::~edit_item()
{
	if(m_sz)
		free( m_sz );
	m_reff--;
	if( m_reff == 0 )
	{
		delete m_on_bmp;
		delete m_off_bmp;	
		m_on_bmp = m_off_bmp = NULL;
	}
	m_data_ptr = NULL;
	
}

void edit_item::add_str( const char* str)
{
	if( m_sz )
		free(m_sz);
	m_sz = NULL;
	if( str && strlen(str) > 0 )
		m_sz = strdup( str);
}

void edit_item::suspend_draw( bool b)
{
	if( m_suspended == b)
		return;
	m_suspended = b;		
}
void edit_item::DrawItem(BView *owner, BRect itemRect, bool drawEverything) 
{
	rgb_color color, hil_color; 
	color = owner->ViewColor(); 
	rgb_color hcolor = owner->HighColor();
   	
   	hil_color.red 	= uint8( color.red / 1.5);
	hil_color.green = uint8( color.green / 1.5);
   	hil_color.blue 	= uint8( color.blue / 1.5);
   		
   	if ( IsSelected() ) 
   	{	
   		owner->SetHighColor(hil_color); 	
   	}		
	else
	{
		owner->SetHighColor(color); 
	}
	itemRect.left += DX_LOCK;
	owner->FillRect(itemRect); 
	itemRect.left -= DX_LOCK;
	
   	owner->SetHighColor( hil_color ); 
   	owner->StrokeLine( itemRect.LeftBottom(), 	itemRect.RightBottom() );
	
	owner->SetHighColor( 0, 0, 0 ); 
	font_height height;
     	owner->GetFontHeight(&height); 
	owner->SetDrawingMode(B_OP_MIN);
	BBitmap *bmp;
	if( m_locked )
	{
		bmp = m_off_bmp;
	}
	else
		bmp = m_on_bmp;
	owner->DrawBitmap( bmp, BPoint( itemRect.left + 3, ((itemRect.bottom + itemRect.top)/2) - 4));
		
	owner->MovePenTo( DX_LOCK , itemRect.top +  height.ascent + height.leading);
	if( m_sz )
		owner->DrawString( m_sz ); 	
	
   	owner->SetHighColor(hcolor);
   	owner->SetDrawingMode (B_OP_COPY); 
}


///////////////////////// ///////////////////////// ///////////////////////// ///////////////////////// 
///////////////////////// ///////////////////////// ///////////////////////// ///////////////////////// 
edit_listView::edit_listView(BRect rc, const char *name,  list_view_type type,  uint32 resizingMode, uint32 flags)
	: BListView(rc, name, type,  resizingMode, flags)
{
	rc = Bounds();
  	font_height fheight;
  	GetFontHeight( &fheight );
  	float m_font_h = fheight.ascent + fheight.descent + fheight.leading;

	rc.bottom = rc.top + m_font_h;
	//m_edit = (BTextControl*)new myText( new textFilter(false) , rc, "_edit_", NULL , NULL, new BMessage('edit'), B_FOLLOW_TOP | B_FOLLOW_LEFT_RIGHT );
  	//((myText*)m_edit)->set_draw(false);
  	m_edit = new BTextControl(rc, "_edit_", NULL , NULL, new BMessage('edit'), B_FOLLOW_TOP | B_FOLLOW_LEFT_RIGHT );
  	
  	BTextView* tv = m_edit->TextView();	
  	m_edit->ResizeTo(rc.Width() - m_font_h, m_font_h );
  	tv->MoveTo(0, 0);
  	tv->ResizeBy(8, 0);
  	tv->SetFont(be_plain_font);
  	AddChild( m_edit );  	
  	m_edit->Hide();
  	
  	//m_btnDel = (BButton*)new bmpButton( BPoint( 0, 0), "_X_", 35, -1, new BMessage('Xdel') );//newButton( BRect( 0, 0, 14, 13), "btnDel", "X", NULL, 1 );
  	m_btnDel = (BButton*)new newButton(BRect(0, 0, m_font_h, m_font_h - 1), "_X_", "X", new BMessage('Xdel') );
  	m_btnDel->SetHighColor( irc_color[eRed].color );
  	((newButton*)m_btnDel)->set_type( 1 );
  	AddChild( m_btnDel );
  	  	
  	m_btnDel->Hide();
  	m_edit_item = NULL;
  	m_idx_from = -1;
}
edit_listView::~edit_listView()
{
//	RemoveChild( m_edit );
//	delete m_edit;
}
void edit_listView::AttachedToWindow(void)
{
	BListView::AttachedToWindow();
	m_btnDel->SetTarget( this );
}
void edit_listView::FrameResized(float new_width, float new_height)
{
	int32 cur_sel =  CurrentSelection();
	BRect rc = ItemFrame( cur_sel );
	ConvertToParent( &rc );
	m_btnDel->MoveTo( rc.right - rc.Height(), rc.top );
}
/*void edit_listView::KeyDown(const char *bytes, int32 numBytes)
{

	switch(bytes[0])
	{
		case B_ENTER:
		{
			SelectionChanged();
		}	return;
		case B_DELETE:			
		case B_BACKSPACE:
		case B_UP_ARROW:
		case B_DOWN_ARROW:
		case B_TAB:
		case B_LEFT_ARROW:
		case B_RIGHT_ARROW:
		case B_INSERT:
		case B_HOME:
		case B_END:
		case B_PAGE_DOWN:
		case B_PAGE_UP:
		case B_ESCAPE:
		case B_FUNCTION_KEY:
			break;
	}
	BListView::KeyDown( bytes,  numBytes);
}
*/
bool edit_listView::InitiateDrag( BPoint pt, int32 index, bool wasSelected)
{
	edit_item* item = (edit_item*) ItemAt( index );
	if( item->locked() )
		return false;
	
	BMessage msg( 'drg' );
	//msg.AddInt32("idx", index);
	m_idx_from = index; 
	//DragMessage( &msg, s_on_bmp, BPoint( 4, 4) );
	StopEdit();
	DragMessage( &msg, ItemFrame( index ));
	return true;	
}
void edit_listView::MouseMoved( BPoint where, uint32 code,	const BMessage *msg)
{
	if( !msg )
		return;
	if( msg->what != 'drg' )
		return;// BListView::MouseMoved( pt, transit, msg);
	//if( code != B_EXITED_VIEW )
	{
		//ConvertFromScreen( &pt );
		int32 idx = IndexOf( where );
		if( idx >= 0 && m_idx_from >=0 )
		{	
			edit_item* item = (edit_item*) ItemAt( idx );
			if( !item->locked() && m_idx_from != idx)
			{
				MoveItem( m_idx_from, idx);
				//msg->ReplaceInt32("idx", idx );
				m_idx_from = idx;
			}
		
		}
		ScrollToSelection();	
		//BListView::MouseMoved( pt, transit, msg);
		//ScrollTo( 0, where.y );
	}
	return;	
}
void edit_listView::StopEdit(void)
{
	if( m_edit_item == NULL )
		return;
/*	if( Window() )
		Window()->Lock();
		
	
	BMessage * msg = SelectionMessage();
	if( msg )
	{
		msg->AddBool( "StopEdit", true);
		if( m_edit_item->get_ptr() ) 
			msg->AddString( "StopEdit", m_edit_item->get_ptr() );
		else
			msg->AddString( "StopEdit", "_NULL_" );	
	}
*/	
	m_edit->Hide();
	m_btnDel->Hide();
	const char *ptr = m_edit->Text();
	if( ptr && *ptr )
	{
		m_edit_item->add_str( ptr );
		/*if( msg ) 
			msg->AddString( "StopEdit", m_edit_item->get_ptr() );	
		*/	
	}	
	else
		m_edit_item->add_str( NULL );	
	
	m_edit_item = NULL;
	
/*	if( msg ) 
	{
		Invoke( msg );
		msg->RemoveName("StopEdit");
	}	

	if( Window() )
		Window()->Unlock();
*/		
}
void edit_listView::SelectionChanged(void)
{
	//BListView::SelectionChanged();
	//RemoveChild( m_edit );
	int32 cur_sel = CurrentSelection();
	//BMessage * msg = SelectionMessage();

	if( m_edit_item )
	{
		m_edit->Hide();
		m_btnDel->Hide();
		if( strlen( m_edit->Text()) < 1 && LastItem() != m_edit_item)
		{
			if( Window()) 
				Window()->Lock();
			RemoveItem( m_edit_item );
			delete m_edit_item;
			m_edit_item = NULL;
			if( Window())
				Window()->Unlock();			
			return;
		}

			
		/*if( msg && m_edit_item->get_ptr() )
		{
			msg->AddBool( "StopEdit", true);
			msg->AddString( "StopEdit", m_edit_item->get_ptr() );	
			msg->AddString( "StopEdit", m_edit->Text() );	
		}	
		*/	
		m_edit_item->add_str( m_edit->Text() );
		
		const char *ptr = ((edit_item*)LastItem())->get_ptr();
		if( ptr && strlen( ptr ) > 0 )
		{
			AddItem( new edit_item() );						
		}	
	}
/*	Window()->Unlock();
	if( msg ) 
	{
		Invoke( msg );
		msg->RemoveName("StopEdit");
	}	
*/
	m_edit_item = NULL;
	if( cur_sel < 0)
	{			
		return;
	}
	
	m_edit_item = (edit_item*) ItemAt( cur_sel );
	if( m_edit_item->locked() )
	{
		m_edit_item = NULL;
		return;
	}

	if(Window())
		if( Window()->Lock() )
		{
			BRect rc = ItemFrame( cur_sel );
			ConvertToParent( &rc );
			m_edit->MoveTo( rc.left + DX_LOCK, rc.top );
			m_edit->ResizeTo(rc.Width() - DX_LOCK - rc.Height(), rc.Height() - 1);
			m_edit->SetText( m_edit_item->get_ptr() );
			m_btnDel->MoveTo( rc.right - rc.Height(), rc.top );
			m_btnDel->Show();
			m_edit->Show();
			m_edit->MakeFocus();
		
			Window()->Unlock();
		}	

}
void edit_listView::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		case 'ntr':
		{
			BMessage *l_target;
			if( message->FindPointer("target", (void**)&l_target) != B_OK)
				break;
			if ( l_target->what == 'edit')
			{
				//BTextControl* mms = (BTextControl*)FindView("message");
				//const char* sz_txt =  mms->Text();
				SelectionChanged();
			}			
		}
		break;	
		case 'Xdel':
		{
			Invoke( message );
			Window()->Lock();
			int32 cur_sel = CurrentSelection();
			StopEdit();			
			delete RemoveItem( cur_sel );
			Window()->Unlock();
		}
		break;
		case 'drg':
		{
			m_idx_from = -1;
			SelectionChanged();
		}
		break;
		
	}
	BListView::MessageReceived(message);			
}

