#ifndef _EDITLISTITEM_H
#define  _EDITLISTITEM_H
#include <ListItem.h>
#include <ListView.h>
//#include "newButton.h"

class BBitmap;

class edit_item : public BListItem 
{ 
public: 
	edit_item(const char *name = NULL);
	virtual ~edit_item(); 
	
	void* get_data(void){ return m_data_ptr; }
	void set_data(void* ptr){  m_data_ptr = ptr; }
	
	void add_str( const char* str);
	const char *get_ptr(void) { return m_sz; }
	void suspend_draw( bool b);
	bool is_suspended(void) { return m_suspended; }
	bool &locked() { return m_locked; }
	virtual void   DrawItem(BView *owner, BRect frame, bool complete = false); 
private: 
	float	m_font_h;
	void* 	m_data_ptr;
	char	*m_sz;
	bool	m_suspended;
	bool	m_locked;
static BBitmap *m_on_bmp;
static BBitmap *m_off_bmp;
static int32	m_reff;
};

class BButton;

class edit_listView : public BListView
{
public:
	edit_listView(BRect rc, const char *name,  list_view_type type = B_SINGLE_SELECTION_LIST, 
		uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP, uint32 flags = B_WILL_DRAW | B_NAVIGABLE | B_FRAME_EVENTS);
	virtual ~edit_listView();

	//virtual void MouseDown(BPoint point);
	virtual void MessageReceived(BMessage* message);
	virtual void SelectionChanged(void);
	void	StopEdit(void);
	bool	InitiateDrag( BPoint pt, int32 index, bool wasSelected);
	virtual	void MouseMoved( BPoint where, uint32 code,	const BMessage *a_message);
	virtual void AttachedToWindow(void);
	void FrameResized(float new_width, float new_height);
protected:
	BTextControl	*m_edit;    
	BButton		*m_btnDel; 
	edit_item		*m_edit_item;
	int32			m_idx_from;
};
#endif