#include "init_prefs.h"
#include <Message.h>
#include <Path.h>
#include <Application.h>
#include <Entry.h>
#include <stdio.h>
#include "Prefs.h"

#include "constants.h"

em_colors irc_event_color[] = 
{
	eBlack,	//eBkColor = 0,
	eOrange,	//eNotice,
	eGreen,		//eJoin,
	eMedMetallicBlue,		//ePart,
	//eMedMetallicBlue,			//eQuit,
	eLightBlue,		//eNick,
	ePurple,		//eInvite,	
	eYellow,		//eTopic,
	ePurple,		//eMode,
	eRed,			//eKick,
	eLightMetallicBlue,		//eNote,
	eWhite,		//eChanel_Notice,
	eLightGreen,		//eServer_Notice,
	eGreen,		//eWallop,
	eOrange,		//eCTCP_Query,
	eRed,			//eCTCP_Reply,
	eRed,			//eAction,
	eRed,			//eError_Message,
	eLightMetallicBlue,	//eInformation,
	ePurple,		//eAway_Message,
	eRed,			//eIRC_Operator_Tag,
	eWhite,	//eOwn_Txt,
	eLightGrey			//eNormal_Txt	
};

const int num_irc_event_color = sizeof(irc_event_color)/sizeof(irc_event_color[0]);

bool init_main_prefs( BMessage *msg )
{
///////////  main window
	if( !msg->HasPoint("IRCAppWindow") )
	{
		BPoint pt( 30,30);
		if( msg->AddPoint("IRCAppWindow", pt) != B_OK)
			return false; 
	}		
/////////// default user settings
	if( !msg->HasString("nick") )
		if( msg->AddString("nick", "be_user") != B_OK)
			return false;
	if( !msg->HasString("nick2") )		
		if( msg->AddString("nick2", "be_user_2") != B_OK)
			return false;
	if( !msg->HasString("name") )
		if( msg->AddString("name", "my name") != B_OK)
			return false;
	if( !msg->HasString("userinfo") )
		if( msg->AddString("userinfo", "empty") != B_OK)
			return false;
//	if( msg->HasString("server") )	
//		if( !msg->AddString("server", "ca.undernet.org:6667"))
//			return false;

/////////  default colors shema	
	for( int16 i = 0; i < int16(num_irc_event_color); i++)
	{	
		int16 cl;
		const char sz_in[] = "event_colors";
		if( !msg->HasInt16( sz_in, i ) )
		{
			if( msg->AddInt16( sz_in, irc_event_color[ i ]) != B_OK)
				return false;
		}
		else
		{
			if( msg->FindInt16( sz_in, i, &cl ) != B_OK)
				return false;
			irc_event_color[ i ] = (em_colors)cl;
		}		
	}
////////// active tab in the settings dialog
	if( !msg->HasInt16( "active_tab") )
		if( msg->AddInt16( "active_tab", 0 ) != B_OK)
			return false;
		
///////// predefined chats
	if( !msg->HasString("def_chats") )
		if( msg->AddString("def_chats", "#beos") != B_OK)
			return false;
		
//////// defined commands
	if( !msg->HasString("def_commands") )
		if( msg->AddString("def_commands", "/j .JOIN %1") != B_OK)
			return false;

//////// encoding
	if ( !msg->HasInt16("encoding") )
		if( msg->AddInt16("encoding", (int16)B_MS_WINDOWS_CONVERSION) != B_OK)
			return false;
		
///////// ident server
  	if( !msg->HasString("ident_name") )
		if( msg->AddString("ident_name", "Bardak" ) != B_OK)
			return false;
  	if( !msg->HasString("ident_server") )
		if( msg->AddString("ident_server", "UNIX" ) != B_OK)
			return false;
	if( !msg->HasBool( "active_ident" ) )
		if( msg->AddBool( "active_ident", false ) != B_OK)
			return false;

//////////// Default Messages
	if( !msg->HasString( "_part_" ) )
		if( msg->AddString( "_part_", "bye bye:)") != B_OK)
			return false;
	if( !msg->HasString( "_quit_" ) )
		if( msg->AddString( "_quit_", "Leaving") != B_OK)
			return false;
/*	if( !msg->HasString( "_kick_" ) )
		if( !msg->AddString( "_kick_", "fuck off"))
			return false;
*/
/////////// DCC
	if( !msg->HasBool( "_dcc_auto_chat_" ) )
		if( msg->AddBool( "_dcc_auto_chat_", false ) != B_OK)
			return false;

	if( !msg->HasBool( "_dcc_auto_send_" ) )
		if( msg->AddBool( "_dcc_auto_send_", false ) != B_OK)
			return false;
	if( !msg->HasInt16( "_dcc_buffer_size_" ) )
		if( msg->AddInt16( "_dcc_buffer_size_", 0 ) != B_OK)
			return false;
	if( !msg->HasString( "_dcc_folder_" ) )
		if( msg->AddString( "_dcc_folder_", "" ) != B_OK)
			return false;
	if( !msg->HasInt16( "_dcc_answer_time_" ) )
		if( msg->AddInt16( "_dcc_answer_time_", 120 ) != B_OK)
			return false;
////////////////////
	if( !msg->HasInt16("ChanelsListSize") )
		if( msg->AddInt16("ChanelsListSize", 180 ) != B_OK)
			return false;
	if( !msg->HasBool("CollapseList") )
		if( msg->AddBool("CollapseList", false ) != B_OK)
			return false;

////////////////
	if( !msg->HasString("default_server") )
		msg->RemoveName("default_server"); // delete old version
	if( !msg->HasString("default_server2.3") )
		msg->RemoveName("default_server2.3"); // delete old version
		
///////////////
	if( !msg->HasString("last_network") )
		if( msg->AddString("last_network", "") != B_OK)
			return false;
//////////////
	if( !msg->HasString("default_font") )
	{
		font_family 	font_name;
		font_style 	font_s;
		be_plain_font->GetFamilyAndStyle( &font_name, &font_s);
		msg->AddString("default_font", font_name );
	}
	if( !msg->HasInt16("default_font_size") )
	{
		msg->AddInt16("default_font_size", 12);
	}
////////////// SOCKS5
	if( !msg->HasString("socks5_usr_name") )
		if( msg->AddString("socks5_usr_name", "") != B_OK)
			return false;
	if( !msg->HasString("socks5_password") )
		if( msg->AddString("socks5_password", "") != B_OK)
			return false;
	if( !msg->HasString("socks5_host") )
		if( msg->AddString("socks5_host", "") != B_OK)
			return false;
	if( !msg->HasString("socks5_port") )
		if( msg->AddString("socks5_port", "1080") != B_OK)
			return false;
	if( !msg->HasBool( "use_socks5" ) )
		if( msg->AddBool( "use_socks5", false ) != B_OK)
			return false;
			
///// 

return true;
}

#include <string.h>
//char   *strchr(const char *str, int chr);

#include "SettingsView.h"
static const char s_sz_net_name[] = "Network_names";

bool load_servers(BMessage *main_msg)
{
	BMessage net_msg;
	
///////// get cur_dir ///
	app_info info;
	be_app->Lock();
	be_app->GetAppInfo(&info);
	be_app->Unlock();
	BEntry ent( &info.ref );
	BPath path;
	ent.GetPath( &path );
	path.GetParent( &path );
	path.Append("Servers.ini");
	if( path.InitCheck() != B_OK )
		return false;
	FILE *f = fopen( path.Path(), "r");
	if( !f )
	{
		net_msg.AddString( s_sz_net_name, "Undernet");
		server_user_info user_info;
		user_info.is_default = true;
		strcpy( user_info.server, "ca.undernet.org:6667");
		net_msg.AddData( "Undernet", B_RAW_TYPE, (void*)&user_info, sizeof(user_info) );	
		net_msg.AddString( s_sz_net_name, "DALnet");
		strcpy( user_info.server, "irc.dal.net:7000");
		net_msg.AddData( "DALnet", B_RAW_TYPE, (void*)&user_info, sizeof(user_info) );	
		if( main_msg->AddMessage("IRCNetworks", &net_msg) != B_OK )
			return false;
		return true;
	}	
////////////////////


	char sz_buff[256];
	while( !feof(f) )
	{
		fgets( sz_buff, sizeof( sz_buff), f );
		if( strlen( sz_buff ) < 1)
			continue;
		
		if( sz_buff[0] != '[' )
			continue;
		int count = 0;
		char *ptr = strchr( &sz_buff[1], ']' );
		if( !ptr )
			continue;
		*ptr = '\0';	 
		char sz_name[64];
		strcpy(sz_name, &sz_buff[1] );
		
		net_msg.AddString( s_sz_net_name, sz_name);
		
		fscanf( f, "count=%i\n", &count );
		sz_buff[0]='\0';
		for( int i = 0 ; i < count; i++)
		{
			char sz_format[16];
			sprintf( sz_format, "%i=", i + 1);
			if( sz_buff[0]=='\0' )
				fgets( sz_buff, sizeof( sz_buff), f );
			if( strlen( sz_buff) < 1 )
			{
				sz_buff[0]='\0';
				continue;
			}	
			sz_buff[ strlen(sz_buff) - 1  ] = '\0';
			if( strncmp( sz_buff, sz_format, strlen(sz_format)) == 0)
			{
				server_user_info user_info;// = new server_user_info;				
				user_info.is_default = true;
				strcpy( user_info.server, &sz_buff[ strlen(sz_format) ]);
				fgets( sz_buff, sizeof( sz_buff), f );
				if( sz_buff[0] == '#')
				{
					sz_buff[ strlen(sz_buff) - 1  ] = '\0';
					user_info.is_default = false;
					user_info.is_ident = sz_buff[1] == 'T';
					char *ptr = strchr( &sz_buff[ 3 ], ',');
					if( ptr)	
					{
						*ptr = '\0';
						strcpy( user_info.nick1, &sz_buff[ 3 ]);
						strcpy( user_info.nick2, ptr+1 );	
					}
					else
						user_info.is_default = true;
					sz_buff[0]='\0';		
				}
				net_msg.AddData( sz_name, B_RAW_TYPE, (void*)&user_info, sizeof(user_info) );	
			}
			
		}	
	}
	fclose(f);
	
	if( main_msg->AddMessage("IRCNetworks", &net_msg) != B_OK )
		return false;

	return true;	
}
bool save_servers(BMessage *main_msg)
{
///////// get cur_dir ///
	app_info info;
	be_app->Lock();
	be_app->GetAppInfo(&info);
	be_app->Unlock();
	BEntry ent( &info.ref );
	BPath path;
	ent.GetPath( &path );
	path.GetParent( &path );
	path.Append("Servers.ini");
	if( path.InitCheck() != B_OK )
		return false;
	FILE *f = fopen( path.Path(), "w");
	if( !f )
		return false;
////////////////////

	BMessage net_msg;
	if( main_msg->FindMessage("IRCNetworks", &net_msg) != B_OK )
		return false;
		
	int32 count = 0;
	type_code type_found;
	net_msg.GetInfo( s_sz_net_name, &type_found,  &count);
	char sz_buff[ 256 ] = "!!!!!!!!!!!!! Do not edit this file !!!!!!!!!!!!!!\nIf you try edit make a copy:))\n\n";
	fwrite(sz_buff, strlen(sz_buff ), 1, f );
						
	for( int32 i = 0; i < count; i++)
	{
		const char *sz_name;
		if( net_msg.FindString( s_sz_net_name, i, &sz_name) != B_OK )
			return false;
		sprintf( sz_buff, "[%s]\n", sz_name);
		fwrite(sz_buff, strlen(sz_buff ), 1, f );		
		int32 count2 = 0;
		net_msg.GetInfo( sz_name , &type_found,  &count2 );
		sprintf( sz_buff, "count=%i\n", (int)count2 );
		fwrite(sz_buff, strlen(sz_buff ), 1, f );		
		
		for( int32 j = 0; j < count2; j++)
		{
			const server_user_info  *user_info;
			ssize_t bytes;
			net_msg.FindData(sz_name, B_RAW_TYPE, j, (const void**)&user_info, &bytes);
			sprintf( sz_buff, "%i=%s\n", (int)(j + 1),  user_info->server);
			fwrite(sz_buff, strlen(sz_buff ), 1, f );					
			if( !user_info->is_default )
			{
				sprintf( sz_buff, "#%c,%s,%s\n", user_info->is_ident ?'T' : 'F',  user_info->nick1, user_info->nick2);
				fwrite(sz_buff, strlen(sz_buff ), 1, f );
			}							
		}
		fwrite("\n", 1, 1, f );	
	}
	fclose(f);
	main_msg->RemoveName("IRCNetworks");
	return true;
}