#include "irc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <OS.h>
#include <UTF8.h>
#include <List.h>

#include <sys/types.h>
#include <ctype.h>
//#include <socket.h>
#include <netdb.h>
//#include <unistd.h>
#include <errno.h>
#include <Debug.h>

#include "socks5.h"

#include "DebugWindow.h"
#include "IRCApp.h"
#include "Prefs.h"
#include "irc_util.h"

#include "dcc.h"
#include "TextEncoding.h"

extern DebugWindow *g_debug;

///////////////////////////////////////////////////////////////
////////              IRC             //////////////////////
BLocker 	irc::m_lock;
thread_id 		irc::m_ident_thread_id	=  0;
bigtime_t		irc::ms_ident_time		=  0;
int 				irc::m_ident_socket 		= -1;

irc::irc(BLooper* target) : 
	BHandler("irc"), 
	m_target(target)
{
	//net_thread_socket=-1;
	m_thread_id = spawn_thread(irc::net_irc_thread_stub, "irc_thread", B_NORMAL_PRIORITY, this);
	set_thread_priority(m_thread_id, B_NORMAL_PRIORITY);
	//resume_thread(net_thread_id);
	m_socket = -1;
	m_nickname[0] = '\0';
	m_ucmd = new BList();
	get_ucmd();
	m_buff = NULL;
	m_buff_size = 0;
	m_buff_tail = 0;
	m_is_stop = false;
	m_info = NULL;
	
	//socks5 init
	m_socks5_port = 1080; //default
	m_is_socks5 = false;
	m_socks5_rassword[ 0 ] = m_socks5_user_name[0] = '\0';

	///////// ttttttt	
	strcpy( m_socks5_server_name, "192.168.1.4");
	strcpy( m_socks5_user_name, "dipa");
	strcpy( m_socks5_rassword, "123");
	//m_is_socks5 = true;
	///////// ttttttt
	
}
irc::~irc()
{
  if(m_socket != -1)
	{		
		msg_info("Quiting...");
		const char *quit_txt;
		Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
		prefs->Lock();
		prefs->GetMsg()->FindString("_quit_", &quit_txt );
		prefs->Unlock();
		char sz_quit[256];
		sprintf( sz_quit, "QUIT :%s\n", quit_txt);		
		writeln( sz_quit );
		m_is_stop = true;
		status_t ret;
		wait_for_thread(m_thread_id, &ret);
		msg_info("Ok\n");
	}
	else
		kill_thread( m_thread_id );

	m_socket = -1;

	void *anItem;
	int i = 0;
	while ( true ) 
	{
		anItem = m_ucmd->ItemAt(i);
		if( !anItem )
			break;
		delete anItem; 
		i++;
	}
		
	if( m_buff )
		delete m_buff;
	delete m_info;	
	//msg_info("READY.\n");
}
/*void irc::setup(char *server_name, char* ports)
{
	strcpy(m_server_name, server_name) ;
	strcpy(m_ports, ports);			
}*/
void irc::set_user_info( server_user_info* pInfo, const char *sz_network_name )
{
	delete m_info;
	m_info = new server_user_info;
	memcpy(m_info, pInfo, sizeof(server_user_info) );
	strcpy( m_network_name, sz_network_name );
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	if( m_info->is_default )
	{
		const char* nick;
		prefs->GetMsg()->FindString("nick", &nick);
 		strcpy( m_info->nick1, nick);
		prefs->GetMsg()->FindString("nick2", &nick);
 		strcpy( m_info->nick2, nick);
		prefs->GetMsg()->FindBool( "active_ident", &m_info->is_ident);				
	}	
	BMessage network_msg;
	if( !prefs->GetMsg()->HasMessage( m_network_name ) )
		prefs->GetMsg()->AddMessage( m_network_name, &network_msg );
	else
		prefs->GetMsg()->FindMessage( m_network_name, &network_msg );
	network_msg.RemoveName("default_server2.4");
	network_msg.AddData("default_server2.4", B_RAW_TYPE, (void*)m_info, sizeof(server_user_info) );
	prefs->GetMsg()->ReplaceMessage( m_network_name, &network_msg );
	
	prefs->Unlock();		
}
void irc::set_socks5_info( const char *sz_socks5_server, short socks5_port, const char *sz_socks5_user, const char* sz_socks5_rassword)
{
	if( !sz_socks5_server )
		return;
	strcpy( m_socks5_server_name, sz_socks5_server);
	m_socks5_port = socks5_port;
	
	m_socks5_rassword[ 0 ] = m_socks5_user_name[0] = '\0';
	
	if( sz_socks5_user && sz_socks5_rassword )
	{
		strcpy( m_socks5_user_name, sz_socks5_user);
		strcpy( m_socks5_rassword, sz_socks5_rassword);
	}	
	m_is_socks5 = true;
}

bool irc::start()
{
	m_is_stop = false;
	resume_thread(m_thread_id);
	return true;
}

int32 irc::net_irc_thread_stub(void *arg)
{
	irc *obj = (irc *)arg;
	obj->net_irc_thread();
	return 0;
}
int32 irc::net_irc_ident_thread(void *arg)
{
	irc *_this = (irc *)arg;
	if ( _this->m_is_socks5 )
	{
		_this->msg_info( "The Ident is not supported while using Firewall (SOCKS5)\n");	
		return 0;
	}
	
	
	struct sockaddr_in sa;
	struct sockaddr_in acc;
	int a = -1, s = -1, len = 0;
	const char* sz_ident_server = NULL;
	const char *sz_ident_name = NULL;
	Prefs *prefs = NULL;
	ms_ident_time = system_time();	
	//struct hostent *host;
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = INADDR_ANY;
	sa.sin_port = htons(113);
	if( m_ident_socket != -1)
		closesocket( m_ident_socket );
	m_ident_socket = -1;
	
		
	s = socket(AF_INET, SOCK_STREAM, 0);
	if( s < 0)
	{
		_this->msg_info( "identd ERROR: socket()\n", true);	
		goto end;
	}	
	if( bind( s, (struct sockaddr *)&sa, sizeof( sa )) < 0  )
	{
		_this->msg_info( "identd ERROR: bind()\n", true);	
		goto end;
	}	
	
	if( listen( s, 1) < 0 )
	{
		_this->msg_info( "identd ERROR: listen()\n", true);	
		goto end;
	}	

	len = sizeof(acc);
	
	prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	
	prefs->GetMsg()->FindString("ident_server", &sz_ident_server );	
  	prefs->GetMsg()->FindString("ident_name", &sz_ident_name );

	prefs->Unlock();
	_this->msg_info( "waiting accept ident connection\n");	

	a = accept( s,  (struct sockaddr *)&acc, (int *)&len);
	
	m_ident_socket = a;
	
	closesocket( s );
	s = -1;

	if( a >= 0 )
	{
		char buf[ 600 ];
		while( 1 )
		{
			if( !_this->readln( buf, a ) )
				break;
			_this->msg_info( buf);
			if( buf[ strlen( buf ) - 1] == '\n')
				buf[ strlen( buf ) - 1] = '\0';
			if( buf[ strlen( buf ) - 1] == '\r' )
				buf[ strlen( buf ) - 1] = '\0';
				
			strcat( buf, " : USERID : ");
			strcat( buf, sz_ident_server );
			strcat( buf, " : ");
			strcat( buf, sz_ident_name );
			strcat( buf, "\r\n" );
			
			_this->writeln( buf, false,  a );
		}	
	}
	else
	{
		_this->msg_info( "identd ERROR: accept()\n", true);	
	}
end:
	if( a >= 0 )closesocket( a );
	if( m_ident_socket != -1)
		closesocket( m_ident_socket );
	m_ident_socket = -1;
			
	if( s >= 0 )closesocket( s );
	_this->msg_info( "finish ident thread\n");	
	_this->m_ident_thread_id = 0;

	ms_ident_time = 0;
	return 0;
}
int32 irc::net_irc_thread(void)
{
	char buff[1024] = {0};
	char buff2[1024] = {0};
	//char buff3[1024] = {0};//fufel
	//*buff3 = 0;
	
	char NonBlocked = 0xff;
	struct fd_set	readfs;
	//bool is_ident_active = false;
	Prefs *prefs = NULL;
	int socket_copy = m_socket;
	FD_ZERO(&readfs);
	struct timeval tv; 
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	
	if( m_is_socks5 )
		msg_info("start using Firewall (SOCKS 5)\n");
	
	
	{
		m_port = 6667;
		strcpy( m_server_name, m_info->server);
		char *pPort = strchr( m_server_name, ':' );
		if( pPort && *(pPort + 1) )
		{
			*pPort = '\0';
			m_port = atoi( pPort + 1);			
		}	
		if( !m_is_socks5 )
			m_addr.sin_port = htons(m_port);
		else
			m_addr.sin_port = htons( m_socks5_port );	
	}
	
	//msg_info("start thread\n");
	msg_info("conect to server: ");
	msg_info(m_server_name);
	msg_info("\n");
	
	
	
	struct hostent *hp;
	m_addr.sin_family = AF_INET;
	if( !m_is_socks5 )
	{
		if( (hp = gethostbyname(m_server_name)) == NULL) 
		{
			msg_info( m_server_name, true);
			msg_info(" ERROR : gethostbyname()\n", true);
			goto end; 
		}
	}
	else // connect to the socks5 server
	{
		if( (hp = gethostbyname(m_socks5_server_name)) == NULL) 
		{
			msg_info( m_socks5_server_name, true );
			msg_info(" ERROR : gethostbyname()\n", true );
			goto end; 
		}

	}	
	memcpy((char*)&m_addr.sin_addr, hp->h_addr, hp->h_length);
	
		
	if((m_socket=socket(AF_INET, SOCK_STREAM, 0)) < 0 ) 
  	{
		msg_info("ERROR : socket()\n", true);
	  goto end;
	}
// start ident_thread
	prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	
	//prefs->GetMsg()->FindBool( "active_ident", &is_ident_active);
	prefs->GetMsg()->FindInt16( "encoding", &encoding);	
	prefs->Unlock();
	if( m_info->is_ident )
	{
		if( ms_ident_time && ( (ms_ident_time + 60000) < system_time()) )
		{
			//closesocket( m_ident_socket );
			//m_ident_socket = -1;
			msg_info( "killing ident thread\n");					
			kill_thread(m_ident_thread_id);
		}	
		else
		{
			msg_info( "wait for ident thread\n");		
			status_t ret;
			wait_for_thread(m_ident_thread_id, &ret);
		}	
		
		m_ident_thread_id = spawn_thread( irc::net_irc_ident_thread, "irc_ident_thread", B_NORMAL_PRIORITY, this);
		msg_info( "start ident thread\n");		
		resume_thread( m_ident_thread_id );
	}	
	
		
	if(connect(m_socket,(struct sockaddr *) &m_addr, sizeof(m_addr))!=0) 
	{
		msg_info( inet_ntoa(*(in_addr*)hp->h_addr), true );
		msg_info(" ERROR : connect()\n", true);		
		goto end;
	}
	if( m_is_socks5 )
		if( !socks5command( m_socket,  SOCKS_CMD_CONNECT, m_server_name, htons(m_port), 
								m_socks5_user_name, m_socks5_rassword ) )
		{
			msg_info( "Socks5 ERROR:" ,true);
			msg_info( socks5error, true );
			msg_info("\n");
			goto end;	
		}
		
	if( setsockopt(m_socket, SOL_SOCKET, SO_NONBLOCK, &NonBlocked, sizeof(NonBlocked)) < 0)
	{
		msg_info("ERROR : setsockopt(...)\n", true);		
		goto end;
	}

	//fcntl(m_socket, F_SETFL, O_TEXT);
	//fcntl(m_socket, F_SETFL, O_NDELAY);
	msg_info("conected\n");
		
	if (!connectclient())
	{
		msg_info("ERROR : connectclient()\n", true);		
		goto end;
	}
	else
	{
		/*BMessage msg('irc');
		msg.AddString("params", "nick\n");
		msg.AddInt16("code", 433);
		m_target->PostMessage(&msg);		 
           //writeln("NICK dipa2\n");      
           */
           char new_nick[64];
           sprintf(new_nick, "NICK %s\n", m_info->nick1);
		strcpy( m_nickname, m_info->nick1 );
		writeln( new_nick );
	}

	
	m_buff_size = 4*1024;
	m_buff = new char[ m_buff_size ];
	
	socket_copy = m_socket;   
	while(1) 
	{
		tv.tv_sec = 1; 
		tv.tv_usec = 0; 

		FD_CLR( socket_copy, &readfs );
		FD_SET( socket_copy, &readfs );
		int ret = -1;		
		
		if( m_socket == -1 )
			break;			
		try
		{
			if( m_is_stop )
				break;
			ret = select( socket_copy + 1, &readfs, NULL, NULL, &tv);	
		}catch( ... ){ break; }

		if( m_socket == -1 )
			break;			

		if(FD_ISSET( socket_copy, &readfs)) 
		{	 
					if( !read2buff() )
						break;
					if( m_is_stop )
						break;

					if( m_buff_tail == 0)
						continue;
						
					char *start_ptr = NULL;	
					for( int j = 0, i = 0; i < m_buff_tail; i++)
					{
						start_ptr = &m_buff[ i ];
						for( j = i; j < m_buff_tail; j++ )
						{
							if( m_buff[ j ] == LF )
							{	
								memset(buff , 0, sizeof(buff) );	
								memcpy( buff, start_ptr, j - i );
								if( buff[ j - i - 1] == CR )
								{
									buff[ j - i - 1] = LF;
    									buff[ j - i ] = 0;
								}
								start_ptr = &m_buff[ j + 1 ];
								int32 iState, u8_len = sizeof( buff ) - 1;
								memset(buff2, 0, sizeof(buff2) );
								//convert_to_utf8(encoding, buff, &u8_len, buff2, &u8_len, &iState);								
								ConvertToUTF8(encoding, buff, &u8_len, buff2, &u8_len, &iState);
								msg_from_srv(buff2);													
								server_spec(buff2);
								
								break;
							}
						}
						i = j;		
					}	
					m_buff_tail = m_buff_tail - (start_ptr - m_buff);
					if( m_buff_tail > 0 ) 
					{
						for( int i = 0; i < m_buff_tail ; i++)
							m_buff[ i ] = start_ptr[ i ];
					}	
					else
					{
						m_buff_tail = 0;
						ASSERT( false );
					}	
		} 		
	}//while 1
end:
	if(m_socket != -1)
		closesocket(m_socket);
	//m_socket = -1;
	//msg_info("exit thread\n");
	BMessage msg('stsp');
	//msg.AddBool("no_continue", true);
	m_target->PostMessage(&msg);		
	return 0;
}

bool irc::connectclient(void)
{ 
	char lhost[64];
	m_lock.Lock();
	gethostname(lhost, 64);
	m_lock.Unlock();
	if( strlen(lhost) < 1 )
		strcpy( lhost, "bardak");
	char sz[512];
	const char *sz_user_info;
	const char *sz_user_name;
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	prefs->GetMsg()->FindString("userinfo", &sz_user_info);
	if( !sz_user_info[0] )
	{
		static char sui[] = "INFO";
		sz_user_info = sui;
	}
	//prefs->GetMsg()->FindString("name", &sz_user_name);
	prefs->GetMsg()->FindString("ident_name", &sz_user_name );	
	if( !sz_user_name[0] )
	{
		static char sun[] = "bardak";
		sz_user_name = sun;
	}
	prefs->Unlock();
	
	sprintf( sz,"USER %s %s %s :%s\n", sz_user_name, lhost, m_server_name , sz_user_info);
  	//msg_from_srv(m_buff);
	if (!writeln ( sz, false))
	{
		msg_info("ERROR : writeln ()", true);
		return false;
	}
  	return true;
}
bool irc::server_spec(const char* buff)
{
	if(d_strncmp( buff, "PING" ) == 0 )
	{
		//char sz_host[64];
		//strcpy(sz_host, &buff[7]); 
		//gethostname( sz_host, sizeof(sz_host) -1);
		char *copy = strdup(buff);
		copy[1] = 'O';
		//sprintf(copy, "PONG :%s", sz_host );
 		writeln(copy, false);
		free(copy);
		return true;
	} /* ping - pong */
	
	return false;
}
bool extract_msg(char *in, char **prefix, char **command, char **params)
{
	char *ptr;
	if ( *in != ':') 
		return false;
	*prefix = in + 1;
	ptr = strchr(*prefix, ' ');
	if (!ptr)
		return false;
	*ptr = '\0';
	*command = ptr + 1;
	ptr = strchr(*command, ' ');
	if(!ptr)
		return false;
	*ptr = '\0';
	*params = ptr+1;
	return true;
}


bool irc::server_msg(char* buff,  BMessage *msg)
{
	char *prefix = NULL;
	char *command = NULL;
	char *params = NULL;
	
	int params_len = 0;
	int prefix_len = 0;
	int command_len = 0;
		
	char *ptr;
	int ret = false;	
	if ( !extract_msg(buff, &prefix, &command, &params))
		return ret;
	
	if ( prefix )
		prefix_len = strlen( prefix );
	if ( 	command )
		command_len = strlen( command ); 
	if ( params )	
		params_len = strlen( params );
	/////// check new nik name
	if( command_len && atoi(command) == 1 && params )
	{
		char *ptr = strchr(params, ' ');
		if(ptr)
		{
			*ptr = '\0';
			strcpy( m_nickname, params);
			*ptr = ' ';
		}	
	}
	/////////////////////////////
	
		
	//*p_msg = params;
	if(!d_strncmp(command, "NOTICE"))
	{
		ptr = strchr(params, '\1');
		if(ptr)
			if(reply_ctcp(command, prefix, ptr))
			  return false;
	}
	else
	if(!d_strncmp(command, "PRIVMSG"))
	{	
		ptr = strchr(params, '\1');
		if(ptr)
			if(reply_ctcp(command, prefix, ptr))
				return false; 
		//ret = true;
	}
	else
	if(!d_strncmp(params, m_nickname) && ( command[0] >= '0' && command[0] <= '9') )
	{
		int nick_len = strlen(m_nickname);
		int16 code = -1;
		if ( params_len >= nick_len)
		{
			ptr = (params + strlen(m_nickname));	
			if(!d_strncmp(ptr, " :"))
				ptr += 2;
			//*p_msg = ptr;
			code = atoi(command);
		}
		msg->AddInt16("code", code);
	
	}
	else
	if(!d_strncmp( command, "433")) //temporary 
	{
		msg->AddInt16("code", 433);		
	
	}
	msg->AddString("command", command);
	msg->AddString("params", params);
	msg->AddString("prefix", prefix);
	ptr = strchr(prefix, '!');
	if (ptr) *ptr = '\0';
	msg->AddString("from", prefix);
	

	return true;
}
/////////// DCC
void irc::dcc(char *command, char *prefix, char *params)
{
	char sz_msg[128];
	//sprintf(sz_msg, "x=%s c=%s p=%s\n", prefix, command,  params );
	
	::dcc *pdcc;
	pdcc = NULL;
	
	char sz_ip[64] = {0};
	char sz_port[32] = {0};
	if( !d_strncmp( params, "CHAT" ) )
	{
		pdcc = new ::dcc(  );
		get_word( params, 2, sz_ip );
		get_word( params, 3, sz_port );
		if( pdcc->init_chat( prefix, sz_ip, sz_port ) )
			msg_info( "start" );
		else
			msg_info( "error" );
		sprintf(sz_msg, " DCC CHAT ip=%s port=%s\n", sz_ip, sz_port );		
		msg_info( sz_msg );
	}
	if( !d_strncmp( params, "SEND" ) )
	{
		pdcc = new ::dcc( );
		char sz_fname[ 128 ] = {0};
		get_word( params, 1, sz_fname );
		get_word( params, 2, sz_ip );
		get_word( params, 3, sz_port );
		char sz_size[64] = {0};
		get_word( params, 4, sz_size );
		if( pdcc->init_send( prefix, sz_fname, sz_ip, sz_port, sz_size) )
			msg_info( "start" );
		else
			msg_info( "error", true );
		sprintf(sz_msg, " DCC FILE %s ip=%s port=%s size=%s\n", sz_fname, sz_ip, sz_port, sz_size );
		msg_info( sz_msg );
	}
	//delete pdcc;
}
/////////// CTCP //////////////////
bool  irc::reply_ctcp(char *command, char *prefix, char *params)
{
		char re_buff[1024];

		char ctcp_cmd[32];
		char data[512];
		bool is_notice = false;
		bool is_command = false;
		params = strchr(params, '\1');
		if(!params)
			return false;
		params++;
		if(!d_strncmp(command, "NOTICE"))
			is_notice = true;
		else
			if(d_strncmp(command, "PRIVMSG"))
				return false;
		char *ptr = strchr(prefix, '!');
		if(!ptr)
			return false;
		*ptr = '\0';
		ptr = strchr(params, '\1');
		if(!ptr)
			ptr = strchr(params, '\n');
		if(!ptr)
			return false;	
		*ptr = '\0';
	char *end_ctcp_cmd = strchr(params, ' ');
		if(end_ctcp_cmd)
			*end_ctcp_cmd = '\0';
  	strcpy(ctcp_cmd, params);
		  	
		if(ptr)
			params = end_ctcp_cmd +1;		
		else
			params = NULL;

		if(is_notice)
		{			
			sprintf(re_buff,"%s %s %s\n", ctcp_cmd, prefix, params);
			if(!strcasecmp(ctcp_cmd, "PING"))
			{
					time_t clock;
					time(&clock);					
					time_t clock_from = atoi(params);
					sprintf(re_buff,"PING %s %li (s)\n", prefix, clock - clock_from);
			}		
			msg_info(re_buff);
			return true;
		}
		else
		{
			if( !d_strncmp( ctcp_cmd, "DCC") )
			{
				dcc( command, prefix, params );
				return true;
			}	

			if(!strcasecmp(ctcp_cmd, "VERSION"))
			{
#if __INTEL__
 				sprintf(data,"Bardak (%s) for BeOS R4 Intel(c)", csz_Version);								
#else
				sprintf(data,"Bardak (%s) for BeOS R4 PowerPC(c)", csz_Version);								
#endif
				is_command = true;
			}
			if(!strcasecmp(ctcp_cmd, "PING"))
			{								
				sprintf(data, "%s", params);				
				is_command = true;
			}
			if(!strcasecmp(ctcp_cmd, "FINGER"))
			{
				sprintf(data,"Finger info unavailable.");
				is_command = true;
			}
			if(!strcasecmp(ctcp_cmd, "SOURCE"))
			{
				sprintf(data,"http://207.16.16.37");
				is_command = true;
			}
			if(!strcasecmp(ctcp_cmd, "CLIENTINFO"))
			{
				sprintf(data,"CLIENTINFO PING USERINFO VERSION SOURCE TIME DCC");
				is_command = true;
			}
			if(!strcasecmp(ctcp_cmd, "USERINFO"))
			{
				Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
				const char* user_info = "INFO";
				prefs->Lock();
				prefs->GetMsg()->FindString("userinfo", &user_info);
				sprintf(data,"%s", user_info);
				prefs->Unlock();
				is_command = true;
			}
			if(!strcasecmp(ctcp_cmd, "TIME"))
			{
				time_t clock;
				time(&clock);					
				tm *sign_on = localtime(&clock);
				strcpy(data, asctime(sign_on));
				sprintf(re_buff,"query CTCP %s from %s\n", ctcp_cmd, prefix);
				msg_info(re_buff);
				sprintf(re_buff, "NOTICE %s :\1TIME %s\n",prefix, data);
				writeln(re_buff, false);				
				return true;
				
				//is_command = true;
			}
			if( !strcasecmp(ctcp_cmd, "ACTION") )
			{
				*end_ctcp_cmd = ' ';
				//sprintf(re_buff,"ACTION prefix = %s, params = %s\n", prefix, params);
				//msg_info(re_buff);
				return false;
			}

			if(is_command)
			{
				sprintf(re_buff,"query CTCP %s from %s\n", ctcp_cmd, prefix);
				msg_info(re_buff);
				
				sprintf(re_buff, "NOTICE %s :\1%s %s\1\n", prefix, ctcp_cmd, data);
				writeln(re_buff, false);				
			}
 	}
	return is_command;
}

void irc::msg_info(const char *info_txt, bool this_error)
{
	BMessage msg('inf');
	msg.AddString("txt", info_txt);
	msg.AddBool( "this_error", this_error);
	m_target->PostMessage(&msg);				
}
void irc::msg_from_srv(char *buff)
{
	BMessage msg('irc');
	char *ptr = buff;
//	char *local_buff = NULL;
	//strcpy(local_buff, buff);
	if(g_debug)
	{
		BMessage dbg_msg('dbg');
		dbg_msg.AddString("debug",ptr);
		g_debug->PostMessage(&dbg_msg);
	}
	//strcpy(local_buff, buff);
	if(d_strncmp( buff, "ERROR " ) == 0 )
	{
		//BMessage msg( 'irc' );
		/*msg.AddInt16( "code", 400 );
		msg.AddString( "command", "ERROR");
		msg.AddString( "params", strchr( buff, ':' ) );
		msg.AddString("from", "");
		m_target->PostMessage(&msg);
		*/
		msg_info(strchr( buff, ':' ) + 1, true);
		msg_info("\n");
		m_is_stop = true;
		closesocket( m_socket );
		m_socket = -1;
		return ;
	}
	/*if(d_strncmp( buff, "NICK " ) == 0 )
	{
		msg.AddInt16( "code", 433 );
		m_target->PostMessage(&msg);
		return;
	}*/
	char local_buff[1024];// = strdup(buff);
	strcpy(local_buff, buff);
	if( !server_msg(local_buff, &msg))
	{
	//	delete local_buff;
		return;
	}
	//delete local_buff;
	//msg.AddString("from_srv", ptr);
	m_target->PostMessage(&msg);				
}
bool irc::prepare_ctcp(const char* sz_in, char* sz_out)
{
	time_t clock;
	time(&clock);
	//tm now = *localtime(&clock);
	char sz_time[64];
	sprintf(sz_time,"%li", clock);
	char sz_target[64];
	char ctcp_cmd[32];
	memset(sz_target, 0, sizeof(sz_target));
	memset(ctcp_cmd, 0, sizeof(ctcp_cmd));
	
	// prepare DCC
 	if( !d_strnicmp( sz_in, "/DCC") )
 	{
 		if(m_is_socks5)
		{
			msg_info( "The DCC is not supported while using Firewall (SOCKS5)\n");	
			return true;
		}
	
 		char w1[32] = { 0 };
 		char w2[64] = { 0 };
 		get_word( sz_in, 1, w1 );
 		if( !strcasecmp( w1, "chat") )
		{
			get_word( sz_in, 2, w2 );
			::dcc *pdcc = new ::dcc(  );
			if( !pdcc->new_chat( w2, m_socket ) )
				delete pdcc;
			return true;
		}
		if( !strcasecmp( w1, "send") )
		{
			char w3[256] = {0};
			get_word( sz_in, 2, w2 );
			get_word( sz_in, 3, w3 );
			::dcc *pdcc = new ::dcc(  );
			if( !pdcc->new_send( w2, w3, m_socket ) )
				delete pdcc;
			return true;
		}
		
  	}
	if( d_strnicmp(sz_in,"/CTCP ") )
		return false;
  	
  	const char *in_ptr = d_skip_chr(&sz_in[5], ' ');
	if(!in_ptr)
		return false; 
	int len = d_len_chr(in_ptr, ' ');
	if(len != 0)
		strncpy(ctcp_cmd, in_ptr, len);
	else
		strcpy(ctcp_cmd, in_ptr);

	char *ptr = d_skip_chr( &in_ptr[strlen(ctcp_cmd)] , ' ');
	if(!ptr) 
			return false;
	sscanf(ptr,"%s",sz_target);

	if(!strcasecmp(ctcp_cmd,"PING"))
	{
		sprintf(sz_out,"PRIVMSG %s :\1PING %s\1\n", sz_target, sz_time);
		return true;
	}
	else
	{
		sprintf(sz_out,"PRIVMSG %s :\1%s\1\n", sz_target, ctcp_cmd);
		return true;
	}
 
 return false;
}
void irc::msg_to_srv(char *buff)
{
	if (!buff)
		return;
	BMessage msg('irc');
	//buff[strlen(buff)] = '\0';

	msg.AddString("to_srv", buff);
	m_target->PostMessage( &msg );				
}
bool irc::writeln( const char *outbuf, bool reflect, int s)
{ 
	if(m_socket == -1 && s == -1)
		return false;
	if(!outbuf)
		return false;
	int32 len = strlen(outbuf);
	if (len<1)
		return false;
	
	int socket_copy = m_socket;
int32 iState = 0;
char* newBuff = new char[len * 4];
int32 len2 = len * 4;
strcpy(newBuff, outbuf);

	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	prefs->GetMsg()->FindInt16( "encoding", &encoding);
	prefs->Unlock();
///*status_t err = */convert_from_utf8( encoding, outbuf, &len, newBuff,&len2,&iState);
/*status_t err = */ConvertFromUTF8( encoding, outbuf, &len, newBuff,&len2,&iState);
	newBuff[len2] = '\0';
	if( newBuff[len2 - 1] != '\n' )
	{
		newBuff[ len2 ] = '\n';
		newBuff[ len2 +1 ] = '\0';
	}
	if(g_debug)
	{
		BMessage dbg_msg('dbg');
		dbg_msg.AddString("debug",newBuff);
		g_debug->PostMessage(&dbg_msg);
	}
	m_lock.Lock();
	int byte_send = strlen(newBuff);

	if( s != -1 )
		send ( s , newBuff, byte_send, 0); 
	 else
	{
		int sended = 0;
		while( 1 )
		{
		
			int ret = send ( socket_copy , &newBuff[ sended ], byte_send, 0);
				
			if( ret == -1 && errno != EWOULDBLOCK)
			{
				delete[] newBuff;
				m_lock.Unlock();
				return false;
			}
			if( ret == byte_send )
				break;
			byte_send -= ret;
			sended += ret;		
		}
	}	
	m_lock.Unlock();
	delete[] newBuff;
	
	if(reflect)
		;//msg_to_srv(outbuf);
	return true;

}	
bool irc::read2buff(void)
{
	//int buff_end = m_buff_tail;
	int sokcet_copy = m_socket;
	int ret = 0;
	while( true )
	{
		m_lock.Lock();
		ret = recv( sokcet_copy , &m_buff[ m_buff_tail ], m_buff_size - m_buff_tail, 0 );
		m_lock.Unlock();

		if( ret <= 0 )
		{
			int error = errno;
			if( error == EWOULDBLOCK)	
				return true;
			/*if( ret == 0 )
				return true;
			*/		
			return false;
		}	
		m_buff_tail += ret;
		if( m_buff_tail == m_buff_size )
		{
			char *ptr = new char[ m_buff_size*2 ];
			memcpy( ptr, m_buff, m_buff_size);
			delete m_buff;
			m_buff = ptr;
			m_buff_size *= 2;
		}
	}
}			

bool irc::readln(char * buff, int s)
{ 
	int i=0;
	char ch;
	m_lock.Lock();
	while(1) 
	{ 
		if( recv( s , &ch, 1, 0 ) < 1 )
		{
			//if(errno != EINTR)
			{	m_lock.Unlock();
				return false;   
			}	
		}
		if(  ch == LF)
		{
			if(buff[ i - 1] == CR)
				i--;
			buff[ i++] = ch;
			buff[ i ] = 0;
			break; 
		}
		if(ch != 0)
			buff[i++]=ch; 
		if( i == 511)
		{
			buff[ i ] = '\0';
			break;
		}
 	}
	m_lock.Unlock();

	int32 iLen2, iLen1, iState=0;
	iLen2 = iLen1=strlen(buff);

	char* newBuff = new char [iLen1 * 4];
	memset(newBuff, 0, iLen1 * 4);
	strcpy( newBuff, buff);
	iLen2 = iLen1 * 4;
	
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	prefs->GetMsg()->FindInt16( "encoding", &encoding);
	prefs->Unlock();
//	convert_to_utf8(encoding, newBuff, &iLen1, buff, &iLen2, &iState);
	ConvertToUTF8(encoding, newBuff, &iLen1, buff, &iLen2, &iState);
	
	delete newBuff;
	
	return true;
}
bool  irc::prepare_cmd(const char* sz_in,  char* sz_out)
{ 
	if(sz_in[0] != '/')
	{
		msg_info( "Accepted command whith \'/\'\n" , true);
		return false;
	}
	if(sz_in[1] == '^')
	{
		sprintf(sz_out,"%s\n", &sz_in[2]);
		return true;
	}
	
	if (!d_strnicmp(sz_in, "/NICK "))
	{
		m_nickname[ 0 ] = '\0';
		if( get_word( sz_in, 1, m_nickname ) == 0)
			return false;
	}
	if( !d_strnicmp(sz_in, "/ME "))
	{
		sprintf( sz_out, "PRIVMSG ");
		get_word( sz_in, 1, sz_out);
		strcat( sz_out, " :\1ACTION ");
		get_string( sz_in, 2, sz_out);
		strcat( sz_out, "\1\n");
		return true;
	}
	if( prepare_def_command( sz_in + 1, sz_out) )
		return true;
	
	
	sprintf( sz_out,"Unknown command:%s\n", sz_in );
	msg_info( sz_out, true );	
	return false;	
}

void irc::MessageReceived(BMessage *msg)
{
	char sz_msg[512];
	memset(sz_msg, 0, sizeof(sz_msg));
	const char* txt;
	switch (msg->what) 
	{
		case 'irc':
		{
			msg->FindString("cmd", &txt);
			bool ret = prepare_ctcp(txt, sz_msg);
			if( !ret )
			{
				ret = prepare_cmd(txt, sz_msg);
			}
			if( ret )
				writeln(sz_msg);
		}
		default: 
		{ //Always handle the defaults
				 BHandler::MessageReceived(msg);
		}break;
	}
}

#include "irc.inc"