#ifndef _IRC_H
#define _IRC_H
//#include <Messenger.h>
#include <Looper.h>
#include <Locker.h>
#include <Handler.h>


#include <socket.h>

#define	CR			'\x0D'
#define	LF			'\x0A'
#define	CRLF		"\x0D\x0A"

struct server_user_info;

class BList;
class irc : public BHandler 
{
public:
	irc(BLooper* target);
	~irc();
//	void 		setup(char *server_name, char* ports);
	void		set_user_info( server_user_info* pInfo, const char *sz_network_name );
	void		set_socks5_info( const char *sz_socks5_server, short socks5_port, const char *sz_socks5_user = NULL, const char* sz_socks5_rassword = NULL);
	const server_user_info* get_user_info(void){ return m_info; }
	bool		start();
	virtual	void	MessageReceived(BMessage *message);
	const char* get_cur_nick(void){	return m_nickname; }
	const char* get_server_name(void){ return m_server_name;}
	const char* get_network_name(void){ return m_network_name; }
private:
	server_user_info				*m_info;

static int32						net_irc_thread_stub(void *arg);
	int32 							net_irc_thread(void);
static int32						net_irc_ident_thread(void *arg);
	//BMessenger			m_target;
static	BLocker 					m_lock;
	BLooper*						m_target;
	sockaddr_in		 			m_addr;
	int 								m_socket;
static int							m_ident_socket;	
	char							m_server_name[128];
	char							m_nickname[32];
	char 							m_network_name[128];
//	char							m_ports[64];
	int								m_port;

	char							*m_buff;
	int								m_buff_size;
	int								m_buff_tail;
	
	thread_id						m_thread_id;
static thread_id					m_ident_thread_id;
static bigtime_t					ms_ident_time;
	int								m_thread_socket;
	
	bool	server_spec(const char* buff);
	void 	msg_from_srv(char *buff);
	void	msg_to_srv(char *buff);
	void	msg_info(const char *info_txt, bool this_error = false);
	bool	prepare_ctcp(const char* sz_in, char* sz_out);
	bool	prepare_cmd(const char* sz_in, char* sz_out);
	bool	prepare_def_command( const char* sz_in, char *sz_out);
	bool	reply_ctcp(char *command, char *prefix, char *params);
	bool	writeln(const char *outbuf, bool reflect = true, int s = -1);
	bool	readln(char * buff, int s = -1);
	bool	read2buff(void);
	bool	connectclient(void);
	void	dcc(char *command, char *prefix, char *params);
	
	bool	server_msg(char* buff, BMessage *msg);
	
	/////////
	void	get_ucmd( void );
	
	BList	*m_ucmd;
	// for stop
	bool	m_is_stop;
	//socks5
	bool	m_is_socks5;
	short	m_socks5_port;
	char	m_socks5_server_name[128];
	char	m_socks5_user_name[ 32 ];
	char	m_socks5_rassword[ 32 ];
	
};

#endif
 