#include "irc_view.h"

#include "constants.h"

#include "textFilter.h"
#include "myText.h"
//#include "Prefs.h"
#include "Utils.h"
#include "irc_txtview.h"
#include <ScrollView.h>
#include <Window.h>
#include <File.h>
#include <stdio.h>

#include "IRCApp.h"
#include "Prefs.h"

#define LH_TXT	30
BBitmap *RetrieveBitmap(const int32 res_id);

IRCView::IRCView(BRect rc)
	: BView(rc, "IRCView", B_FOLLOW_ALL, B_WILL_DRAW | B_NAVIGABLE_JUMP|B_FRAME_EVENTS)
{
	m_log_file = NULL;
	rc = Bounds();
	rc.bottom -= LH_TXT;
	rc.right -= B_V_SCROLL_BAR_WIDTH ;
	//rc.OffsetBy( -2, -2 );
	rc.bottom -= 1;
	//BView *bv = new BView( BRect( rc.left, rc.top, rc.left + 7, rc.bottom ),"fufel", B_FOLLOW_TOP_BOTTOM | B_FOLLOW_LEFT, B_WILL_DRAW);
	//AddChild( bv );
	
	//rc.left += 8;
	BRect rc_txt;
	rc_txt =  rc;
	rc_txt.left += 4;
	BTextView* tv = (BTextView*)new irc_textview(rc, "srv_txt", rc_txt );//BTextView(rc, "srv_txt", rc, B_FOLLOW_ALL, B_WILL_DRAW);
	tv->SetViewColor( irc_color[ irc_event_color[eBkColor] ].color );
	tv->MakeEditable(false);
	tv->MakeSelectable(true);
  	tv->SetMaxBytes(1024*16);
//////////  set font  	
	m_default_font = new BFont;
	const char *font_name;
	Prefs* prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
		prefs->GetMsg()->FindString( "default_font",  &font_name);
		m_default_font->SetFamilyAndStyle( font_name, NULL);
		int16 font_size = 0;
  		prefs->GetMsg()->FindInt16("default_font_size", &font_size );
		m_default_font->SetSize( font_size );
	prefs->Unlock(); 
///////// 
  	
  	
  	//tv->AddFilter(new BMessage('mmg')); 
  	
  	//tv->MakeResizable(true);	
  	BScrollView *sv = new BScrollView("TextScroller",tv,B_FOLLOW_ALL,B_FRAME_EVENTS,false,true,B_NO_BORDER);
  	AddChild(sv);
  	rc.top = rc.bottom;
  	rc.InsetBy( 5, 7 );
  	rc.right += B_V_SCROLL_BAR_WIDTH ;
  	rc.bottom += LH_TXT;
  	textFilter* filter = new textFilter();
  	BTextControl *txt = (BTextControl*)new myText(filter, rc, "message", NULL, NULL, new BMessage('umg'),B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM);
  	txt->SetResizingMode(B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM);
   	txt->TextView()->SetMaxBytes( 511 );
   	AddChild(txt);
 	// txt->SetModificationMessage(new BMessage('mmg'));
  	txt->MakeFocus(true);
  	//window->PostMessage(new BMessage('mmg'));
  	m_is_time_stamp = false;
}
IRCView::~IRCView()
{
	delete m_default_font;
}

//////////////////////////////////////////
void IRCView::FrameResized(float width, float height)
{
   	Window()->Lock();
	BTextView* tv = (BTextView*)FindView("srv_txt");
   	BRect rc = tv->TextRect();
   	rc.right = width - B_V_SCROLL_BAR_WIDTH;
	tv->SetTextRect(rc); 
	Window()->Unlock();
	rc = this->Bounds();
	rc.top = rc.bottom - LH_TXT;
	Invalidate(rc);
	Window()->UpdateIfNeeded();
	//BView::FrameResized( width, height);
}
void IRCView::Draw(BRect updateRect)
{
	//BTextView* tv = (BTextView*)FindView("srv_txt");
	BRect rc = Bounds();
	SetPenSize(1.0);
	//Upper dark gray line.
	rc.top = rc.bottom - LH_TXT;
	//rc.bottom += 2;
	rc.right += B_V_SCROLL_BAR_WIDTH;
	MovePenTo(rc.LeftTop());
	StrokeLine(rc.RightTop(), B_SOLID_LOW);
	rc.top += 1;
	MovePenTo(rc.LeftTop());
	StrokeLine(rc.RightTop(), B_SOLID_HIGH);
}
void IRCView::AttachedToWindow(void)
{
	SETUP_VIEW_COLORS;
	
	BTextControl* txt = (BTextControl*)FindView("message");
	txt->MakeFocus(true);
	
	/*BView *bv = FindView( "fufel" );
	BBitmap *bmp = RetrieveBitmap( 44 );
	if( bmp ) bv->SetViewBitmap(  bmp );
	*/
}
void IRCView::DetachedFromWindow(void) 
{
}
void IRCView::KeyDown(const char *bytes, int32 numBytes)
{
	switch(bytes[0])
	{
	case B_ENTER:
	break;
	}
}

void IRCView::w_print(const char* str, int idx)
{

	if(!str)
		return;
	Window()->Lock();
	
	int32 len_str = strlen (str) + 1;
	if(len_str < 1)
	{
		Window()->Unlock();	
		return;
	}
	irc_textview *txt = (irc_textview*)FindView("srv_txt");
	
	BScrollView *sv = dynamic_cast<BScrollView*>( txt->Parent() );
	if(!sv)
	{
		Window()->Unlock();
		return;
	}

	//Lock();

	BScrollBar *sb = sv->ScrollBar(B_VERTICAL);
	float vl = sb->Value();
	int32 cur_line = int32(vl / (float)txt->LineHeight());
	float mi, mx;
//	int32 s, f;
	sb->GetRange(&mi,&mx);
	bool is_new_line = true;
	int32 len_txt = txt->TextLength();

	const char* csz_text = txt->Text();
	if( len_txt && csz_text[ len_txt - 1 ] != '\n'  )
	{
		is_new_line = false;
	}	
	if( m_is_time_stamp && is_new_line )
		len_str += 8;
	
	int32 dx = (len_txt + len_str) - txt->MaxBytes() ;
	int32 dx_line = 0;
	//txt->GetSelection (&s, &f);
	if(dx > 0)
	{
		int i;   
  		for(i = 0; i < 512; i++)
     			if( txt->ByteAt(i) == '\n' )
     				if ( i >= dx)     				
     				{
     					i++;
     					break;
     				}
     		if( i < 512) dx = i;			
     		dx_line = txt->LineAt(dx);

     		txt->Delete (0, dx);
     	}
	//else dx = 0;
		//txt->Select( 0xffff , 0xffff );
		//txt->GetSelection (&s, &f);
	text_run_array ra;
	ra.count = 1;
	ra.runs[0].offset = 0;
	ra.runs[0].font = m_default_font;
	if( m_is_time_stamp && is_new_line )
	{
		time_t clock;
		time(&clock);	
		tm *time_on = localtime(&clock);
		char sz_time[16];
		sprintf(sz_time, "[%02d:%02d] ", time_on->tm_hour, time_on->tm_min);
		txt->Insert ( txt->TextLength() ,sz_time, 8);
		len_str -= 8;
		ra.runs[0].color = irc_color[ irc_event_color[ eNormal_Txt ] ].color;
		//ra.runs[0].font = be_bold_font;
		txt->SetRunArray( txt->TextLength() - 8,  txt->TextLength() , &ra);
		if(m_log_file)
			m_log_file->Write( sz_time, 8 );
	}	
	//ra.runs[0].font = be_plain_font;
	txt->Insert ( txt->TextLength() , str, len_str - 1);
	ra.runs[0].color = irc_color[ irc_event_color[ idx ] ].color;
	txt->SetRunArray( txt->TextLength() - len_str + 1,  txt->TextLength() , &ra);
	if(m_log_file)
		m_log_file->Write( str, len_str - 1 );

	
	if (vl == mx)
		//sb->SetValue(1e999);
		txt->ScrollToOffset(txt->TextLength());
	else
	{
		vl = txt->LineHeight() * (cur_line - dx_line);

		sb->SetValue(vl);
	}
	//sprintf(s, "val = %f r.bottom = %f (%f,%f)\n", vl, rc.bottom,mi,mx);
	//txt->Insert (f + len_str - 1, s, strlen(s));
	txt->Sync();
	Window()->Unlock();
}

void IRCView::MessageReceived(BMessage* message)
{
  switch (message->what)
  {
	case 'mmg':
	{
		BTextControl* mm = (BTextControl*)FindView("message");
		mm->MakeFocus(true);
	}
		break;
	default:    	
		break;
  }
	BView::MessageReceived(message);
}
