#include <ScrollBar.h>
#include <ListView.h>
#include <Window.h>
#include <Region.h>

#include "list_header.h"
#include "Utils.h"
#include "constants.h"
#include <string.h>
#include <stdio.h>

list_header::list_header( BRect rc, BListView* lv ) 
	: BView(rc, "_list_header_view_", B_FOLLOW_LEFT_RIGHT |  B_FOLLOW_TOP, B_WILL_DRAW /*| B_NAVIGABLE_JUMP*/ | B_FRAME_EVENTS )
	, BMessageFilter(B_ANY_DELIVERY, B_ANY_SOURCE, B_VALUE_CHANGED)
{
	SET_VIEW_COLORS( this );
	m_count = 0;
	m_value = 0.0;
	m_lv = lv;
	SetFont( be_bold_font );
	SetFontSize( 11.5 );
}
list_header::~list_header()
{
	for( int i = 0; i < m_count; i++ )
		delete m_column_names[ i ];
}

void list_header::add_column( const char* name, int width )
{
	m_column_names[ m_count ] = strdup( name );
	m_column_width[ m_count ] = width;
	m_count++;
}

void list_header::Draw( BRect rc )
{
	rc = Bounds();
	//draw_frame( this, rc, false);	
	draw_3Drect( this, rc, false);	
	font_height height;
	GetFontHeight(&height); 
	rgb_color hc = HighColor();
	rc.left -= m_value;
	BRegion reg;
	for( int i = 0; i < m_count; i++ )
	{
		rc.right = rc.left + m_column_width[ i ];
		if( (i + 1) == m_count )
			rc.right = Bounds().right;
		//BRect rc_r = rc;
		//rc_r.left = 0;
		//rc_r.OffsetBy( m_value, 0 );
		reg.Set( rc );
		//reg.Exclude( rc );
		ConstrainClippingRegion( &reg );
		draw_3Drect( this, rc, false);	
		
		MovePenTo( rc.left + 2,  rc.top + height.ascent + height.leading );
		SetDrawingMode(B_OP_MIN);
		
		SetHighColor( 0, 0, 0 ); 
		DrawString( m_column_names[ i ] );
		SetHighColor( hc ); 
		SetDrawingMode (B_OP_COPY); 
		rc.left = rc.right + 1;
		ConstrainClippingRegion( NULL );
	}
	
}
void list_header::MouseDown( BPoint point )
{
	BRect rc = Bounds();
	int i;
	rc.left -= m_value;
	for( i = 0; i < m_count; i++)
	{
		rc.left += m_column_width[ i ] ;
		rc.right = rc.left + 6; 
		if( rc.Contains( point )) 
			goto go;
		
	}	
	return;
	rc.left = point.x;
go:
	BRect rc_v = Bounds();
	unsigned long buttons; 
	do
	{
		snooze( 80 * 1000 ); 
		GetMouse( &point, &buttons );
		int dx = m_column_width[ i ] -  int( rc.left - point.x);
		if( rc.left != point.x && dx >= 8 )
		{
			m_column_width[ i ] -=  int( rc.left - point.x);		
			rc_v.left += m_column_width[ i ];
			//Invalidate( rc_v );
			Invalidate();
			rc_v.left -= m_column_width[ i ];
			m_lv->Invalidate();
			Window()->UpdateIfNeeded();
			rc.left = point.x;
		}	
	} 
	while ( buttons );	
	
}

//#include <be/support/Beep.h>
filter_result list_header::Filter(BMessage *message, BHandler **target)
{
	//B_VALUE_CHANGED
	BScrollBar *sb = dynamic_cast<BScrollBar*>(*target);
	if( sb && message->what == B_VALUE_CHANGED )
	{	int32 v = 0;
		message->FindInt32("value", &v);
		m_value = v;
		Invalidate();
		//beep();
	}	
	
	return B_DISPATCH_MESSAGE;
}
void list_header::MessageReceived(BMessage* message)
{
/*	switch (message->what)
	{
		case B_VALUE_CHANGED:
		//	beep();
		break;
	}
	beep();
*/	BView::MessageReceived(message);
}