#include <Bitmap.h>
#include <PopUpMenu.h>
#include <MenuItem.h>
#include <Region.h>

#include "newButton.h"
#include "irc_util.h"

//#include <TranslationUtils.h> 
//#include <TranslatorFormats.h>

//#include <Bitmap.h>
#include "list_header.h"

#include "Font.h"
#include "constants.h"
#include "Utils.h"
#include "textFilter.h"
#include "myText.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

BBitmap *RetrieveBitmap(const int32 res_id);


newButton::newButton(BRect frame, const char *name, 
         const char *label, 
         BMessage *message, int type, e_aline aline )
   :BButton(frame, name, label, message)
{
  m_bpressed = false; 
  m_bcheck = false;
  m_bclick = false;
  m_type = type;
  m_aline = aline;
  ResizeTo(frame.Width(),frame.Height());
  //SetDrawingMode(B_OP_OVER);
	//BFont font;
	//GetFont(&font);
	BFont font( be_bold_font);
	//font.SetFlags(B_DISABLE_ANTIALIASING);
	SetFont( &font);

}
newButton::~newButton()
{
}
void newButton::Check( bool b)
{
	if ( m_bcheck == b)
		return;
	m_bcheck = b;
	m_bpressed = b;
	Invalidate();
}
void newButton::FirstClick( bool b )
{
	m_bclick = b;
}

void newButton::SetEnabled(bool enabled)
{
	if ( enabled == IsEnabled() ) 
           return; 
    BButton::SetEnabled(enabled);
}
void newButton::Draw(BRect updateRect)
{
	const char *szLabel = Label();
	BRect rc = Bounds();
	if( m_type == 0 )
		draw_frame( this, rc, m_bpressed );
	if( m_type == 1 )
		draw_3Drect(	 this, rc, m_bpressed );
		
	rgb_color high_color = HighColor();
	font_height height; 
	GetFontHeight(&height);
	
	switch( m_aline )
	{
	  	case eCentr:
		{
			rc.left = rc.left + (rc.Width()/2 - StringWidth(szLabel)/2);
		} break;
  	
		case eRight:
		case eLeft:
	  	{
  			rc.left += 2;
  		} break;
	}

	rc.top += (rc.Height()/2) + ( (height.ascent /*+ height.descent + height.leading*/) / 2);
 
	rc.top += m_bpressed;
	rc.left += m_bpressed;
	
	drawing_mode dm = DrawingMode();
	
	if(  m_bpressed  )
	{
		BRect rc2 = Bounds();
		rc2.InsetBy( 1 + (m_type == 0), 1 + (m_type == 0) );
		SetHighColor( 200, 200, 200 );
		FillRect( rc2 );
	}
	SetHighColor( high_color );
	if (IsEnabled())
		;//SetHighColor(0,0,0);
	else
		SetHighColor(128,128,128);
	SetDrawingMode(B_OP_OVER);

	DrawString( szLabel, rc.LeftTop() );
	
	SetHighColor( high_color );
	SetDrawingMode(dm);
}
/*
void newButton::MessageReceived(BMessage* message)
{
  switch (message->what)
  {
    default:
      BView::MessageReceived(message);
    break;
  };
}
*/
void newButton::MouseDown(BPoint point)
{
	unsigned long buttons; 
 	if (!IsEnabled())
 		return;
	if( m_bclick )
	{
		//BButton::MouseDown(point);				
		Window()->PostMessage( Message(), Target());
		return;
	}
 //BRect rect(point, point); 
 BRect rc = Bounds();
 m_bpressed = true;
 Invalidate();
 bool ret = false;
 do
 { 
   snooze(30 * 1000); 
   GetMouse(&point, &buttons);
   ret = rc.Contains(point);
   if( ret && m_bpressed == false)
   {
     m_bpressed = true;
     //Draw(rc);
     Invalidate();
   }
   if(ret == false &&  m_bpressed == true)
   {
     m_bpressed = false;
     //Draw(rc);
     Invalidate();
   }
    
 } while ( buttons );
 
 //
	//BButton::MouseDown(point);
	if( ret )Invoke();
	
	if( m_bpressed && !m_bcheck)
	{ 	
 		m_bpressed = false;
		Invalidate();
	}
	else
		if( m_bcheck )
		{
			m_bpressed = true;
			Invalidate();
		}
}

///////////////// bmp button

/*
bmpButton::bmpButton( BPoint point, const char *name, 
	BBitmap *image1, 
	BBitmap *image2, BMessage *message )
: newButton( BRect( point, point), name, NULL, message)
{
	//m_bpressed = false; 
	m_image1 = image1;
	m_image2 = image2;
	BRect rc = m_image1->Bounds();
	ResizeTo( rc.Width(), rc.Height());
}*/
bmpButton::bmpButton(BPoint point, const char *name, int res_id1, int res_id2, BMessage *message)
: newButton( BRect( point, point), name, NULL, message)
{
	m_image1 = m_image2 = NULL;
	//m_image1 = BTranslationUtils::GetBitmap( B_TGA_FORMAT, res_id1 );
	//m_image2 = BTranslationUtils::GetBitmap( B_TGA_FORMAT, res_id2 );
	m_image1 = RetrieveBitmap( res_id1 );
	m_image2 = RetrieveBitmap( res_id2 );
	if( !m_image1 )
		return;
	BRect rc = m_image1->Bounds();
	ResizeTo( rc.Width(), rc.Height());
	
}
bool bmpButton::ChangeBmp( int res_id1, int res_id2)
{
	BBitmap *image1 = NULL;//BTranslationUtils::GetBitmap( B_TGA_FORMAT, res_id1 );
	BBitmap *image2 = NULL;//BTranslationUtils::GetBitmap( B_TGA_FORMAT, res_id2 );
	image1 = RetrieveBitmap( res_id1 );
	image2 = RetrieveBitmap( res_id2 );

	if( !image1 )
	{
		delete image2;
		return false;
	}	

	if( m_image1 )
		delete m_image1;
	if( m_image2 )
		delete m_image2;
		
	m_image1 = image1;
	m_image2 = image2;
	//BRect rc = m_image1->Bounds();
	//ResizeTo( rc.Width(), rc.Height());
	Invalidate();	
	return true;
}
bmpButton::~bmpButton()
{
	if( m_image1 )
		delete m_image1;
	if( m_image2 )
		delete m_image2;
		
}

void bmpButton::SetEnabled(bool enabled)
{
	if ( enabled == IsEnabled() ) 
           return; 
    BButton::SetEnabled(enabled);
}
void bmpButton::Draw(BRect updateRect)
{
  BRect rc = Bounds();
  //draw_frame(this, rc, m_bpressed);
  BBitmap *bmp;
  
  if( !m_bpressed) 
  	bmp = m_image1;
  else
  	if( m_image2 )
	  	bmp = m_image2;	
	 else
	 {
	 	rc.left++;
	 	rc.top++;
	 	bmp = m_image1; 	
	 }
	if( bmp )
		DrawBitmap( bmp, rc.LeftTop() );
	
	rc = Bounds(); 	
	if( m_type == 0 )
	{
		//draw_frame( this, rc, m_bpressed );
		rgb_color prevH = HighColor();
		rgb_color c1 = { 174, 174, 174 };
		rgb_color c2 = { 64, 64, 64 };
		rgb_color c3 = { 240, 240, 240 };
	
		SetHighColor( c1 );
		StrokeLine( rc.LeftTop(), rc.RightTop(), B_SOLID_HIGH);
		StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_HIGH);
		rc.top++;
		rc.left++;
		SetHighColor( c3 );
		StrokeLine( rc.RightTop(), rc.RightBottom(), B_SOLID_HIGH);
		StrokeLine( rc.LeftBottom(), rc.RightBottom(), B_SOLID_HIGH);
		rc.right--;
		rc.bottom--;
		SetHighColor( c2 );
		StrokeRect( rc, B_SOLID_HIGH);
		
		rc.top++;
		rc.left++;
		rc.right--;
		rc.bottom--;
		SetHighColor( m_bpressed ? c1 : c3 );
		StrokeLine( rc.LeftTop(), rc.RightTop(), B_SOLID_HIGH);
		StrokeLine( rc.LeftTop(), rc.LeftBottom(), B_SOLID_HIGH);
		rc.top++;
		rc.left++;
		if( !m_bpressed )
		{
			SetHighColor( c1 );
			StrokeLine( rc.RightTop(), rc.RightBottom(), B_SOLID_HIGH);
			StrokeLine( rc.LeftBottom(), rc.RightBottom(), B_SOLID_HIGH);
			SetHighColor( prevH  );
		}	
		
	}
	if( m_type == 1 )
		draw_3Drect(	 this, rc, m_bpressed );
		
}
///////////////// color button
ColorButton::ColorButton(BRect frame,  int en_color, BMessage *message)
   :newButton(frame, "_color_button_", "_color_button_", message)
{
	m_selected = m_bpressed = false; 
	m_en_color = en_color;
	ResizeTo(frame.Width(),frame.Height());
	
}
ColorButton::~ColorButton()
{
}
void ColorButton::AttachedToWindow(void)
{
	BView::AttachedToWindow();
	if((unsigned int)m_en_color < (sizeof(irc_color) / sizeof(irc_color[0])) )
 		SetViewColor(irc_color[m_en_color].color);
}
void ColorButton::set_color(int idx)
{
	m_en_color = idx;
	if((unsigned int)m_en_color < (sizeof(irc_color) / sizeof(irc_color[0])) )
 		SetViewColor(irc_color[m_en_color].color);
 	Invalidate();	
}
void ColorButton::Select(bool b)
{
	if( m_selected == b )
		return;
	m_selected = b;
	//Invalidate();
	BRect rc = Bounds();
	rc.left = ( rc.right + rc.left ) / 2 ;
	rc.top = ( rc.top + rc.bottom ) / 2;
	drawing_mode dw = DrawingMode();
	SetDrawingMode( B_OP_INVERT );
	FillEllipse( rc.LeftTop(), 4 , 4 );
	SetDrawingMode( dw );
	
}
void ColorButton::Draw(BRect updateRect)
{
	BRect rc = Bounds();
	
	draw_frame(this, rc, m_bpressed);
	//draw_3Drect(this, rc, m_bpressed);
	if( m_selected  )
	{
		rc.left = ( rc.right + rc.left ) / 2 ;
		rc.top = ( rc.top + rc.bottom ) / 2;
		drawing_mode dw = DrawingMode();
		SetDrawingMode( B_OP_INVERT );
		FillEllipse( rc.LeftTop(), 4 , 4 );
		SetDrawingMode( dw );
	}
}


////////////////////////////////////////////
///////
#define COMBO_BTN	20
newComboBox::newComboBox(BRect frame, char *name, BMessage *msg)
	: BView(frame, name, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE_JUMP|B_FRAME_EVENTS)

{
	m_data_ptr = NULL;
	m_count_items = 0;
	m_bpressed = false;
	m_benable = true;
	m_cmd = msg->what;
	frame = Bounds();
	textFilter* filter = new textFilter(false);
  	BRect rc;
  	rc = frame;
  	rc.right -= COMBO_BTN;
  	rc.left -= 3;  
  	m_txt = //(BTextControl*) new newTextControl(rc, "_n_combo_edit", NULL , NULL, msg);
  		(BTextControl*)new myText(filter, rc, "_n_combo_edit", NULL , NULL, msg);
	((myText*)m_txt)->set_draw(false);
	BTextView* tv = m_txt->TextView();	
	frame = tv->Bounds();
	m_txt->ResizeTo(frame.Width() + 1, frame.Height() + 1);
	tv->MoveTo(1, 1);
	
	m_popup = new BPopUpMenu("_n_combo_menu", false, false );
	
	m_popup->SetFont(be_plain_font);
	m_popup->SetTriggersEnabled(false);
	//m_popup->SetFontSize(10);
	
	frame = m_txt->Bounds();
	frame.bottom += 4;
  	frame.right += COMBO_BTN; 
  	ResizeTo(frame.Width(), frame.Height());
  	m_txt->MoveTo( 2, 2 );
}
newComboBox::~newComboBox()
{
	delete m_popup;
	delete m_data_ptr;
}
void newComboBox::AttachedToWindow(void)
{	
	AddChild(m_txt);

	//m_popup->SetViewColor(225, 200, 200);
	//const rgb_color	viewcolor	= {220, 220, 220};
	//const rgb_color	highcolor	= {234, 234, 234};
	//const rgb_color	lowcolor	= {200, 200, 200};
	BTextView* tv = m_txt->TextView();
	tv->SetViewColor( Parent()->HighColor());
	m_txt->SetViewColor(tv->ViewColor());
	
	
	SetHighColor(Parent()->HighColor());
	SetLowColor(Parent()->LowColor());
	SetViewColor(Parent()->ViewColor());
	//SetHighColor(highcolor);
	//SetLowColor(lowcolor);	  	
	
}

////////////
void newComboBox::Enable(bool b)
{
	if(m_benable == b)
   		return;
   	m_benable = b;
   	BTextView *tv = m_txt->TextView();
   	tv->MakeEditable(b);	
   	//const rgb_color	enable_color	= {220, 220, 220 };
	//const rgb_color	disable_color	= {182, 182, 182 };
	tv->SetViewColor( b ? Parent()->HighColor() : Parent()->LowColor() );//b ? enable_color:  disable_color );//Parent()->LowColor());
	m_txt->SetViewColor( tv->ViewColor() );   	
   	
   	tv->Invalidate();
   	m_txt->Invalidate();
   	Invalidate();
   	Window()->UpdateIfNeeded();
}

//
void newComboBox::AddString(const char *sz_str, const void *ptr, ssize_t size)
{
	BMessage *msg = NULL;
	if( ptr && size)
	{
		msg = new BMessage('cbit');
		msg->AddData("item_data", B_RAW_TYPE, ptr, size );
	}	
	BMenuItem *item = new BMenuItem( sz_str, msg );
	m_popup->AddItem(item);
}
/*void newComboBox::SetString(const char *name)
{
	m_txt->SetText(name);
}
*/

void newComboBox::SetString(const char *name, const void *ptr, ssize_t size)
{
	delete m_data_ptr;
	m_data_ptr = NULL;
	m_txt->SetText(name);
	if( ptr && size)
	{
		m_data_ptr = (void* )new char[ size ];
		memcpy( m_data_ptr, ptr, size);
	}
}

void newComboBox::RemoveAll(void)
{
	int32 count = m_popup->CountItems();
	for( int32 i = 0; i < count; i++)
	{
		delete m_popup->RemoveItem( (int32)0 );
	}
}


void newComboBox::MessageReceived(BMessage* message)
{
  switch (message->what)
  {
    default:
      BView::MessageReceived(message);
    break;
  }
}

void newComboBox::MouseDown(BPoint point)
{
	BMenuItem *selected; 
	//BMessage *copy;
	if (!m_benable)	
		return;
	BRect rc = Bounds(); 
	BPoint pt = rc.LeftBottom();
    
    pt.x += 2; pt.y +=2; 
    ConvertToScreen(&pt);
    BRect	frame = Bounds();
	frame.left = frame.right - COMBO_BTN;
	 
	m_bpressed = true;
	Invalidate(frame);
	//frame.top = frame.left = 0;
	//frame.bottom = frame.right = 9000;
	//frame = Frame();
    	ConvertToScreen(&frame);
	BMenuItem *marked = m_popup->FindItem( m_txt->Text() );
	if(marked)
		marked->SetMarked(true);
	
	selected = m_popup->Go(pt, true,true, frame); 
	if ( selected ) 
	{ 
		marked = m_popup->FindMarked();
		if(marked)
			marked->SetMarked(false);
			
		const char *name = selected->Label();
		//m_txt->SetText(NULL);
		m_txt->SetText(name);
		delete m_data_ptr;
		m_data_ptr = NULL;
		BMessage *msg = selected->Message();
		if( msg )
		{
			ssize_t bytes;
			void *ptr;
 			if( msg->FindData("item_data", B_RAW_TYPE, 0, (const void**)&ptr, &bytes) == B_OK )
 			{
 				m_data_ptr = (void* )new char[ bytes ];
 				memcpy( m_data_ptr, ptr, bytes);
 			}
		}
		//BLooper *looper; 
		//BHandler *target = selected->Target(&looper); 
		//looper->PostMessage(selected->Message(), target); 
		
	} 
	//if(m_bpressed)
	{
		m_bpressed = false;
		ConvertFromScreen(&frame);
		Invalidate(frame);
	}
	BView::MouseDown(pt);
}
void newComboBox::Draw(BRect updateRect)
{
	BRect	frame = Bounds();
	draw_3Drect(this, frame, true);
	frame.InsetBy(1, 1);
	rgb_color color;
	if (m_benable)
	{
		SetHighColor(64,64,64);
	}	
	else
	{
		SetHighColor(128,128,128);
	}	
	color = HighColor();
	StrokeRect(frame, B_SOLID_HIGH);	
	
	
	frame.Set(frame.right - COMBO_BTN + 4, frame.top + 0, frame.right , frame.bottom - 0);
	draw_frame(this, frame, m_bpressed);
	frame.left = (frame.left + frame.right)/2;//  - 4 + m_bpressed;
	
	frame.top = (frame.top + frame.bottom)/2 - 2 + m_bpressed;
	//frame.right = frame.left + 8;
	
	BeginLineArray( 7 );
	AddLine(BPoint( frame.left - 1 , frame.top), BPoint( frame.left + 1, frame.top), color);
	frame.top++;
	AddLine(BPoint( frame.left - 1 , frame.top), BPoint( frame.left + 1, frame.top),  color);
	frame.top++;
	AddLine(BPoint( frame.left - 3 , frame.top), BPoint( frame.left + 3, frame.top), color);
	frame.top++;
	AddLine(BPoint( frame.left - 2 , frame.top), BPoint( frame.left + 2, frame.top), color);
	frame.top++;
	AddLine(BPoint( frame.left - 1 , frame.top), BPoint( frame.left + 1, frame.top), color);
	frame.top++;
	AddLine(BPoint( frame.left - 0 , frame.top), BPoint( frame.left + 0, frame.top - 1), color);
	
	
	
	/*for(int i = 0; i < 5; i++)
	{
		StrokeLine(frame.LeftTop(), frame.RightTop(), B_SOLID_HIGH);
		frame.left++;
		frame.right--;
		frame.top++;		
	}*/
	EndLineArray();
	
}
void newTextControl::Draw(BRect updateRect)
{

}
const void* newComboBox::GetDataPtr(void)
{
	return m_data_ptr;
}
const char*  newComboBox::GetString(void)
{
	return m_txt->Text();
}

//////////////////////////////////////               //////////////////////////
//////////////////

//BBitmap *RetrieveBitmap(const char *name);
static BBitmap *s_op_bmp = NULL;
static BBitmap *s_v_bmp = NULL;
#include "newItem.h"
nickitem::nickitem(const char *name, int type, bool default_font)
{
	m_type = type;
	m_b_default_font = default_font;
	if(name[0] == '@')
	{
		name++;
		m_type = 1;
	}
	if(name[0] == '+')
	{
		name++;
		m_type = 2; //voice 
	}
	strcpy(m_name, name);
	if( !s_op_bmp )
		s_op_bmp = RetrieveBitmap( 3 );//"op.trg_bitmap");
	if( !s_v_bmp )
		s_v_bmp = RetrieveBitmap( 37 );//
}
nickitem::~nickitem()
{
}
void nickitem::rename(const char* str)
{
	BLocker lock;
	lock.Lock();
	if(str[0] == '@')
	{
		str++;
		m_type = 1;
	}
	if(str[0] == '+')
	{
		str++;
		m_type = 2; // + 
	}
	
	strcpy(m_name, str);	
	lock.Unlock();
}
void nickitem::set_type(int type)
{
	m_type = type;
}
void nickitem::DrawItem(BView *owner, BRect itemRect, bool drawEverything) 
{
  	rgb_color color; 
	static const rgb_color	highlight_color = {0};
   	color = owner->ViewColor(); 
   	rgb_color hcolor = owner->HighColor();
   	owner->SetHighColor(color); 
	owner->FillRect(itemRect); 
     //char str[65];
     	//sprintf(str, "%c%s", (m_type) ? '@' : ' ', m_name);
	if( !m_b_default_font )
	{
		BFont font (be_fixed_font) ;
		font.SetFlags(B_DISABLE_ANTIALIASING);
		owner->SetFont(&font);
	}
	else
	{
		BFont font (be_plain_font) ;
		font.SetFlags(B_DISABLE_ANTIALIASING);
		owner->SetFont(&font);
	}
	
	//owner->SetFont( &font );
	font_height height;
	//font.GetHeight( &height );	
     	owner->GetFontHeight(&height);
 
	owner->MovePenTo( 12. , itemRect.top +  height.ascent + height.leading);
	if( m_type == 1 )
		owner->DrawBitmap( s_op_bmp, BPoint( itemRect.left + 1, ((itemRect.bottom + itemRect.top)/2) - 4));
	if( m_type == 2 )
		owner->DrawBitmap( s_v_bmp, BPoint( itemRect.left + 1, ((itemRect.bottom + itemRect.top)/2) - 4));
			
	owner->MovePenTo( 12. , itemRect.top +  height.ascent + height.leading + 1);
	owner->SetHighColor(highlight_color); 
	owner->DrawString( m_name);//str ); 	
   	owner->SetHighColor(hcolor); 
	if (IsSelected()) 
      { 
      	itemRect.right++;
      	draw_3Drect(owner, itemRect, false);
      	owner->SetDrawingMode (B_OP_SUBTRACT);
		owner->SetHighColor (30,30,30);
		owner->FillRect(itemRect);
		owner->SetDrawingMode (B_OP_COPY);
	}	
}
// for sorting int (*compareFunc)(const void *, const void *)
int nick_cmp(const void *u1, const void *u2)
{
   nickitem *user1 = (nickitem*)*((void**)u1);
   nickitem *user2 = (nickitem*)*((void**)u2);
   //int op = user1->get_type
   if( user1->get_type() || user2->get_type() )
   {
   	if(user1->get_type() > user2->get_type() ) return -1;
   	if(user1->get_type() < user2->get_type()) return +1;
   	//return 0;
   }

   //if(user1->voice && !user2->voice) return -1;
   //if(!user1->voice && user2->voice) return +1;
  const char *ptr1 = user1->get_name();  
  const char *ptr2 = user2->get_name();
  return strcmp( ptr1, ptr2);
}


//////////
int chanelItem::m_cmp_type = 0;
chanelItem::chanelItem(const char *name)//, int32 piple, char *topic)
{
	m_name = NULL;
	if(!name)
		return;
	m_name = strdup(name);
	
	//strcpy(m_name, name );
}

chanelItem::~chanelItem()
{
	if(m_name)
		delete m_name;
}
/*void chanelItem::rename(const char* str)
{
	if(m_name)
		delete m_name;
	m_name = strdup(str);
}
*/
void chanelItem::DrawItem(BView *owner, BRect itemRect, bool drawEverything) 
{
  	rgb_color color; 
	rgb_color	highlight_color = {0};
   	color = owner->ViewColor(); 
   	rgb_color hcolor = owner->HighColor();
   	owner->SetHighColor(color); 
	owner->FillRect(itemRect); 
	newListView  *lv = (newListView*)owner;
	list_header *lh = (list_header*) lv->get_prefs();
/*     char *sz = NULL;
     if(m_topic)
     {
		int len = strlen(m_name);
		if(m_topic)
     			len += strlen(m_topic);
		if(m_piple != -1)
     			len += 16;
     		char *sz = new char[ len + 1];     
		sprintf(sz, "%s %li %s", m_name, m_piple, m_topic);
	}
*/	
	BFont font (be_fixed_font) ;
	font.SetFlags(B_DISABLE_ANTIALIASING);
	owner->SetFont(&font);
	
	//owner->SetFont( &font );
	font_height height;
	//font.GetHeight( &height );	
     	owner->GetFontHeight(&height);
 
	owner->MovePenTo( 2. , itemRect.top +  height.ascent + height.leading);
	owner->SetHighColor(highlight_color); 
	BRegion reg;
	if(m_name)
	{
		char sz_channel[ 200 ] = { 0 };
		get_word( m_name, 0, sz_channel );

		reg.Set( BRect( 0, itemRect.top, lh->get_column_width( 0 ), itemRect.bottom) );
		owner->ConstrainClippingRegion( &reg );
		owner->DrawString( sz_channel );
		sz_channel[ 0 ] = '\0';
		get_word( m_name, 1, sz_channel );
		
		int len = lh->get_column_width( 0 );
		reg.Set( BRect( len, itemRect.top, len + lh->get_column_width( 1 ), itemRect.bottom) );
			
		owner->MovePenTo( len + 2 , itemRect.top +  height.ascent + height.leading);
		owner->ConstrainClippingRegion( &reg );
		//owner->StrokeLine( BPoint( len, itemRect.top) , BPoint(len , itemRect.bottom) ,B_SOLID_HIGH );
		//owner->StrokeLine( BPoint( len + 1 , itemRect.top) , BPoint(len + 1 , itemRect.bottom) ,B_SOLID_LOW );
	
		owner->DrawString( sz_channel );

		len += lh->get_column_width( 1 );
		reg.Set( BRect( len, itemRect.top, itemRect.right , itemRect.bottom) );		
		owner->MovePenTo( len + 2 , itemRect.top +  height.ascent + height.leading);
		owner->ConstrainClippingRegion( &reg );
		//owner->StrokeLine( BPoint( len, itemRect.top) , BPoint(len , itemRect.bottom) ,B_SOLID_HIGH );
		//owner->StrokeLine( BPoint( len + 1 , itemRect.top) , BPoint(len + 1 , itemRect.bottom) ,B_SOLID_LOW );

		owner->DrawString( strchr( m_name, ':') + 1 ); 					
	}
   	owner->SetHighColor(hcolor); 
/*	if(sz)
		delete sz;
*/		
     owner->ConstrainClippingRegion( NULL );
     if (IsSelected()) 
      { 
      	itemRect.right++;
      	draw_3Drect(owner, itemRect, false);
	}
	
}
void chanelItem::get_chanel_name( char *str )
{
	if( !str )
		return;
	str[ 0 ] = '\0';
	get_word( m_name, 0, str );
}
int chanelItem::get_chanel_users(void)
{
	char sz_users[ 32 ] = { 0 };
	sz_users[ 0 ] = '\0';
	if( m_name )get_word( m_name, 1, sz_users );
	return atoi( sz_users);
}
const char* chanelItem::get_chanel_topic(void)
{
	if(m_name) 
		return strchr( m_name, ':') + 1;
	else
		return NULL;	
}

int chan_cmp(const void *u1, const void *u2)
{
	chanelItem *user1 = (chanelItem*)*((void**)u1);
	chanelItem *user2 = (chanelItem*)*((void**)u2);
	int type = user1->get_cmp_type();
	const char *ptr1 = NULL; 
	const char *ptr2 = NULL; 
	char sz_user1[ 200 ], sz_user2[ 200 ];

	switch( type )
   	{
   		case 0: 
   		{
   			user1->get_chanel_name( sz_user1 ); 
   			user2->get_chanel_name( sz_user2 );
   			ptr1 = sz_user1;
   			ptr2 = sz_user2;
   		}	
   		break;
   		case 1:
   			{
   				int n1 = user1->get_chanel_users();
   				int n2 = user2->get_chanel_users();
   				return (n1 <= n2);
   			}break;
   		case 2:ptr1 = user1->get_chanel_topic(); ptr2 = user2->get_chanel_topic();
   			break;

   	}
     return strcmp( ptr1, ptr2);
}
///////////////////////// 

newListView::newListView(BRect rc, const char *name,  list_view_type type,  uint32 resizingMode, uint32 flags)
	: BListView(rc, name, type,  resizingMode, flags)
{
}
newListView::~newListView()
{
}
void newListView::KeyDown(const char *bytes, int32 numBytes)
{
	BTextControl* txt = (BTextControl*)(Parent()->Parent()->FindView("message"));
	if( !txt )
		txt = (BTextControl*)(Parent()->Parent()->Parent()->FindView("message"));
	switch(bytes[0])
	{
		case B_ENTER:
		{
			BMessage msg('ntr');
			BMessage *l_target = txt->Message();
			msg.AddPointer("target", (void*)l_target);			
			txt->Window()->PostMessage(&msg);
		}	return;
		case B_DELETE:			
		case B_BACKSPACE:
		case B_UP_ARROW:
		case B_DOWN_ARROW:
		case B_TAB:
		case B_LEFT_ARROW:
		case B_RIGHT_ARROW:
		case B_INSERT:
		case B_HOME:
		case B_END:
		case B_PAGE_DOWN:
		case B_PAGE_UP:
		case B_ESCAPE:
		case B_FUNCTION_KEY:
			return;
	}
	BTextView *tv = txt->TextView();
	txt->MakeFocus(true);
	tv->Select( 0xffff , 0xffff );
	tv->Insert(tv->TextLength(), bytes, numBytes); 
	//txt->KeyDown(bytes, numBytes);
}

void newListView::MouseDown(BPoint point)
{
	unsigned long buttons; 
	GetMouse(&point, &buttons);
	//
	if ( buttons == B_SECONDARY_MOUSE_BUTTON) 
	{
		//int32 selected = CurrentSelection();
		int32 idx = IndexOf( point );
		if( idx >= 0 )
			Select( idx );
		//if(selected == idx )
		{
			BMessage msg ('mdn');
			msg.AddPoint("mouse", point);
			BMessenger messanger(Parent()->Parent());
			messanger.SendMessage( &msg, Parent()->Parent());
			return;
		}
	}	
	BListView::MouseDown(point);
	return;
}




