#ifndef _NEWBUTTON_H
#define  _NEWBUTTON_H

#include <TextControl.h>
#include <Button.h>

class newTextControl : public BTextControl
{
public:
	newTextControl(BRect frame, const char *name, 
         const char *label, const char *text, 
         BMessage *message, 
         uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP, 
         uint32 flags = B_WILL_DRAW | B_NAVIGABLE) : 
         BTextControl(frame, name, label, text, message, resizingMode, flags)
         { }
         
	virtual void Draw(BRect updateRect);	
};
enum e_aline
{
	eLeft,
	eCentr,
	eRight
}; 
class newButton : public BButton
{
public:

	newButton(BRect frame, const char *name, 
		const char *label, 
		BMessage *message, int type = 0, e_aline aline = eCentr );
		//newButton(BMessage *archive):BButton(archive){}
		
	virtual ~newButton();
  	virtual void SetEnabled(bool enabled);
	virtual void Draw(BRect updateRect);	
	virtual void MouseDown(BPoint point);
//	virtual void MessageReceived(BMessage *message);
	virtual void Check( bool b);
	virtual bool IsCheck(void) { return m_bcheck; }
	virtual void FirstClick( bool b );
	void set_type( int t){ m_type = t; }
protected:
	bool 	m_bpressed;
	bool 	m_bcheck;
	bool	m_bclick;
	int		m_type;
	e_aline	m_aline;
}; 


class bmpButton : public newButton
{
public:

	//bmpButton(BPoint point, const char *name, BBitmap *image1, BBitmap *image2, BMessage *message);
	bmpButton(BPoint point, const char *name, int res_id1, int res_id2, BMessage *message);
		
	virtual ~bmpButton();
  	virtual void SetEnabled(bool enabled);
  	virtual bool ChangeBmp( int res_id1, int res_id2);
	virtual void Draw(BRect updateRect);	
	
private:
	BBitmap *m_image1;
	BBitmap *m_image2;
	
}; 


class ColorButton : public newButton
{
public:

	ColorButton(BRect frame,  int en_color, BMessage *message);
		
	virtual ~ColorButton();
	virtual void Draw(BRect updateRect);	
	virtual void AttachedToWindow(void);
	
	void Select(bool b);
	int get_color(void){ return m_en_color; }
	void set_color(int idx);
private:
	int 		m_en_color;
	bool 	m_selected;
}; 
class newComboBox : public BView
{
public:
			newComboBox(BRect frame, char *name, BMessage *msg);
	virtual ~newComboBox();

  	virtual void Draw(BRect updateRect);
	virtual void MessageReceived(BMessage *message);
	virtual void MouseDown(BPoint point);
	virtual void AttachedToWindow(void);
	void 		AddString(const char *sz_str, const void *ptr, ssize_t size);
	const char*	GetString(void);
	const void* 	GetDataPtr(void);
//	void		SetDataPtr(const void *ptr, ssize_t size);
	void 		SetString(const char *name, const void *ptr, ssize_t size);
	void		RemoveAll(void);
	bool		IsEnable(void){ return m_benable; }
	void		Enable(bool b);
protected:
	void*			m_data_ptr;
	uint32			m_cmd;
	BTextControl	*m_txt;
	BPopUpMenu		*m_popup;
	int				m_count_items;
	bool 			m_bpressed;
	bool			m_benable;
};

#endif