#include "irc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <OS.h>
#include <UTF8.h>
//#include <sys/types.h>
#include <ctype.h>
//#include <socket.h>
#include <netdb.h>
//#include <unistd.h>
#include "DebugWindow.h"
#include "IRCApp.h"
#include "Prefs.h"



extern DebugWindow *g_debug;

/*inline*/ int d_strncmp(const char*str1, const char*str2)
{
	int len1 = strlen(str1);
	int len2 = strlen(str2);
	if(len1 < len2)
		return (len1 - len2);
	for(int i = 0; i < len2; i++)
	{
	 	if(str1[i] != str2[i])
			return (i + 1); 
	}
  return 0;

//  return strncmp(str1, str2, strlen(str2));
}
void d_tolower(char *str)
{
	int len = strlen(str);
	for(int i = 0; i < len; i++)
		str[i] = tolower( str[i] );	
}
int d_strnicmp(const char*str1, const char*str2)
{
	int len1 = strlen(str1);
	int len2 = strlen(str2);
	if(len1 < len2)
		return (len1 - len2);
	for(int i = 0; i < len2; i++)
	{
	 	if( toupper(str1[i]) != toupper(str2[i]))
			return (i + 1); 
	}
  return 0;
}

int d_strRncmp(const char*str1, const char*str2)
{
	int len1 = strlen(str1);
	int len2 = strlen(str2);
	if(len1 < len2)
		return (len1 - len2);
	for(int i = len2; i >= 0; i--)
	{
	 	if(str1[len1 - (len2 - i)] != str2[i])
			return (i + 1); 
	}
  return 0;

//  return strncmp(str1, str2, strlen(str2));
}
char* d_skip_chr(const char*str, const char chr)
{
  //int len = strlen(str);
	char *ptr = strchr(str, chr);
	if(!ptr)
		return NULL;
	while ( *ptr )
	{
   	if( *ptr != chr)
			return (ptr);
		ptr++;
  }	
	return ptr;
}
char* d_skipR_chr(const char*str, const char chr)
{
	char *ptr = strrchr(str, chr);
	if(!ptr)
		return NULL;
	while( ptr != str)
	{
    if( *ptr != chr)
			return (ptr);	
		ptr--;
  }
	return ptr;
}
int d_len_chr(const char*str, const char chr)
{
  int len = strlen(str);
	for(int i = 0; i < len; i++)
	  if( str[i] == chr)
			return i;	
	return 0;
}
void d_get_word(const char *str, char* sword)
{
	sscanf(str,"%s", sword);
}
///////////////////////////////////////////////////////////////
////////              IRC             //////////////////////

irc::irc(BLooper* target) : 
	BHandler("irc"), 
	m_target(target)
{
	m_thread_id = spawn_thread(irc::net_irc_thread_stub, "irc_thread", B_NORMAL_PRIORITY, this);
	set_thread_priority(m_thread_id, B_NORMAL_PRIORITY);
	//resume_thread(net_thread_id);
	m_nickname[0] = '\0';
	m_net_end = NULL;	
}
irc::~irc()
{
	msg_info("QUITING...\n");
	if(m_net_end)
	{		
		writeln("QUIT :Bardak Beta 1\n");
		status_t ret;
		wait_for_thread(m_thread_id, &ret);
		//kill_thread(m_thread_id);
		if ( m_net_end ) // it is too strange
		{
			m_net_end->Close();
			delete m_net_end;
		}
	}
	else
		kill_thread(m_thread_id);
	msg_info("READY.\n");
}
void irc::setup(char *server_name,char *username, char* ports)
{
	strcpy(m_server_name, server_name) ;
	strcpy(m_username, username);
	strcpy(m_ports, ports);			
}
bool irc::start()
{
	resume_thread(m_thread_id);
	return true;
}

int32 irc::net_irc_thread_stub(void *arg)
{
	irc *obj = (irc *)arg;
	obj->net_irc_thread();
	return 0;
}
int32 irc::net_irc_thread(void)
{
	char buff[1024] = {0};
	//fd_set	readfs;
	msg_info("start thread\n");
	msg_info("conect to server ...\n");
	unsigned short pport = 0;	
	
	/// new code
	pport = atoi(m_ports);
	BNetAddress net_addr( m_server_name, pport);
	if( net_addr.InitCheck() != B_OK)
		goto end;
	//net_addr.GetAddr(buff, &pport);
	m_net_end = new BNetEndpoint();
	if( m_net_end->InitCheck() != B_OK)
		goto end;
	if ( m_net_end->Connect( net_addr ) != B_OK )
		goto end;
	//m_net_end->SetNonBlocking();
	
	if (!connectclient())
	{
		msg_info("ERROR : connectclient()\n");		
		goto end;
	}
/*	
	////////////
	struct hostent *hp;
	m_addr.sin_family = AF_INET;
	if( (hp = gethostbyname(m_server_name)) == NULL) 
	{
		msg_info("ERROR : gethostbyname()\n");
		goto end; 
	}
	memcpy((char*)&m_addr.sin_addr, hp->h_addr, hp->h_length);
	m_port = atoi(m_ports);
	m_addr.sin_port = htons(m_port);
	if((m_socket=socket(AF_INET, SOCK_STREAM, 0)) < 0 ) 
  	{
		msg_info("ERROR : socket()\n");
	  goto end;
	}
	if(connect(m_socket,(struct sockaddr *) &m_addr, sizeof(m_addr))!=0) 
	{
		msg_info("ERROR : connect()\n");		
		goto end;
	}
	fcntl(m_socket, F_SETFL, O_TEXT);
	//fcntl(m_socket, F_SETFL, O_NDELAY);
	msg_from_srv("conected\n");
		
	if (!connectclient())
	{
		msg_info("ERROR : connectclient()\n");		
		goto end;
	}
	else
*/
	{
		BMessage msg('irc');
		msg.AddString("params", "nick\n");
		msg.AddInt16("code", 433);
		m_target->PostMessage(&msg);		 
    //writeln("")      
	}
	
	while(1) 
	{
		//FD_ZERO(&readfs);
		//FD_SET(m_socket,&readfs);
		//if(select(FD_SETSIZE,&readfs, NULL, NULL, NULL)) 
		{
			//if(FD_ISSET(m_socket,&readfs)) 
			if ( m_net_end->IsDataPending() )
			{	 
				memset(buff , 0, sizeof(buff) );
				if(!readln(buff))
					break;
				msg_from_srv(buff);
				server_spec(buff);
			}
 		}
	}

end:
	if(m_net_end)
		m_net_end->Close();//closesocket(m_socket);
	msg_info("exit thread\n");
	BMessage msg('con');
	msg.AddBool("no_continue", true);
	m_target->PostMessage(&msg);		
	
	// new code
	if ( m_net_end )
		delete	m_net_end;
	m_net_end = NULL;	
	return 0;
}

bool irc::connectclient(void)
{ 
	char lhost[64];
	//gethostname(lhost, 64);
	gethostname(lhost, 64);
	if ( lhost[0] == '\0' )
	{
		msg_info("ERROR : gethostname()\n");
		return false; 
	}
	sprintf (m_buff,"USER %s %s %s :%s\n", m_username, lhost, m_server_name , "INFO");
  	msg_from_srv(m_buff);
	if (!writeln (m_buff, false))
	{
		msg_info("ERROR : writeln ()");
		return false;
	}
 	return true;
}
bool irc::server_spec(const char* buff)
{
	if(d_strncmp(buff,"PING")==0)
	{
		//char sz_host[64];
		//strcpy(sz_host, &buff[7]); 
		//gethostname( sz_host, sizeof(sz_host) -1);
		char *copy = strdup(buff);
		copy[1] = 'O';
		//sprintf(buff, "PONG :%s\n", sz_host );
 		writeln(copy, false);
		free(copy);
		return true;
	} /* ping - pong */
	return false;
}
bool extract_msg(char *in, char **prefix, char **command, char **params)
{
	char *ptr;
	if ( *in != ':')
		return false;
	*prefix = in + 1;
	ptr = strchr(*prefix, ' ');
	if (!ptr)
		return false;
	*ptr = '\0';
	*command = ptr + 1;
	ptr = strchr(*command, ' ');
	if(!ptr)
		return false;
	*ptr = '\0';
	*params = ptr+1;
	return true;
}


bool irc::server_msg(char* buff,  BMessage *msg)
{
	char *prefix = NULL;
	char *command = NULL;
	char *params = NULL;
	
	int params_len = 0;
	int prefix_len = 0;
	int command_len = 0;
		
	char *ptr;
	int ret = false;	
	if ( !extract_msg(buff, &prefix, &command, &params))
		return ret;
	
	if ( prefix )
		prefix_len = strlen( prefix );
	if ( 	command )
		command_len = strlen( command ); 
	if ( params )	
		params_len = strlen( params );
		
	//*p_msg = params;
	if(!d_strncmp(command, "NOTICE"))
	{
		ptr = strchr(params, '\1');
		if(ptr)
			if(reply_ctcp(command, prefix, ptr))
			  return false;
	}
	else
	if(!d_strncmp(command, "PRIVMSG"))
	{	
		ptr = strchr(params, '\1');
		if(ptr)
			if(reply_ctcp(command, prefix, ptr))
				return false; 
		//ret = true;
	}
	else
	if(!d_strncmp(params, m_nickname))
	{
		int nick_len = strlen(m_nickname);
		int16 code = -1;
		if ( params_len >= nick_len)
		{
			ptr = (params + strlen(m_nickname));	
			if(!d_strncmp(ptr, " :"))
				ptr += 2;
			//*p_msg = ptr;
			code = atoi(command);
		}
		msg->AddInt16("code", code);
	}
	msg->AddString("command", command);
	msg->AddString("params", params);
	ptr = strchr(prefix, '!');
	if (ptr) *ptr = '\0';
	msg->AddString("from", prefix);
	
	return true;
}

/////////// CTCP //////////////////
bool  irc::reply_ctcp(char *command, char *prefix, char *params)
{
		char re_buff[1024];

		char ctcp_cmd[32];
		char data[512];
		bool is_notice = false;
		bool is_command = false;
		params = strchr(params, '\1');
		if(!params)
			return false;
		params++;
		if(!d_strncmp(command, "NOTICE"))
			is_notice = true;
		else
			if(d_strncmp(command, "PRIVMSG"))
				return false;
		char *ptr = strchr(prefix, '!');
		if(!ptr)
			return false;
		*ptr = '\0';
		ptr = strchr(params, '\1');
		if(!ptr)
			ptr = strchr(params, '\n');
		if(!ptr)
			return false;	
		*ptr = '\0';
	char *end_ctcp_cmd = strchr(params, ' ');
		if(end_ctcp_cmd)
			*end_ctcp_cmd = '\0';
  	strcpy(ctcp_cmd, params);
		  	
		if(ptr)
			params = end_ctcp_cmd +1;		
		else
			params = NULL;

		if(is_notice)
		{
			sprintf(re_buff,"%s %s %s\n", ctcp_cmd, prefix, params);
			if(!strcmp(ctcp_cmd, "PING"))
			{
					time_t clock;
					time(&clock);					
					time_t clock_from = atoi(params);
					sprintf(re_buff,"PING %s %li (s)\n", prefix, clock - clock_from);
			}		
			msg_info(re_buff);
			return true;
		}
		else
		{
			if(!strcmp(ctcp_cmd, "VERSION"))
			{
				sprintf(data,"VERSION Bardak (v0.1a) for BeOS R4 Intel(c) Dmitry Pavlushko (dipa@altavista.net)");								
				is_command = true;
			}
			if(!strcmp(ctcp_cmd, "PING"))
			{								
				sprintf(data, "%s", params);				
				is_command = true;
			}
			if(!strcmp(ctcp_cmd, "FINGER"))
			{
				sprintf(data,"Finger info unavailable.");
				is_command = true;
			}
			if(!strcmp(ctcp_cmd, "SOURCE"))
			{
				sprintf(data,"http://www.be.com");
				is_command = true;
			}
			if(!strcmp(ctcp_cmd, "CLIENTINFO"))
			{
				sprintf(data,"CLIENTINFO PING USERINFO VERSION SOURCE TIME");
				is_command = true;
			}
			if(!strcmp(ctcp_cmd, "USERINFO"))
			{
				sprintf(data,"%s", m_username);
				is_command = true;
			}
			if(!strcmp(ctcp_cmd, "TIME"))
			{
				time_t clock;
				time(&clock);					
				tm *sign_on = localtime(&clock);
				strcpy(data, asctime(sign_on));
				sprintf(re_buff,"query CTCP %s from %s\n", ctcp_cmd, prefix);
				msg_info(re_buff);
				sprintf(re_buff, "NOTICE %s :\1TIME %s\n",prefix, data);
				writeln(re_buff, false);				
				return true;
				
				//is_command = true;
			}
			if( !strcmp(ctcp_cmd, "ACTION") )
			{
				*end_ctcp_cmd = ' ';
				//sprintf(re_buff,"ACTION prefix = %s, params = %s\n", prefix, params);
				//msg_info(re_buff);
				return false;
			}

			if(is_command)
			{
				sprintf(re_buff,"query CTCP %s from %s\n", ctcp_cmd, prefix);
				msg_info(re_buff);
				
				sprintf(re_buff, "NOTICE %s :\1%s %s\1\n", prefix, ctcp_cmd, data);
				writeln(re_buff, false);				
			}
 	}
	return is_command;
}

void	irc::msg_info(const char *info_txt)
{
	BMessage msg('inf');
	msg.AddString("txt", info_txt);
	m_target->PostMessage(&msg);				
}
void irc::msg_from_srv(char *buff)
{
	BMessage msg('irc');
	char *ptr = buff;
	char *local_buff = strdup(buff);
	//strcpy(local_buff, buff);
	if(g_debug)
	{
		BMessage dbg_msg('dbg');
		dbg_msg.AddString("debug",ptr);
		g_debug->PostMessage(&dbg_msg);
	}
	//strcpy(local_buff, buff);
	if( !server_msg(local_buff, &msg))
	{
		delete local_buff;
		return;
	}
	delete local_buff;
	//msg.AddString("from_srv", ptr);
	m_target->PostMessage(&msg);				
}
bool irc::prepare_ctcp(const char* sz_in, char* sz_out)
{
	time_t clock;
	time(&clock);
	//tm now = *localtime(&clock);
	char sz_time[64];
	sprintf(sz_time,"%li", clock);
	char sz_target[64];
	char ctcp_cmd[32];
	memset(sz_target, 0, sizeof(sz_target));
	memset(ctcp_cmd, 0, sizeof(ctcp_cmd));
	if( d_strnicmp(sz_in,"/CTCP ") )
		return false;
  const char *in_ptr = d_skip_chr(&sz_in[5], ' ');
	if(!in_ptr)
		return false; 
	int len = d_len_chr(in_ptr, ' ');
	if(len != 0)
		strncpy(ctcp_cmd, in_ptr, len);
	else
		strcpy(ctcp_cmd, in_ptr);

	char *ptr = d_skip_chr( &in_ptr[strlen(ctcp_cmd)] , ' ');
	if(!ptr) 
			return false;
	sscanf(ptr,"%s",sz_target);

	if(!strcmp(ctcp_cmd,"PING"))
  {
		sprintf(sz_out,"PRIVMSG %s :\1PING %s\1\n", sz_target, sz_time);
		return true;
  }
	else
	{
		sprintf(sz_out,"PRIVMSG %s :\1%s\1\n", sz_target, ctcp_cmd);
		return true;
	}
 return false;
}
void irc::msg_to_srv(char *buff)
{
	if (!buff)
		return;
	BMessage msg('irc');
	//buff[strlen(buff)] = '\0';

	msg.AddString("to_srv",buff);
	m_target->PostMessage(&msg);				
}
bool irc::writeln(char *outbuf, bool reflect)
{ 
/*	if(m_socket == -1)
		return false;
*/
	if ( m_net_end == NULL)
		return false;
	if(!outbuf)
		return false;
	int32 len = strlen(outbuf);
	if (len<1)
		return false;
	//m_net_buff->Removewhatever();
/*	if (write(m_socket, outbuf, len) < 1)
		return false;
	return true;
*/	
int32 iState = 0;
char* newBuff = new char[len * 4];
int32 len2 = len * 4;
strcpy(newBuff, outbuf);

	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	if( prefs->GetMsg()->HasInt16("encoding") )
	{
		prefs->GetMsg()->FindInt16( "encoding", &encoding);
	}
	prefs->Unlock();
/*status_t err = */convert_from_utf8( encoding, outbuf, &len, newBuff,&len2,&iState);
//newBuff[len2++] = '\r';
newBuff[len2] = '\0';
	if(g_debug)
	{
		BMessage dbg_msg('dbg');
		dbg_msg.AddString("debug",newBuff);
		g_debug->PostMessage(&dbg_msg);
	}

	if (m_net_end->Send( newBuff, strlen(newBuff) )  < 0)
//	if(send(m_socket, newBuff, strlen(newBuff), 0) < 0 )
	{	delete[] newBuff;
		return false;
	}
	delete[] newBuff;
	if(reflect)
		;//msg_to_srv(outbuf);
	return true;

}	
bool irc::readln(char * buff)
{ 
	int i=0;
	char ch;
	/*if ( m_net_end->Receive( (void*)buff, 512 ) < 1 )
	{
		char *ptr = m_net_end->ErrorStr();
		msg_info(ptr);
		msg_info("\n");
		return false;   
	}
	*/	
	while(1) 
	{ 
		//if(recv(m_socket,&ch,1,0)<1)
		if ( m_net_end->Receive( (void*)&ch, 1 ) < 1 )
		{
			char *ptr = m_net_end->ErrorStr();
			msg_info(ptr);
			msg_info("\n");
			return false;   
		}
		if(  ch == LF)
		{
			if(buff[ i - 1] == CR)
				i--;
			buff[ i++] = ch;
			buff[ i ] = 0;
			break; 
		}
		if(ch != 0)
			buff[i++]=ch; 
		if( i == 511)
		{
			buff[ i ] = '\0';
			break;
		}
 	}
	int32 iLen2, iLen1, iState=0;
	iLen2 = iLen1=strlen(buff);
	char* newBuff = strdup( buff );
	Prefs *prefs = ((IRCApp*)be_app)->GetPrefs();
	prefs->Lock();
	int16 encoding = B_MS_WINDOWS_CONVERSION;
	if( prefs->GetMsg()->HasInt16("encoding") )
	{
		prefs->GetMsg()->FindInt16( "encoding", &encoding);
	}
	prefs->Unlock();
	convert_to_utf8(encoding, newBuff, &iLen1, buff, &iLen2, &iState);

delete newBuff;

	return true;
}
bool  irc::prepare_cmd(const char* sz_in, char* sz_out)
{ 
	if(sz_in[0] != '/')
		return false;
	if(sz_in[1] == '^')
	{
		sprintf(sz_out,"%s\n", &sz_in[2]);
		return true;
	}
	char sz[512];
	strcpy(sz, sz_in + 1);
	if (!d_strnicmp(sz, "NICK "))
	{
		sprintf(sz_out,"%s\n",sz);
		char *ptr;
		if (sz[ strlen(sz) ] == ' ')
    		{ 
   			ptr = d_skipR_chr(sz, ' ');
		  	if (ptr) *(ptr + 1) = '\0';
		}
		ptr = d_skip_chr(sz, ' ');
		strcpy(m_nickname, ptr);
	}
	if (!d_strnicmp(sz, "JOIN "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "J "))
	{
		sprintf(sz_out,"JOIN%s\n", sz + 1);
		return true;
	}
	if (!d_strnicmp(sz, "LIST"))
	{
		sprintf(sz_out,"LIST%s\n", sz + 4);
		return true;
	}
	
	if (!d_strnicmp(sz, "WHO "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "WHOIS "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "USERHOST "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "MODE "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "KICK "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "INVITE "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}
	if (!d_strnicmp(sz, "QUIT "))
	{
		sprintf(sz_out,"%s\n",sz);
		return true;
	}

// must be 2 arguments
	char *ptr1 = d_skip_chr(sz + 3, ' ');
	if (!ptr1)
		return false;
	char *ptr2 = strchr(ptr1, ' ');
	if(!ptr2)
		return false;
	*ptr2 = '\0';
	ptr2++;

	if (!d_strnicmp(sz, "MSG "))
		sprintf(sz_out,"PRIVMSG %s :%s\n", ptr1, ptr2);
	if (!d_strnicmp(sz, "PART "))
		sprintf(sz_out,"PART %s :%s\n", ptr1, ptr2);
	if (!d_strnicmp(sz, "TOPIC "))
		sprintf(sz_out,"TOPIC %s :%s\n", ptr1, ptr2);

	return true;
}

void irc::MessageReceived(BMessage *msg)
{
	char sz_msg[512];
	memset(sz_msg, 0, sizeof(sz_msg));
	const char* txt;
	switch (msg->what) 
	{
	case 'irc':
		{
			msg->FindString("cmd", &txt);			
			if(!prepare_ctcp(txt, sz_msg))
				prepare_cmd(txt, sz_msg);
			
			writeln(sz_msg);
		}
		default: 
		{ //Always handle the defaults
				 BHandler::MessageReceived(msg);
		}break;
	}
}