#ifndef _IRC_H
#define _IRC_H
//#include <Messenger.h>
#include <Looper.h>
#include <Handler.h>

//#include <NetKit.h>

#include <NetworkKit.h>

#define	CR			'\x0D'
#define	LF			'\x0A'
#define	CRLF		"\x0D\x0A"
class irc : public BHandler 
{
public:
	irc(BLooper* target);
	~irc();
	void 		setup(char *server_name,  char *username, char* ports);
	bool		start();
	virtual	void	MessageReceived(BMessage *message);
	const char* get_cur_nick(void){ return m_nickname;}
	const char* get_server_name(void){ return m_server_name;}
	
private:
	static int32			net_irc_thread_stub(void *arg);
	int32 					net_irc_thread(void);

	BNetEndpoint			*m_net_end;

	BLooper				*m_target;
	//struct	sockaddr_in 	m_addr;
	//int 						m_socket;
	char					m_server_name[256];
	char					m_nickname[32];
	char					m_username[256];
	char					m_ports[256];
	//int						m_port;

	char					m_buff[600];

	thread_id				m_thread_id;
	int						m_thread_socket;
	
	bool	server_spec(const char* buff);
	void 	msg_from_srv(char *buff);
	void	msg_to_srv(char *buff);
	void	msg_info(const char *info_txt);
	bool	prepare_ctcp(const char* sz_in, char* sz_out);
	bool	prepare_cmd(const char* sz_in, char* sz_out);

	bool	reply_ctcp(char *command, char *prefix, char *params);
	bool	writeln(char *outbuf, bool reflect = true);
	bool	readln(char * buff);
	bool	connectclient(void);

	bool	server_msg(char* buff, BMessage *msg);
};

#endif
 