#include "open_dlg.h"
#include <StorageKit.h>
#include <Window.h>
#include <OS.h>
#include <Application.h>
#include <Button.h>
open_dlg::open_dlg( BWindow *w)
{
	BLooper *lp = new BLooper("open/save looper");
	lp->AddHandler(this);
	lp->Run();
	//lp = w->Looper();
	
	
	m_fPanel = new BFilePanel( B_OPEN_PANEL, new BMessenger( this, lp ),
	NULL, 0, false, NULL, NULL, true, true);
	BMessage *msg = new BMessage('U');
	m_fPanel->SetMessage(msg);
	m_fPanel->SetTarget( this );
}
open_dlg::~open_dlg()
{
	if( m_fPanel )
		delete m_fPanel;
}
bool open_dlg::go()
{
	m_fPanel->Show();
	BLooper *lp = m_fPanel->Window()->Looper();
	thread_id t = lp->Thread();
	status_t tret;
	wait_for_thread( t, &tret );	
	if( m_fPanel )
		delete m_fPanel;
		
	return true;
}

void open_dlg::MessageReceived(BMessage *msg)
{
	switch( msg->what )
	{
		case 'U':
		case B_CANCEL:
		case B_REFS_RECEIVED:
			delete m_fPanel;
			m_fPanel = NULL;
		break;
	}
	BHandler::MessageReceived(msg);
}
///////////////////////////**************************
TDirFilePanel::TDirFilePanel( BMessenger* target, 
                              BRefFilter* filter ) 
  : BFilePanel( B_OPEN_PANEL, target, NULL, 
                B_DIRECTORY_NODE, false, NULL, filter) 
{ 
  BWindow  *w; 

  //  1) Get the window from the FilePanel 
  //     so we can find the window's children 

  w = Window(); 
  if (w->Lock()) 
  { 
    BRect btnrect; 

    //  2) Find the first view in the window, 
    //     and from that view we find the cancel button 

    BView *v = w->ChildAt(0); 
    BView *cancelBtn = v->FindView("cancel button"); 

    if (cancelBtn) { 
      BView *parentview; 
      float charWidth; 

      //  3) Construct and add the new 'Select Current 
      //     Directory' button 

      charWidth  = cancelBtn->StringWidth("Select Current Directory"); 
      btnrect = cancelBtn->Frame(); 
      btnrect.right = btnrect.left - 10; 
      btnrect.left = btnrect.right - charWidth - 40; 
      BInvoker *ic = (BControl*)v->FindView("default button");
      BMessage *msg2 = new BMessage( ic->Message() );
      fCurrentDirBtn = new BButton(btnrect, 
        "current dir button", "Select Current Directory", msg2, B_FOLLOW_RIGHT + B_FOLLOW_BOTTOM); 

      //  4) Set the target for the new button 

      fCurrentDirBtn->SetTarget(*target); 

      parentview = cancelBtn->Parent(); 
      parentview->AddChild(fCurrentDirBtn); 

      //  5) Set the message for the new button 

      entry_ref ref; 
      BMessage *msg = new BMessage('slct'); 
      GetPanelDirectory(&ref); 
      msg->AddRef("refs",&ref); 
      fCurrentDirBtn->SetMessage(msg); 
    } 

    w->Unlock(); 

  } 
} 

void 
TDirFilePanel::SelectionChanged() 
{ 
  BWindow *wind; 

  wind = Window(); 

  if (wind->Lock()) 
  { 
    entry_ref currRef; 

    GetPanelDirectory(&currRef); 

    //  modify the btn's msg 

    BMessage *msg = new BMessage('slct'); 
    msg->AddRef("refs",&currRef); 
    fCurrentDirBtn->SetMessage(msg); 

    wind->Unlock(); 
  } 
} 

bool TDirFilter::Filter(const entry_ref* e, BNode* n, 
                   struct stat* s, const char* mimetype) 
{ 
  if (strcmp("application/x-vnd.Be-directory", 
             mimetype) == 0) 
    return true; 
  else if (strcmp("application/x-vnd.Be-volume", 
                  mimetype) == 0) 
    return true; 
  else 
    return false; 
} 
