#include <InterfaceKit.h>
#include <Application.h>
#include <Resources.h>
#include <BitmapStream.h>

BResources *OpenRes(void)
{
	BFile *file;
	app_info info;
	if(be_app->GetAppInfo(&info)!=B_OK) 
		return NULL;
	file = new BFile(&info.ref, B_READ_ONLY);
	if( file->InitCheck() != B_NO_ERROR) 
	{
		delete file;
		return NULL;
	}
	if( file->InitCheck()!=B_NO_ERROR ) 
	{
		delete file;
		return NULL;
	}	
	BResources *res= new BResources( file );
	
	delete file;
	//return file;
	return res;
}
BBitmap *GetBitmap( BResources *res, int32 idFound, size_t length)
{
	void *data;
	BMessage *mes = NULL;
	BBitmap *bitmap=NULL;
	BArchivable *unarchived = NULL;
	data = new unsigned char [length];
	if(res->ReadResource(B_RAW_TYPE, idFound, data, 0, length)==B_ERROR)
		goto end;
	mes = new BMessage();
	if( mes->Unflatten( (const char*)data ) != B_OK)
		goto end;
	
	unarchived = instantiate_object( mes );
	if( unarchived )
	{
		bitmap = cast_as( unarchived, BBitmap );
	}

end:
	delete data;
	delete mes;
	return bitmap;
}

////////////////////  RetrieveBitmap( )
BBitmap *RetrieveBitmap(const int32 res_id)
{
	size_t length;
	int32 idFound;
	BBitmap *bitmap=NULL;
	
	BResources *res = OpenRes();
	if( !res )
		goto end;
	const char *name;
	if(res->GetResourceInfo(B_RAW_TYPE, res_id, &idFound,  &name, &length)==false) 
		goto end;
	
	bitmap = GetBitmap( res, idFound, length);

end: // fail
	delete res;
	return bitmap;

}

BBitmap *RetrieveBitmap(const char *name)
{
	//BFile *file;
	size_t length;
	int32 idFound;
	BBitmap *bitmap=NULL;
	
	/*file = OpenRes();
	if ( !file )
		return NULL;
	*/	
	BResources *res = OpenRes();
	//res= new BResources(file);
	if( !res )
		goto end;

	if(res->GetResourceInfo(B_RAW_TYPE, name, &idFound, &length)==false) 
		goto end;
	
	bitmap = GetBitmap( res, idFound, length);

end: // fail
//	delete file;
	delete res;
	return bitmap;
}