#include <View.h>
#include <StatusBar.h>
#include "send_recive.h"
#include "newButton.h"
#include <stdio.h>
#include <stdlib.h>
#include "Utils.h"
#include <Bitmap.h>
#include <Mime.h>
#include <Node.h>
#include <File.h>
#include <NodeInfo.h>



SendResiveWindow::SendResiveWindow( BHandler* handler, bool is_recive, const char *fname, long size, const char* app_type) 
	: BWindow(BRect(120, 100, 440, 162), is_recive ? "DCC Reciving" : "DCC Sending", 
        B_TITLED_WINDOW,
        B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS   ) 
{
	m_dcc = handler;
	BRect rc = Bounds(); 
	BView* v = (BView*)new a3DView( rc, "vv", B_FOLLOW_ALL, B_WILL_DRAW);
	v->SetViewColor(225, 225, 225);
	AddChild( v );  
	
		BBitmap *icon = new BBitmap( BRect(0, 0, B_LARGE_ICON - 1, B_LARGE_ICON - 1), 
					B_CMAP8);

	if( is_recive )
	{
		while( 1 ) 
		{
			BMimeType mime_type( (app_type ? app_type : "application/octet-stream") );
			if( mime_type.InitCheck() != B_OK )
			{
				//status_t ret = BMimeType::IsValid( app_type );
				if( app_type == NULL)
					break;
				app_type = NULL;
				continue;	
			}
			if( mime_type.GetIcon( icon, B_LARGE_ICON  ) == B_OK) 
			{
				
				BRect ic_rc( 6, 10, 0, 0 );
				ic_rc.right = ic_rc.left + 32;
				ic_rc.bottom = ic_rc.top + 32;
				IconView *iv = new IconView( ic_rc, "icon", icon );
				v->AddChild( iv );
				break;
			}	
			else
			{
				if( app_type == NULL)
					break;
				app_type = NULL;	
			}	
		}		
	}
	else
	{
		BFile file(fname, B_READ_ONLY);
		BNodeInfo node_info( (BNode*)&file );	
		if( node_info.InitCheck() == B_OK && node_info.GetTrackerIcon( icon, B_LARGE_ICON  ) == B_OK) 
		{
			BRect ic_rc( 6, 10, 0, 0 );
			ic_rc.right = ic_rc.left + 32;
			ic_rc.bottom = ic_rc.top + 32;
			IconView *iv = new IconView( ic_rc, "icon", icon );
			v->AddChild( iv );
		}	
	}
	rc.left += 40;
	rc.bottom -= 30;
	rc.InsetBy( 4, 0);
	rc.top = rc.bottom - 24;
	//rc.right -= 50;
	char sz_label[ 256 ];
	char sz_t [ 128 ];
	sprintf( sz_label, "File: %s", fname);
	sprintf( sz_t, "[0.0/%.1f]Kb", (float)size/1024. );

	BStatusBar *sb = new BStatusBar( rc, "progress", sz_label);
	sb->SetTrailingText( sz_t );
	sb->SetBarHeight( 14 );
	sb->SetMaxValue( size );
	v->AddChild( sb  );
	
	rc = Bounds();
	rc.left = rc.right - 50;
	rc.right -= 6;
	rc.bottom -= 4;
	rc.top = rc.bottom - 18;
	BButton *btn = (BButton*) new newButton(rc, "Stop", "Stop", new BMessage('qdcc') ); 
	v->AddChild( btn  );
	btn->SetTarget( this ); 
	
		
		
	
	Show();
}
SendResiveWindow::~SendResiveWindow() 
{
}
void SendResiveWindow::SetIcon( const char* app_type )
{
}
void SendResiveWindow::Quit()
{
	Lock();
	
	if(m_dcc)
	{
		delete m_dcc;
	}	
	m_dcc = NULL;
	BWindow::Quit();
	Unlock();
	
}

void SendResiveWindow::MessageReceived(BMessage* message)
{
 	switch(message->what)
	{
		case 'qdcc':
		{			
			Quit();
		}break;
		
		case 'inc':
		{
			BStatusBar *sb = (BStatusBar*)FindView( "progress" );
			int32 len = 0;
			message->FindInt32( "len", &len );
			char sz_t[ 128 ];
			sprintf( sz_t, "[%.1f/%.1f]Kb", (float)len/1024., sb->MaxValue()/1024 );
			sb->SetTrailingText( sz_t );
			sb->Update( (float)len - sb->CurrentValue() );
		}break;	
	}
   BWindow::MessageReceived(message);
}
