#include "textFilter.h"
#include "TextView.h"
#include <string.h>
#include <Window.h>
#include <Control.h>

textFilter::textFilter(bool is_list)
		: BMessageFilter(B_ANY_DELIVERY, B_ANY_SOURCE, B_KEY_DOWN, NULL)
{
	m_cur_pos = -1;
	m_is_list = is_list;
}
textFilter::~textFilter()
{
   void *anItem; 
   for ( int i = 0; (anItem = m_list.ItemAt(i)); i++ ) 
       delete anItem; 
}
filter_result textFilter::Filter(BMessage *message, BHandler **target)
{
	int32 mods;

	// Let the control handle all meta keys
	if (!message->FindInt32("modifiers", &mods) && (mods & B_COMMAND_KEY))
		return B_DISPATCH_MESSAGE;
	

	// message->what == B_KEY_DOWN
	int8 byte;
	message->FindInt8("byte", &byte);
	BTextView* tv = (BTextView*)*target;
	switch(byte)
	{
/*		case B_DELETE:
			return B_SKIP_MESSAGE;
		case B_BACKSPACE:
			return B_DISPATCH_MESSAGE;
*/
		case B_ENTER:
		{
			//if( m_cur_pos != -1)
			//	m_list.RemoveItem(m_cur_pos);
			const char* text = tv->Text();
			if( !text )
				return B_SKIP_MESSAGE;
			if(m_is_list)
			{
				char *str = new char[ strlen( text ) + 1 ];
				strcpy( str, text);
				m_list.AddItem(str);
				m_cur_pos = -1;//m_list.CountItems();
			}
			BMessage msg('ntr');
			BMessage *l_target = ((BControl*)tv->Parent())->Message();
			msg.AddPointer("target", (void*)l_target);			
			tv->Window()->PostMessage(&msg);
		}	return B_SKIP_MESSAGE;//B_DISPATCH_MESSAGE;
		case B_UP_ARROW:
		case B_DOWN_ARROW:
		if(m_is_list)
		{
			char *str = NULL;
			if( byte == B_UP_ARROW)
			{
				if( m_cur_pos == -1)
				{
					str = (char*) m_list.LastItem();
					m_cur_pos = m_list.IndexOf( (void*)str );
				}
				else
				{
					m_cur_pos--;
					str = (char*)m_list.ItemAt(m_cur_pos);
					if( !str)
					{
						m_cur_pos++;
						str = (char*)m_list.ItemAt(m_cur_pos);
					}
				}
			}
			else
			{
				if( m_cur_pos != -1)
				{
					m_cur_pos++;
					str = (char*)m_list.ItemAt(m_cur_pos);				
					if( !str)
					{
						m_cur_pos= -1;
					//str = (char*)m_list.ItemAt(m_cur_pos);
					}
				}
			}
			tv->SetText(str);
			if( !str )
				return B_SKIP_MESSAGE;
			if( str[0] == '/' )
				return B_SKIP_MESSAGE;
			char* ptr = strchr(str, ' ');
			if(ptr)
			{
				*ptr = '\0';
				int strt = strlen(str) + 1;
				*ptr = ' ';
				int finish = strlen(str);
				tv->Select(strt, finish);
			}
		}
		return B_SKIP_MESSAGE;
		case B_TAB:
			//*target = ((BView *)*target)->Parent(); // send it to the parent bview so you
													// can navigate
			return B_DISPATCH_MESSAGE;
	default:
		return B_DISPATCH_MESSAGE;
	}
}

