#include "tips.h"
#include <View.h>
#include <Window.h>
#include <Application.h>
#include <Screen.h>
#include <Font.h>
#include <SupportDefs.h>
#include <Control.h>
#include <string.h>
//#include <List.h>
#include <Region.h>

#define kHOR_MARGIN					  4		// hor. gap between frame and tip
#define kVER_MARGIN					  3		// ver. gap between frame and tip
#define kTIP_HOR_OFFSET				 -5		// tip position right of cursor
#define kTIP_VER_OFFSET				 15		// tip position below cursor
#define kSLOP						  4		// mouse slop before tip hides

#define kTOOL_TIP_DELAY_TIME	 500000		// default delay time before tip shows (.5 secs.)
#define kTOOL_TIP_HOLD_TIME		3000000		// default hold time of time (3 secs.)

#define kDRAW_WINDOW_FRAME

const rgb_color kVIEW_COLOR	= {240, 240, 10, 255};	// view background color (light yellow)
const rgb_color kLIGHT_VIEW_COLOR = {255, 255, 80, 255}; // top left frame highlight
const rgb_color kDARK_VIEW_COLOR = {175, 123, 0, 255}; // bottom right frame highlight
const rgb_color kTEXT_COLOR = {0, 0, 0, 255};		// text color (black)



tips_server::tips_server(void)
{
	m_stop = false;
	m_window = new TipWindow();
	// start tool_tip thread
	while(!be_app_messenger.IsValid())
		snooze(200000);

	resume_thread(m_thread = spawn_thread( tips_server::thread,
				"tt_server", B_NORMAL_PRIORITY, this));
}
tips_server::~tips_server(void)
{
	status_t	status;
	
	m_stop = true;
	m_window->Quit();
	
	wait_for_thread( m_thread, &status);
	
}
status_t tips_server::thread(void* ptr)
{
	tips_server* _this = (tips_server*)ptr;
	_this->sercher();
	return 0;
}
void tips_server::sercher(void)
{
	BPoint	pt;
	BView *my_v;
	bigtime_t t_start = 0;
	bigtime_t delay = 500000;
	//bigtime_t delay2 = 5000000;
	while( !m_stop || !be_app_messenger.IsValid() )
	{
		if( !m_window->get_mouse( &pt ) )
		{
			t_start = 0;
			goto end;
		}	
		my_v = m_window->my_view();
		if( my_v )
		{
			BWindow *my_w = my_v->Window();
			if( !my_w->IsLocked() && my_w->Lock()  ) 
			{
				BRect rc = my_v->Bounds();
				my_v->ConvertToScreen(&rc);
				my_w->Unlock();
				if( !rc.Contains( pt ))
				{
					m_window->stop();
					t_start = 0;
					goto end;
				}	
				else
				{
					if ((t_start + (delay * 10)) < system_time() )
					{
						if( !m_window->IsHidden() )
							m_window->Hide();
						goto end;
					}
					m_window->get_mouse( &pt );
					m_window->start( my_v, &pt );
					goto end;					
				}
			}						
		}
		m_window->get_mouse( &pt );
		if( m_window->is_stoped() )
		{
			BView *v;
					v = find_view( pt );
					//w->Unlock();
					if( v && is_kind_of( v, BInvoker) )
					{
						if( t_start && system_time() >= t_start )
						{
							m_window->get_mouse( &pt );
							m_window->start( v, &pt );
							t_start = system_time();
							//break;
						}
						if( !t_start )t_start = system_time() + delay;
						goto end;	
					}else t_start = 0;	
		}else t_start = 0;			
		/*if( m_window->is_stoped() )
		{
			int32 count = be_app->CountWindows();
			
			for( int32 i = 0; i < count; i++ )
			{
				BWindow *w = be_app->WindowAt( i );				
				if( !w ) continue;
				if( w == static_cast<BWindow*>(m_window) )
					continue;
				if( !w->IsActive() ) continue;
				w->Lock();			
				int32 count_v = w->CountChildren();
				w->Unlock();
				for( int32 j = 0; j < count_v; j++)
				{
					BView *v;
					w->Lock();			
					 v = w->ChildAt( j );
					w->Unlock();			 
					if( !v ) continue;
					
					w->Lock();
					v->ConvertFromScreen( &pt );
					v->ConvertToParent( &pt );
					v = w->FindView( pt );
					w->Unlock();
					if( v && is_kind_of( v, BInvoker) )
					{
						if( t_start && system_time() >= t_start )
						{
							m_window->get_mouse( &pt );
							m_window->start( v, &pt );
							t_start = system_time();
							//break;
						}
						if( !t_start )t_start = system_time() + delay;
						goto end;	
					}					
				}
			}*/
					
																		
		
end:	snooze(50000);
	}
}

BView *tips_server::find_view(BPoint where)
{
    BView *winview=NULL;
    BWindow *win;
    long windex=0;
    
    while( 1 ) //(winview==NULL) )//&&((win=be_app->WindowAt(windex++))!=NULL))
    {
		//be_app->Lock();
		win=be_app->WindowAt(windex++);
		//be_app->Unlock();
		if(  win == NULL || winview != NULL )
			break;
			
        if( win != m_window )//&& win->LockWithTimeout(1E6)==B_OK && win->IsActive() )
        {
            // lock with timeout, in case somebody has a non-running window around
            // in their app.
            if( !win->IsLocked() && win->LockWithTimeout(1E6)==B_OK )
            {
                BRect frame=win->Frame();
                if(frame.Contains(where))
                {
                    BPoint winpoint;
                    winpoint=where-frame.LeftTop();
                    winview=win->FindView(winpoint);
                    if(winview)
                    {
                        BRegion region;
                        BPoint newpoint=where;
                        winview->ConvertFromScreen(&newpoint);
                        winview->GetClippingRegion(&region);
                        if( !region.Contains(newpoint) )
                            winview = NULL;
                    }
                }
                win->Unlock();
            }
        }
    }
	return winview;
}
///////////////////////// Window
TipWindow::TipWindow(void)
	   :BWindow(BRect(0, 0, 1, 1), "w_tip", B_NO_BORDER_WINDOW_LOOK,
	   			B_FLOATING_ALL_WINDOW_FEEL, B_AVOID_FRONT | B_NO_WORKSPACE_ACTIVATION)//B_ALL_WORKSPACES)
{
	m_my_view = NULL;
	AddChild( m_view = new TipView() );
	SetSizeLimits( 1.0, 1024, 1.0, 30);
	m_stoped = true;

	Run();
}

bool TipWindow::get_mouse( BPoint *pt)
{
	 	if( !be_app_messenger.IsValid() )
	 		return false;
	 	uint32	buttons; 
	 	Lock();
	 	m_view->GetMouse(pt, &buttons, false);
	 	m_view->ConvertToScreen(pt);
	 	Unlock();
	 	if( buttons )
	 	{
	 		stop();
	 		return false;
	 	}	
	 	return true;
}
void TipWindow::start( BView *v, BPoint *pt )
{
	if(  v != m_my_view)
	{		
		BInvoker *in = dynamic_cast<BInvoker*>(v);
		BMessage *msg = in->Message();
		if( !msg ) return;
		if( !msg->HasString( STR_TTIPS ))
			return;
		const char *s;
		msg->FindString(STR_TTIPS, &s);
		m_view->set_string( s );			
		m_view->AdjustWindow( pt );
		BRect rc = Bounds();
		Lock();
		float h = 1.0;
		ResizeTo( rc.Width(), h);
		Show();
		Activate(false);
		Unlock();
		Sync();
		Flush();
		h += 1.0;
		for( float i = h; i < rc.Height(); i += 1.0)
		{
			snooze(2000);// - i * 3000);
			Lock();
			ResizeTo( rc.Width(), i);
			m_view->Invalidate(m_view->Bounds());
			m_view->Flush();
			//m_view->Sync();
			Unlock();
			Flush();					
		}	
		
		//Unlock();
		m_my_view = v;
	}
	else
	{
		BPoint pt2(0, 0);
		Lock();
		m_view->ConvertToScreen( &pt2 );
		Unlock();
		double distance = sqrt( ((pt->x - pt2.x)*(pt->x - pt2.x)) + 
								((pt->y - pt2.y)*(pt->y - pt2.y)) );
		
		if( distance > 50 )
			m_view->AdjustWindow( pt );							
		
	}	
	m_stoped = false;
}
void TipWindow::stop( void )
{
	if( !IsHidden())
		Hide();
	m_my_view = NULL;
	m_stoped = true;
}

////////////////  View 
TipView::TipView( void )
			 :BView(BRect(0, 0, 10, 10), "tool_tip", B_FOLLOW_ALL, B_WILL_DRAW)
{
	// initialize the tip
	m_String = new char[32];
	strcpy( m_String, "tool_tips");
	// initialize the view
	SetFont( be_plain_font );
	SetViewColor(kVIEW_COLOR);
}


TipView::~TipView(void)
{
	delete m_String;
}


void TipView::AllAttached()
{
}

void TipView::set_string(const char* str)
{
	delete m_String;
	m_String = strdup(str);
}
void TipView::Draw(BRect /* where */)
{
	//char		*src_strings[1];
	//char		*tmp_string;
	//char		*truncated_strings[1];
	BFont		font;
	BRect		r = Bounds();
	font_height	finfo;

	// draw border around window
#ifdef kDRAW_WINDOW_FRAME
	SetHighColor(0, 0, 0, 255);
	StrokeRect(r);
	r.InsetBy(1, 1);
#endif
/*	SetHighColor(kLIGHT_VIEW_COLOR);
	StrokeLine(BPoint(r.left, r.bottom), BPoint(r.left, r.top));
	StrokeLine(BPoint(r.left + 1, r.top), BPoint(r.right - 1, r.top));
	SetHighColor(kDARK_VIEW_COLOR);
	StrokeLine(BPoint(r.right, r.top), BPoint(r.right, r.bottom));
	StrokeLine(BPoint(r.right - 1, r.bottom), BPoint(r.left + 1, r.bottom));
*/	
	// set pen position
	GetFont(&font);
	font.GetHeight(&finfo);
	MovePenTo(kHOR_MARGIN + 1, kVER_MARGIN + finfo.ascent);

	// truncate string if needed
	/*src_strings[0] = m_String;
	tmp_string = new char[ strlen(m_String) + 16];
	truncated_strings[0] = tmp_string;
	font.GetTruncatedStrings((const char **)src_strings, 1, B_TRUNCATE_END,
		Bounds().Width() - (2 * kHOR_MARGIN) + 1, truncated_strings);
	*/
	// draw string
	SetLowColor(kVIEW_COLOR);
	SetHighColor(kTEXT_COLOR);
	//DrawString(tmp_string);
	//delete tmp_string;
	DrawString(m_String);
}
void TipView::MouseMoved( BPoint where,	uint32 code,
									const BMessage *a_message)
{
	if( code == B_INSIDE_VIEW)
	{
		TipWindow* tw = (TipWindow*)Window();
		tw->Lock();
		tw->stop();
		tw->Unlock();
		
	}			
}
void TipView::MouseDown(BPoint point)
{
	TipWindow* tw = (TipWindow*)Window();
	tw->Lock();
	tw->stop();
	tw->Unlock();
}


void TipView::AdjustWindow( BPoint *pt)
{
	float		width;
	float		height;
	float		x;
	float		y;
	BScreen		s(B_MAIN_SCREEN_ID);
	BRect		screen = s.Frame();
	BWindow		*wind = Window();
	font_height	finfo;

	screen.InsetBy(2, 2);	// we want a 2-pixel clearance
	BFont font;
	GetFont( &font );
	font.GetHeight(&finfo);
	width = font.StringWidth(m_String) + (kHOR_MARGIN * 2);  // string width
	height = (finfo.ascent + finfo.descent + finfo.leading) + (kVER_MARGIN * 2);  // string height

	// calculate new position and size of window
	int start_x = (int)pt->x;
	int start_y = (int)pt->y;
	
	x = start_x + kTIP_HOR_OFFSET;
	if ((x + width) > screen.right)
		x = screen.right - width;
	y = start_y + kTIP_VER_OFFSET;
	if ((y + height) > screen.bottom)
	{
		y = screen.bottom - height;
		if ((start_y >= (y - kSLOP)) && (start_y <= (y + height)))
			y = start_y - kTIP_VER_OFFSET - height;
	}
	if (x < screen.left) 
	{
		width -= screen.left - x;
		x = screen.left;
	}
	if (y < screen.top) 
	{
		height -= screen.top - y;
		y = screen.top;
	}
	wind->Lock();
	wind->MoveTo((int)x, (int)y);
	wind->ResizeTo((int)width, (int)height);
		// force an update
	Invalidate(Bounds());
	wind->Unlock();
	//wind->UpdateIfNeeded();
}


